CREATE OR REPLACE PACKAGE BODY sjs."IBR_EDITS"
    as

CURSOR ADMIN_CURSOR (v_agency_in VARCHAR2) is
 Select * from ibr_admin_segment
   where row_status is null
   and ori_number = v_agency_in
   for update;
v_admin_rec  ADMIN_CURSOR%rowtype;

CURSOR OFFENSE_CURSOR (v_agency_in VARCHAR2) is
 Select * from ibr_offense_segment
   where row_status is null
   and ori_number = v_agency_in
   for update;
v_offense_rec OFFENSE_CURSOR%rowtype;

CURSOR PROPERTY_CURSOR (v_agency_in VARCHAR2) is
 Select * from ibr_property_segment
   where row_status is null
   and ori_number = v_agency_in
   for update;
v_prop_rec PROPERTY_CURSOR%rowtype;

CURSOR OFFENDER_CURSOR (v_agency_in VARCHAR2) is
 Select * from ibr_offender_segment
  where row_status is null
   and ori_number = v_agency_in
   for update;
v_offender_rec OFFENDER_CURSOR%rowtype;

CURSOR VICTIM_CURSOR (v_agency_in VARCHAR2) is
 Select * from ibr_victim_segment
  where row_status is null
   and ori_number = v_agency_in
   for update;
v_victim_rec  VICTIM_CURSOR%rowtype;

CURSOR ARRESTEE_CURSOR (v_agency_in VARCHAR2) is
 Select * from ibr_arrestee_segment
  where row_status is null
   and ori_number = v_agency_in
   for update;
v_arrestee_rec  ARRESTEE_CURSOR%rowtype;

CURSOR ARREST_CURSOR (v_agency_in VARCHAR2) is
 Select * from ibr_arrest_charge_segment
  where row_status is null
   and ori_number = v_agency_in
   for update;
v_arrest_rec  ARREST_CURSOR%rowtype;

/* Error Rtn */
procedure update_row_status(v_table in number, v_i_number in varchar2,  v_error_code in number,v_agcy_ori VARCHAR2) is

v_message  ibr_error_message_lookup.error_message%type;

 BEGIN
   if v_table = 1 then
      update ibr_admin_segment
        set row_status = 'E'
      where current of ADMIN_CURSOR;
   end if;

   if v_table = 2 then
      update ibr_offense_segment
        set row_status = 'E'
      where current of OFFENSE_CURSOR;
   end if;

   if v_table = 3 then
      update ibr_property_segment
        set row_status = 'E'
      where current of PROPERTY_CURSOR;
   end if;

   if v_table = 4 then
      update ibr_offender_segment
        set row_status = 'E'
      where current of OFFENDER_CURSOR;
   end if;

   if v_table = 5 then
      update ibr_victim_segment
        set row_status = 'E'
      where current of VICTIM_CURSOR;
   end if;

   if v_table = 6 then
      update ibr_arrestee_segment
        set row_status = 'E'
      where current of ARRESTEE_CURSOR;
   end if;

   if v_table = 7 then
      update ibr_arrest_charge_segment
        set row_status = 'E'
      where current of ARREST_CURSOR;
   end if;

   select error_message into v_message from ibr_error_message_lookup
    where v_error_code = error_number;

   insert into ibr_errors (incident_number, error_code,agcy_ori)
                   values    (v_i_number, v_error_code||' '||v_message,v_agcy_ori);
 END;

/****************************************** ADMIN SEGMENT EDITS *****************************************************/
/* 136 thru 182 */
/*              */
PROCEDURE admin_edit(v_agency in varchar2) is

v_ibr_date   varchar2(8);

/* Occurence date edits */
 BEGIN
   DBMS_OUTPUT.PUT_LINE('------admin_edit');
   FOR v_admin_rec in ADMIN_CURSOR(v_agency) LOOP
   EXIT when ADMIN_CURSOR%notfound;
    BEGIN
     if substr(v_admin_rec.incident_occurence_date,1,4) is null then
        update_row_status(1, v_admin_rec.incident_number, 144, v_agency);

      end if;

     if substr(v_admin_rec.incident_occurence_date,5,2) is null then
        update_row_status(1, v_admin_rec.incident_number,144, v_agency);
     end if;

     if substr(v_admin_rec.incident_occurence_date,7,2) is null then
        update_row_status(1, v_admin_rec.incident_number,144, v_agency);
     end if;

     If v_admin_rec.incident_occurence_date > to_char(sysdate,'YYYYMMDD') then
        update_row_status(1, v_admin_rec.incident_number,150, v_agency);
     end if;

/* Occurence Time edits */
    if v_admin_rec.incident_occurence_time is null then
       update_row_status(1,v_admin_rec.incident_number,152, v_agency);
    end if;

    if substr(v_admin_rec.incident_occurence_time,1,2) not between '00' and '23' then
      update_row_status(1,v_admin_rec.incident_number,152, v_agency);
    end if;

    if substr(v_admin_rec.incident_occurence_time,3,2) not between '00' and '59' then
       update_row_status(1,v_admin_rec.incident_number,152, v_agency);
    end if;

 /* Occurence Report Date*/
 /* 154 */
    if v_admin_rec.segment_action not in ('W', 'U') then
       if substr(v_admin_rec.incident_report_date,1,4) < '1991' then
          update_row_status(1,v_admin_rec.incident_number,154, v_agency);
       end if;
    end if;

 /* 156 */
    if v_admin_rec.segment_action in ('I', 'R') then
       BEGIN
         Select to_char(agcy_ibr_date, 'YYYYMMDD') into v_ibr_date from v_agency
          where agcy_ori = v_admin_rec.ori_number;

         if v_admin_rec.incident_report_date < v_ibr_date then
            update_row_status(1,v_admin_rec.incident_number,156, v_agency);
         end if;
       END;
    end if;

 /* 158 */
    if v_admin_rec.incident_report_date > to_char(sysdate,'YYYYMMDD') then
       update_row_status(1,v_admin_rec.incident_number,158, v_agency);
    end if;

 /* 160 */
    if v_admin_rec.incident_occurence_date not in ('88888888', '99999999') then
       if v_admin_rec.incident_report_date < v_admin_rec.incident_occurence_date then
           update_row_status(1,v_admin_rec.incident_number,160, v_agency);
       end if;
    end if;

 /* Incident report time */
 /* 162 */
   if v_admin_rec.incident_report_time is null then
      update_row_status(1,v_admin_rec.incident_number,162 , v_agency);
    end if;

    if substr(v_admin_rec.incident_report_time,1,2) not between '00' and '23' then
       update_row_status(1,v_admin_rec.incident_number,162, v_agency);
    end if;

    if substr(v_admin_rec.incident_report_time,3,2) not between '00' and '59' then
       update_row_status(1,v_admin_rec.incident_number,162, v_agency);
    end if;

 /* Incident case status */
 /* 164 */
     if v_admin_rec.incident_case_status not in ('01', '02', '10', '11', '12', '13', '14', '20','21', '22', '88', '99') then
         update_row_status(1,v_admin_rec.incident_number,164, v_agency);
     end if;

 /* 166 */
     if v_admin_rec.exception_clearance_date <> '77777777' then
        if v_admin_rec.incident_case_status not in ('10', '11', '12', '13', '14') then
           update_row_status(1,v_admin_rec.incident_number, 166, v_agency);
         end if;
      end if;

 /* 168 */
      if v_admin_rec.exception_clearance_date = '77777777' then
        if v_admin_rec.incident_case_status in ('10', '11', '12', '13', '14') then
           update_row_status(1,v_admin_rec.incident_number, 168, v_agency);
         end if;
      end if;

 /* Exception Clearance Date  not coded in sjs front end */
 /* 170 */
      if v_admin_rec.exception_clearance_date = '77777777' then
         null;
      elsif substr(v_admin_rec.exception_clearance_date,1,4) is null then
             update_row_status(1,v_admin_rec.incident_number,170, v_agency);
      elsif substr(v_admin_rec.exception_clearance_date,5,2) is null then
            update_row_status(1,v_admin_rec.incident_number,170, v_agency);
      elsif substr(v_admin_rec.exception_clearance_date,7,2) is null then
            update_row_status(1,v_admin_rec.incident_number,170, v_agency);
      end if;

/* 172 */
      if v_admin_rec.exception_clearance_date <> '77777777' then
         if v_admin_rec.exception_clearance_date < v_ibr_date then
            update_row_status(1,v_admin_rec.incident_number,172, v_agency);
         end if;
/* 174 */
         If v_admin_rec.exception_clearance_date > to_char(sysdate,'YYYYMMDD') then
            update_row_status(1,v_admin_rec.incident_number,174, v_agency);
         end if;
      end if;

/* 176 */
       if v_admin_rec.incident_occurence_date not in ('88888888', '99999999') then
          if v_admin_rec.exception_clearance_date < v_admin_rec.incident_occurence_date then
             update_row_status(1,v_admin_rec.incident_number, 176, v_agency);
          end if;
       end if;

/*Location Of Incident code */
/* 178 */
       if v_admin_rec.incident_location_code in ('0000', null) then
           update_row_status(1,v_admin_rec.incident_number, 178, v_agency);
       end if;

/*Station Division Precint */
/* 180 */

      if length(v_admin_rec.station_div_prec_id) is null or instr(rtrim(v_admin_rec.station_div_prec_id),' ') > 0 then
            update_row_status(1,v_admin_rec.incident_number, 180, v_agency);
      end if;

/* Bias Crime Type */
/* 182 */
      if v_admin_rec.bias_crime_type not in ('11', '12', '13', '14', '21', '22', '23', '24', '29', '31',
                                             '32', '33', '39', '41', '50', '77', '88', '99') then
           update_row_status(1,v_admin_rec.incident_number, 182, v_agency);
      end if;
/*688*/
     if v_admin_rec.segment_action  in ('W', 'U') then
        if v_admin_rec.incident_case_status between '10' and '14' then
	      if v_admin_rec.exception_clearance_date = '7777777' then
		    update_row_status(1,v_admin_rec.incident_number, 688, v_agency);
           end if;
	   end if;
     end if;

    END;
  END LOOP;
 COMMIT;
 END admin_edit;

/************************************************** OFFENSE SEGMENTS *********************************************/
/* 184 thru 246 */
procedure offense_edit(v_agency in varchar2) is

BEGIN
  DBMS_OUTPUT.PUT_LINE('------offense_edit');
  FOR v_offense_rec in OFFENSE_CURSOR(v_agency) LOOP
   EXIT when OFFENSE_CURSOR%notfound;
   BEGIN
    if v_offense_rec.segment_action not in ('W', 'U') then
      BEGIN
/* offense number */
/* 184 */
      if v_offense_rec.offense_number not between 01 and 75 then
          update_row_status(2,v_offense_rec.incident_number, 184, v_agency);
      end if;

/* 186 */
      if v_offense_rec.justifiable_homicide_circ = '77' then
         if v_offense_rec.incident_offense_code = 'XXXXXXXXXXXXXXXXXXXXX' then
            update_row_status(2,v_offense_rec.incident_number, 186, v_agency);
         end if;
      end if;

/* 188 */
      if v_offense_rec.justifiable_homicide_circ = '77' then
         if substr(v_offense_rec.incident_offense_code,22,1) not in ('C', 'A') then
            update_row_status(2,v_offense_rec.incident_number, 188, v_agency);
         end if;
      end if;

/* larceny Type */
/* 190 */
      if v_offense_rec.incident_larceny_type not in ('77', '88', '99') then
         if v_offense_rec.incident_larceny_type not between '01' and '10' then
             update_row_status(2,v_offense_rec.incident_number, 190, v_agency);
         end if;
      end if;

/* 192 */
     if v_offense_rec.incident_larceny_type <> '77' then
         if v_offense_rec.ucr_code not in ('23A', '23B', '23C', '23D', '23E', '23F',
                                           '23G', '23H', '240') then
            update_row_status(2,v_offense_rec.incident_number, 192, v_agency);
         end if;
     end if;

/* 194 */
     if v_offense_rec.ucr_code in ('23A', '23B', '23C', '23D', '23E', '23F', '23G', '23H', '240') then
        if v_offense_rec.incident_larceny_type = '77' then
           update_row_status(2,v_offense_rec.incident_number, 194, v_agency);
        end if;
     end if;

/* location code */
/* 196 */
     if v_offense_rec.incident_location_type not in ('88', '99') then
        if v_offense_rec.incident_location_type not between '01' and '52' then
            update_row_status(2,v_offense_rec.incident_number, 196, v_agency);
        end if;
     end if;

/* Weapons Force */
/* 198 */
      if v_offense_rec.weapon_force1 not in ('77', '88', '99') then
         if v_offense_rec.weapon_force1 not between '01' and '19' then
            update_row_status(2,v_offense_rec.incident_number, 198, v_agency);
         end if;
      end if;

/* 200 */
      if v_offense_rec.weapon_force2 <> '77' then
         if v_offense_rec.weapon_force2 not between '01' and '19' then
            update_row_status(2,v_offense_rec.incident_number, 200, v_agency);
         end if;
      end if;

      if v_offense_rec.weapon_force3 <> '77' then
         if v_offense_rec.weapon_force3 not between '01' and '19' then
            update_row_status(2,v_offense_rec.incident_number, 200, v_agency);
         end if;
      end if;

 /* 202 */
      if v_offense_rec.weapon_force1 between '01' and '19' then
         BEGIN
           if v_offense_rec.weapon_force2 = v_offense_rec.weapon_force1 then
              update_row_status(2,v_offense_rec.incident_number, 202, v_agency);
           end if;

           if v_offense_rec.weapon_force3 = v_offense_rec.weapon_force1 then
               update_row_status(2,v_offense_rec.incident_number, 202, v_agency);
           end if;
         END;
       end if;

       if v_offense_rec.weapon_force2 between '01' and '19' then
          if v_offense_rec.weapon_force3 = v_offense_rec.weapon_force2 then
               update_row_status(2,v_offense_rec.incident_number, 202, v_agency);
           end if;
       end if;

/* 204 */
      if v_offense_rec.weapon_force1 in ('77', '88', '99') then
         BEGIN
          if v_offense_rec.weapon_force2 <> '77' then
             update_row_status(2,v_offense_rec.incident_number, 204, v_agency);
          end if;

          if v_offense_rec.weapon_force3 <> '77' then
             update_row_status(2,v_offense_rec.incident_number, 204, v_agency);
          end if;
         END;
      end if;


      if v_offense_rec.weapon_force2 in ('77', '88', '99') then
         if v_offense_rec.weapon_force3 <> '77' then
             update_row_status(2,v_offense_rec.incident_number, 204, v_agency);
          end if;
      end if;

/*206 */
      if v_offense_rec.weapon_force1 = '77' then
         if v_offense_rec.ucr_code in ('09A', '09B', '09C', '100', '11A', '11B', '11C',
                                       '11D', '120', '13A', '13B', '210', '520') then
            update_row_status(2,v_offense_rec.incident_number, 206, v_agency);
         end if;
      end if;


/*208 */
      if v_offense_rec.ucr_code = '13B' then
         if v_offense_rec.weapon_force1 not in ('09', '14', '19', '88', '99') then
            update_row_status(2,v_offense_rec.incident_number, 208, v_agency);
         end if;
      end if;

/* 209 */
      if v_offense_rec.ucr_code = '13B' then
         BEGIN
          if v_offense_rec.weapon_force2 not in ('09', '14', '19','77') then
             update_row_status(2,v_offense_rec.incident_number,209, v_agency);
          end if;
          if v_offense_rec.weapon_force3 not in ('09', '14', '19','77') then
             update_row_status(2,v_offense_rec.incident_number,209, v_agency);
          end if;
         END;
      end if;

/* # of premises entered */
/* 210 */
      if v_offense_rec.number_premises_entered not between '00' and '99' then
         update_row_status(2,v_offense_rec.incident_number, 210 , v_agency);
      end if;

/* 212 */
      if v_offense_rec.ucr_code <> '220' then
         if v_offense_rec.number_premises_entered <> '00' then
             update_row_status(2,v_offense_rec.incident_number, 212, v_agency);
         end if;
      end if;

/* 214 */
      if v_offense_rec.ucr_code = '220' then
         if v_offense_rec.incident_location_type in ('18', '24') then
            if v_offense_rec.number_premises_entered = '00' then
                update_row_status(2,v_offense_rec.incident_number, 214, v_agency);
            end if;
         end if;
      end if;

/* Methond of entry */
/* 216 */
       if v_offense_rec.method_of_entry not in ('F', 'N', 'X') then
          update_row_status(2,v_offense_rec.incident_number, 216, v_agency);
        end if;

/* 218 */
       if v_offense_rec.ucr_code <> '220' then
          if v_offense_rec.method_of_entry <> 'X' then
             update_row_status(2,v_offense_rec.incident_number, 218, v_agency);
          end if;
       end if;

/* 220 */
       if v_offense_rec.ucr_code = '220' then
          if v_offense_rec.method_of_entry not in ('F', 'N') then
             update_row_status(2,v_offense_rec.incident_number, 220, v_agency);
           end if;
       end if;

/* Assault Homicide */
/*222*/
      if v_offense_rec.assault_homicide_circ1 not in ('01', '02', '03', '04', '05', '06', '07', '08', '09', '10','11', '12',
                                                      '20', '21', '30', '31', '32', '33','34', '40', '77') then
          update_row_status(2,v_offense_rec.incident_number, 222, v_agency);
      end if;

      if v_offense_rec.assault_homicide_circ2 not in ('01', '02', '03', '04', '05', '06', '07', '08', '09', '10','11', '12',
                                                      '20', '21', '30', '31', '32', '33','34', '40', '77') then
                  update_row_status(2,v_offense_rec.incident_number, 222, v_agency);
      end if;

/*224*/
      if v_offense_rec.ucr_code in ('13B', '09A', '09C') then
          if (v_offense_rec.assault_homicide_circ1 not between '01' and '12') then
             if  (v_offense_rec.assault_homicide_circ1 not in ('20', '21')) then
                 update_row_status(2,v_offense_rec.incident_number, 224, v_agency);
             end if;
          end if;
      end if;

/*226*/
      if v_offense_rec.ucr_code in ('13B', '09A', '09C') then
          if (v_offense_rec.assault_homicide_circ2 not between '01'and '12') then
             if (v_offense_rec.assault_homicide_circ2 not in ('20', '21', '77')) then
                update_row_status(2,v_offense_rec.incident_number, 226 , v_agency);
             end if;
          end if;
      end if;

/*228*/
      if v_offense_rec.ucr_code = '13A' then
          if (v_offense_rec.assault_homicide_circ1 not between '01'and '10') then
             if (v_offense_rec.assault_homicide_circ1 not in('12', '20', '21')) then
                 update_row_status(2,v_offense_rec.incident_number, 228, v_agency);
             end if;
          end if;
      end if;


/*230*/
     if v_offense_rec.ucr_code = '13A' then
          if (v_offense_rec.assault_homicide_circ2 not between '01'and '10') then
             if (v_offense_rec.assault_homicide_circ2 not in ('12', '20', '21', '77')) then
                update_row_status(2,v_offense_rec.incident_number, 230, v_agency);
             end if;
          end if;
      end if;

/*232*/
     if v_offense_rec.ucr_code = '09B' then
        if v_offense_rec.assault_homicide_circ1 not between '30' and '34'
                              and
           v_offense_rec.assault_homicide_circ1 !=40 then
           update_row_status(2,v_offense_rec.incident_number, 232, v_agency);
        end if;
     end if;

/* 234*/
      if v_offense_rec.ucr_code = '09B' then
        if v_offense_rec.assault_homicide_circ2 <> '77' then
           update_row_status(2,v_offense_rec.incident_number, 234, v_agency);
        end if;
     end if;

/*236*/
      if (v_offense_rec.assault_homicide_circ1 between '01' and '12') then
         if (v_offense_rec.assault_homicide_circ1 in ('20', '21', '30', '31', '32', '33', '34', '40')) then
            if v_offense_rec.assault_homicide_circ2 = v_offense_rec.assault_homicide_circ1 then
               if v_offense_rec.ucr_code = '09B' then
                  update_row_status(2,v_offense_rec.incident_number, 236, v_agency);
               end if;
            end if;
         end if;
      end if;

/*238*/
      if v_offense_rec.assault_homicide_circ1 = '21' then
         if v_offense_rec.assault_homicide_circ2 <> '77' then
            update_row_status(2,v_offense_rec.incident_number, 238, v_agency);
         end if;
      end if;

 /*240*/
      if v_offense_rec.assault_homicide_circ1 = '77' then
         if v_offense_rec.assault_homicide_circ2 <> '77' then
            update_row_status(2,v_offense_rec.incident_number, 240, v_agency);
         end if;
      end if;
/* Justifiable Homicide */
/*242*/
      if v_offense_rec.ucr_code = '09C' then
         if v_offense_rec.justifiable_homicide_circ not in ('01', '02', '03', '04', '05', '06', '09', '13', '14', '15',
                                                            '16', '17', '19') then
            update_row_status(2,v_offense_rec.incident_number, 242, v_agency);
         end if;
      end if;

/* 244 */
      if v_offense_rec.ucr_code <> '09C' then
         if v_offense_rec.justifiable_homicide_circ <> '77' then
             update_row_status(2,v_offense_rec.incident_number, 244, v_agency);
         end if;
      end if;


/* 246 */
      if v_offense_rec.computer_used not in ('0','1','8') then
         update_row_status(2,v_offense_rec.incident_number, 246, v_agency);
      end if;

/*implied edits*/
/*850*/
      if substr(v_offense_rec.incident_offense_code,1,12) in ('PL 120.03   ', 'PL 120.03 01','PL 120.04 02','PL 120.03 02') then
         if  (v_offense_rec.weapon_force1 <> '13') then
            if (v_offense_rec.weapon_force2 <> '13') then
              if (v_offense_rec.weapon_force3 <> '13') then
                  update_row_status(2,v_offense_rec.incident_number, 850, v_agency);
              end if;
            end if;
         end if;
      end if;

/*852*/
      if substr(v_offense_rec.incident_offense_code,1,14) in ('PL 120.05 02', 'PL 120.05 04') then
         if v_offense_rec.weapon_force1 in ('77', '88', '99') then
            update_row_status(2,v_offense_rec.incident_number, 852, v_agency);
         end if;
      end if;

/*854*/
       if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 120.05 05' then
         if  (v_offense_rec.weapon_force1 <> '18') or
             (v_offense_rec.weapon_force2 <> '18') or
             (v_offense_rec.weapon_force3 <> '18') then
             update_row_status(2,v_offense_rec.incident_number, 854, v_agency);
         end if;
      end if;

/*856*/
      if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 120.05 06' then
         if (v_offense_rec.assault_homicide_circ1 not in ('02','03','04','05','06','07','08','09','12')) or
            (v_offense_rec.assault_homicide_circ2 not in ('02','03','04','05','06','07','08','09','12')) then
             update_row_status(2,v_offense_rec.incident_number, 856, v_agency);
         end if;
      end if;

/*858*/
       if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 120.10   01' then
           if (v_offense_rec.weapon_force1 in ('77','88','99')) then
               update_row_status(2,v_offense_rec.incident_number, 858 , v_agency);
           end if;
       end if;

/*860*/
       if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 120.10   04' then
         if (v_offense_rec.assault_homicide_circ1 not in ('02','03','04','05','06','07','08','09','12')) or
            (v_offense_rec.assault_homicide_circ2 not in ('02','03','04','05','06','07','08','09','12')) then
             update_row_status(2,v_offense_rec.incident_number, 860, v_agency);
         end if;
      end if;

/*862*/
       if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 120.11     ' then
          if (v_offense_rec.weapon_force1 not between '01' and '08') or
             (v_offense_rec.weapon_force2 not between '01' and '08') or
             (v_offense_rec.weapon_force3 not between '01' and '08') then
             update_row_status(2,v_offense_rec.incident_number, 862, v_agency);
           elsif
              v_offense_rec.assault_homicide_circ1 <> '02' then
               update_row_status(2,v_offense_rec.incident_number, 862, v_agency);
           end if;
       end if;

/*864*/
      if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 125.13     ' then
          if (v_offense_rec.weapon_force1 <> '13') or
             (v_offense_rec.weapon_force2 <> '13') or
             (v_offense_rec.weapon_force3 <> '13') then
             update_row_status(2,v_offense_rec.incident_number, 864, v_agency);
           elsif
              (v_offense_rec.assault_homicide_circ1 <> '34') or
              (v_offense_rec.assault_homicide_circ2 <> '34') then
               update_row_status(2,v_offense_rec.incident_number, 864, v_agency);
           end if;
       end if;

/*866*/
       if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 125.25   03' then
         if (v_offense_rec.assault_homicide_circ1 not in ('02','03','04','05','06','07','08','09', '12')) then
            update_row_status(2,v_offense_rec.incident_number, 866, v_agency);
         end if;
       end if;

/*868*/
      if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 125.27     ' then
         if (v_offense_rec.assault_homicide_circ1 <> '02') or
            (v_offense_rec.assault_homicide_circ1 <> '02') then
              update_row_status(2,v_offense_rec.incident_number, 868, v_agency);
         end if;
      end if;

/*872*/
      if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 140.17   01' then
         if (v_offense_rec.weapon_force1 not in ('01','02','03','04','05','06','07','08','11','12','16','17')) or
            (v_offense_rec.weapon_force2 not in ('01','02','03','04','05','06','07','08','11','12','16','17')) or
            (v_offense_rec.weapon_force3 not in ('01','02','03','04','05','06','07','08','11','12','16','17')) then
            update_row_status(2,v_offense_rec.incident_number, 872, v_agency);
         end if;
       end if;

/*874*/
      if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 140.17   02' then
         if (v_offense_rec.weapon_force1 not in ('01','02','03','04','05','06','07','08')) or
            (v_offense_rec.weapon_force2 not in ('01','02','03','04','05','06','07','08')) or
            (v_offense_rec.weapon_force3 not in ('01','02','03','04','05','06','07','08')) then
            update_row_status(2,v_offense_rec.incident_number, 874, v_agency);
         end if;
       end if;

       if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 140.17   03' then
         if (v_offense_rec.weapon_force1 not in ('01','02','03','04','05','06','07','08')) or
            (v_offense_rec.weapon_force2 not in ('01','02','03','04','05','06','07','08')) or
            (v_offense_rec.weapon_force3 not in ('01','02','03','04','05','06','07','08')) then
            update_row_status(2,v_offense_rec.incident_number, 874, v_agency);
         end if;
       end if;

/*876*/
      if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 140.30   01' then
         if (v_offense_rec.weapon_force1 not in ('01','02','03','04','05','06','07','08','11','12','16','17')) or
            (v_offense_rec.weapon_force2 not in ('01','02','03','04','05','06','07','08','11','12','16','17')) or
            (v_offense_rec.weapon_force3 not in ('01','02','03','04','05','06','07','08','11','12','16','17')) then
            update_row_status(2,v_offense_rec.incident_number, 876, v_agency);
         end if;
       end if;

/*880*/
      if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 140.30   04' then
         if (v_offense_rec.weapon_force1 not in ('01','02','03','04','05','06','07','08')) or
            (v_offense_rec.weapon_force2 not in ('01','02','03','04','05','06','07','08')) or
            (v_offense_rec.weapon_force3 not in ('01','02','03','04','05','06','07','08')) then
            update_row_status(2,v_offense_rec.incident_number, 880, v_agency);
         end if;
       end if;

/*888*/
      if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 145.12     ' then
         if (v_offense_rec.weapon_force1 <> 16) and
            (v_offense_rec.weapon_force2 <> 16) and
            (v_offense_rec.weapon_force3 <> 16) then
            update_row_status(2,v_offense_rec.incident_number, 888, v_agency);
         end if;
       end if;

/*904*/
       if (substr(v_offense_rec.incident_offense_code,1,14) = 'PL 156.05     ') or
          (substr(v_offense_rec.incident_offense_code,1,14) = 'PL 156.10     ') or
          (substr(v_offense_rec.incident_offense_code,1,14) = 'PL 156.10   01') or
          (substr(v_offense_rec.incident_offense_code,1,14) = 'PL 156.10   02') or
          (substr(v_offense_rec.incident_offense_code,1,14) = 'PL 156.20     ') or
          (substr(v_offense_rec.incident_offense_code,1,14) = 'PL 156.25     ') or
          (substr(v_offense_rec.incident_offense_code,1,14) = 'PL 156.25   01') or
          (substr(v_offense_rec.incident_offense_code,1,14) = 'PL 156.25   02') then
          if v_offense_rec.computer_used <> 1 then
             update_row_status(2,v_offense_rec.incident_number, 904, v_agency);
          end if;
       end if;

/*910*/
       if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 156.30     ' then
          if v_offense_rec.computer_used <> 1 then
               update_row_status(2,v_offense_rec.incident_number, 910, v_agency);
          end if;
       end if;

/*914*/
       if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 156.35     ' then
          if v_offense_rec.computer_used <> 1 then
               update_row_status(2,v_offense_rec.incident_number, 914 , v_agency);
          end if;
       end if;

/*918*/
       if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 160.15   02' then
         if (v_offense_rec.weapon_force1 not in ('01','02','03','04','05','06','07','08','11','12')) and
            (v_offense_rec.weapon_force2 not in ('01','02','03','04','05','06','07','08','11','12')) and
            (v_offense_rec.weapon_force3 not in ('01','02','03','04','05','06','07','08','11','12')) then
             update_row_status(2,v_offense_rec.incident_number, 918, v_agency);
         end if;
       end if;

/*920*/
       if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 160.15   03' then
         if (v_offense_rec.weapon_force1 not in ('01','02','03','04','05','06','07','08','11','19')) and
            (v_offense_rec.weapon_force2 not in ('01','02','03','04','05','06','07','08','11','19')) and
            (v_offense_rec.weapon_force3 not in ('01','02','03','04','05','06','07','08','11','19')) then
             update_row_status(2,v_offense_rec.incident_number, 920, v_agency);
         end if;
       end if;

/*922*/
       if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 160.15   04' then
         if (v_offense_rec.weapon_force1 not in ('01','02','03','04','05','06','07','08','09')) and
            (v_offense_rec.weapon_force2 not in ('01','02','03','04','05','06','07','08','09')) and
            (v_offense_rec.weapon_force3 not in ('01','02','03','04','05','06','07','08','09')) then
             update_row_status(2,v_offense_rec.incident_number, 922, v_agency);
         end if;
       end if;

/*1028*/
        if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 265.01   03' then
           if v_offense_rec.incident_location_type not in ('08', '09')  then
              update_row_status(2,v_offense_rec.incident_number, 1028, v_agency);
           elsif
              (v_offense_rec.weapon_force1 not in ('01','02','03','04','05','06','07','08')) and
              (v_offense_rec.weapon_force2 not in ('01','02','03','04','05','06','07','08')) and
              (v_offense_rec.weapon_force3 not in ('01','02','03','04','05','06','07','08')) then
               update_row_status(2,v_offense_rec.incident_number, 1028, v_agency);
           end if;
        end if;

/*1030*/
        if substr(v_offense_rec.incident_offense_code,1,14) in('PL 265.01   04','PL 265.01   06') then
           if (v_offense_rec.weapon_force1 not in ('05','06','07','08')) and
              (v_offense_rec.weapon_force2 not in ('05','06','07','08')) and
              (v_offense_rec.weapon_force3 not in ('05','06','07','08')) then
               update_row_status(2,v_offense_rec.incident_number, 1030, v_agency);
           end if;
        end if;

/*1032*/
        if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 265.02   02' then
           if (v_offense_rec.weapon_force1 not in ('04','07','16','17')) and
              (v_offense_rec.weapon_force2 not in ('04','07','16','17')) and
              (v_offense_rec.weapon_force3 not in ('04','07','16','17')) then
               update_row_status(2,v_offense_rec.incident_number, 1032, v_agency);
           end if;
        end if;

/*1034*/
        if substr(v_offense_rec.incident_offense_code,1,14) in ('PL 265.02   03', 'PL 265.03     ') then
         if (v_offense_rec.weapon_force1 not in ('01','02','03','04','05','06','07','08')) and
            (v_offense_rec.weapon_force2 not in ('01','02','03','04','05','06','07','08')) and
            (v_offense_rec.weapon_force3 not in ('01','02','03','04','05','06','07','08')) then
            update_row_status(2,v_offense_rec.incident_number, 1034, v_agency);
         end if;
       end if;

/*1036*/
        if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 265.04     ' then
           if (v_offense_rec.weapon_force1 not in ('16','17')) and
              (v_offense_rec.weapon_force2 not in ('16','17')) and
              (v_offense_rec.weapon_force3 not in ('16','17')) then
               update_row_status(2,v_offense_rec.incident_number, 1036, v_agency);
           end if;
        end if;

/*1038*/
        if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 265.09   01' then
           if (v_offense_rec.weapon_force1 not in ('01','02','03','04','05','06','07','08','11','12')) and
              (v_offense_rec.weapon_force2 not in ('01','02','03','04','05','06','07','08','11','12')) and
              (v_offense_rec.weapon_force3 not in ('01','02','03','04','05','06','07','08','11','12')) then
               update_row_status(2,v_offense_rec.incident_number, 1038, v_agency);
           end if;
        end if;

/*1040*/
       if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 265.09   02' then
           if (v_offense_rec.weapon_force1 not in ('01','02','03','04','05','06','07','08','09')) and
              (v_offense_rec.weapon_force2 not in ('01','02','03','04','05','06','07','08','09')) and
              (v_offense_rec.weapon_force3 not in ('01','02','03','04','05','06','07','08','09')) then
               update_row_status(2,v_offense_rec.incident_number, 1040, v_agency);
           end if;
        end if;

/*1042*/
        if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 265.10   02' then
           if (v_offense_rec.weapon_force1 not in ('01','02','03','04','05','06','07','08','11','12')) and
              (v_offense_rec.weapon_force2 not in ('01','02','03','04','05','06','07','08','11','12')) and
              (v_offense_rec.weapon_force3 not in ('01','02','03','04','05','06','07','08','11','12')) then
               update_row_status(2,v_offense_rec.incident_number, 1042, v_agency);
           end if;
        end if;

/*1044*/
         if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 265.10   03' then
           if (v_offense_rec.weapon_force1 not in ('01','02','03','04','05','06','07','08')) and
              (v_offense_rec.weapon_force2 not in ('01','02','03','04','05','06','07','08')) and
              (v_offense_rec.weapon_force3 not in ('01','02','03','04','05','06','07','08')) then
               update_row_status(2,v_offense_rec.incident_number, 1044, v_agency);
           end if;
        end if;

/*1046*/
         if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 265.10   04' then
           if (v_offense_rec.weapon_force1 not in ('10','11','12','15','16'',17','19')) and
              (v_offense_rec.weapon_force2 not in ('10','11','12','15','16'',17','19')) and
              (v_offense_rec.weapon_force3 not in ('10','11','12','15','16'',17','19')) then
               update_row_status(2,v_offense_rec.incident_number, 1046, v_agency);
           end if;
        end if;

/*1048*/
        if substr(v_offense_rec.incident_offense_code,1,14) in ('PL 265.10   06','PL 265.11     ',
                                                                'PL 265.11   01','PL 265.11   02')  then
           if (v_offense_rec.weapon_force1 not in ('01','02','03','04','05','06','07','08')) and
              (v_offense_rec.weapon_force2 not in ('01','02','03','04','05','06','07','08')) and
              (v_offense_rec.weapon_force3 not in ('01','02','03','04','05','06','07','08')) then
               update_row_status(2,v_offense_rec.incident_number, 1048, v_agency);
           end if;
        end if;

/*1050*/
        if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 265.12     ' then
           if (v_offense_rec.weapon_force1 not in ('01','02','03','04','05','06','07','08')) and
              (v_offense_rec.weapon_force2 not in ('01','02','03','04','05','06','07','08')) and
              (v_offense_rec.weapon_force3 not in ('01','02','03','04','05','06','07','08')) then
               update_row_status(2,v_offense_rec.incident_number, 1050 , v_agency);
           end if;
        end if;

/*1052*/
        if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 265.35   01' then
           if (v_offense_rec.weapon_force1 not in ('10','11','12','15','16'',17','19')) and
              (v_offense_rec.weapon_force2 not in ('10','11','12','15','16'',17','19')) and
              (v_offense_rec.weapon_force3 not in ('10','11','12','15','16'',17','19')) then
               update_row_status(2,v_offense_rec.incident_number, 1052, v_agency);
           end if;
        end if;

/*1054*/
       if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 265.35   02' then
           if (v_offense_rec.weapon_force1 not in ('01','02','03','04','05','06','07','08')) and
              (v_offense_rec.weapon_force2 not in ('01','02','03','04','05','06','07','08')) and
              (v_offense_rec.weapon_force3 not in ('01','02','03','04','05','06','07','08')) then
               update_row_status(2,v_offense_rec.incident_number, 1054, v_agency);
           end if;
        end if;

/*1056*/
       if substr(v_offense_rec.incident_offense_code,1,14) = 'PL 265.35   03' then
           if (v_offense_rec.weapon_force1 not in ('01','02','03','04','05','06','07','08')) and
              (v_offense_rec.weapon_force2 not in ('01','02','03','04','05','06','07','08')) and
              (v_offense_rec.weapon_force3 not in ('01','02','03','04','05','06','07','08')) then
               update_row_status(2,v_offense_rec.incident_number, 1056, v_agency);
           end if;
        end if;

     END;
    end if;
    END;
  END LOOP;
 COMMIT;
 end offense_edit;

/************************************************PROPERTY INVOLVEMENT**************************************************************/
/*property involvement */

PROCEDURE property_edit(v_agency in varchar2) is
v_ibr_date date;
vehicle_cnt number;
e_cnt number :=0;
v_found number :=0;

--i number:=0;
--j number:=0;

type prop_type_TABLE IS TABLE OF VARCHAR2(2)
 index by binary_integer;
p_type  prop_type_table;

type prop_value_TABLE IS TABLE OF VARCHAR2(9)
 index by binary_integer;
p_value  prop_value_table;

type prop_date_table is table of varchar2(8)
 index by binary_integer;
p_date  prop_date_table;

type prop_drug_type is table of varchar2(2)
 index by binary_integer;
p_drug_type   prop_drug_type;

type prop_drug_qty is table of varchar2(12)
 index by binary_integer;
p_drug_qty   prop_drug_qty;

type prop_drug_uom is table of varchar2(2)
 index by binary_integer;
p_drug_uom   prop_drug_uom;


 BEGIN
   DBMS_OUTPUT.PUT_LINE('------property_edit');
  Select a.agcy_ibr_date into v_ibr_date from v_agency a
   where a.agcy_ori = v_agency;

   FOR v_prop_rec in PROPERTY_CURSOR(v_agency) LOOP
   EXIT when PROPERTY_CURSOR%notfound;
    BEGIN
       p_type(1) := v_prop_rec.property_type1;
       p_type(2) := v_prop_rec.property_type2;
       p_type(3) := v_prop_rec.property_type3;
       p_type(4) := v_prop_rec.property_type4;
       p_type(5) := v_prop_rec.property_type5;
       p_type(6) := v_prop_rec.property_type6;
       p_type(7) := v_prop_rec.property_type7;
       p_type(8) := v_prop_rec.property_type8;
       p_type(9) := v_prop_rec.property_type9;
       p_type(10) := v_prop_rec.property_type10;

       p_value(1) := v_prop_rec.property_value1;
       p_value(2) := v_prop_rec.property_value2;
       p_value(3) := v_prop_rec.property_value3;
       p_value(4) := v_prop_rec.property_value4;
       p_value(5) := v_prop_rec.property_value5;
       p_value(6) := v_prop_rec.property_value6;
       p_value(7) := v_prop_rec.property_value7;
       p_value(8) := v_prop_rec.property_value8;
       p_value(9) := v_prop_rec.property_value9;
       p_value(10) := v_prop_rec.property_value10;

       p_date(1) := v_prop_rec.property_recovery_date1;
       p_date(2) := v_prop_rec.property_recovery_date2;
       p_date(3) := v_prop_rec.property_recovery_date3;
       p_date(4) := v_prop_rec.property_recovery_date4;
       p_date(5) := v_prop_rec.property_recovery_date5;
       p_date(6) := v_prop_rec.property_recovery_date6;
       p_date(7) := v_prop_rec.property_recovery_date7;
       p_date(8) := v_prop_rec.property_recovery_date8;
       p_date(9) := v_prop_rec.property_recovery_date9;
       p_date(10) := v_prop_rec.property_recovery_date10;

       p_drug_type(1) := v_prop_rec.drug_type1;
       p_drug_type(2) := v_prop_rec.drug_type2;
       p_drug_type(3) := v_prop_rec.drug_type3;

       p_drug_qty(1) := v_prop_rec.drug_quantity1;
       p_drug_qty(2) := v_prop_rec.drug_quantity2;
       p_drug_qty(3) := v_prop_rec.drug_quantity3;

       p_drug_uom(1) := v_prop_rec.drug_uom1;
       p_drug_uom(2) := v_prop_rec.drug_uom2;
       p_drug_uom(3) := v_prop_rec.drug_uom3;

/*248*/
      if v_prop_rec.property_involvement not in ('01', '02', '03', '04' ,'05',
                                                 '06', '07', '88', '99') then
          update_row_status(3,v_prop_rec.incident_number, 248, v_agency);
      end if;


/*250*/
      if v_prop_rec.property_involvement in ('02', '03', '04', '05', '06', '07') then
         if v_prop_rec.property_type1 = '77' then
             update_row_status(3,v_prop_rec.incident_number, 250, v_agency);
         end if;
      end if;

/*property type*/
/*252*/
      if (v_prop_rec.property_type1 not between '01' and '51') then
          if (v_prop_rec.property_type1 not in ('77', '88' ,'99')) then
             update_row_status(3,v_prop_rec.incident_number, 252, v_agency);
          end if;
      end if;


/*254*/
      For i_254 in 2..10 loop
       if p_type(i_254) <> '77' then
         if p_type(i_254) not between '01' and '51' then
            update_row_status(3,v_prop_rec.incident_number, 254, v_agency);
         end if;
       end if;
      end loop;

/* 256 */
     BEGIN
      for i_256 in 1..10 LOOP
         for j_256 in i_256+1..10 LOOP
           if p_type(i_256) = p_type(j_256) and p_type(i_256) between '01' and '51' then
               update_row_status(3,v_prop_rec.incident_number, 256, v_agency);
           end if;
         end loop;
       end loop;
     END;

/*258*/
      if v_prop_rec.property_involvement = '01' then
         for i_258 in 1..10 loop
            if p_type(i_258) <> '77' then
                update_row_status(3,v_prop_rec.incident_number, 258, v_agency);
            end if;
         end loop;
      end if;

/*260*/
      if v_prop_rec.property_involvement = '88' then
         if v_prop_rec.property_type1 <> '88' then
             update_row_status(3,v_prop_rec.incident_number, 260, v_agency);
         end if;
      end if;

/* 262*/
      if v_prop_rec.property_involvement = '99' then
         if v_prop_rec.property_type1 <> '99' then
             update_row_status(3,v_prop_rec.incident_number, 262, v_agency);
         end if;
      end if;

/*264*/
       for i_264 in 1..10 loop
           if p_type(i_264) = '77' then
              for j_264 in i_264+1..9 loop
                if p_type(j_264) <> '77' then
                  update_row_status(3,v_prop_rec.incident_number, 264, v_agency);
                end if;
              end loop;
           end if;
       end loop;

/*266*/
       for i_266 in 1..10 loop
           if p_type(i_266) = '50' then
              for j_266 in i_266+1..10 loop
               if p_type(j_266) <> '77' then
                  update_row_status(3,v_prop_rec.incident_number, 266, v_agency);
               end if;
              end loop;
           end if;
       end loop;

/*268*/
      for i_268 in 1..10 loop
           if p_type(i_268) = '50' then
              if p_value(i_268) <> '999999999' then
                 update_row_status(3,v_prop_rec.incident_number, 268, v_agency);
              end if;
           end if;
       end loop;

/*270*/
       for i_270 in 1..10 loop
           if p_type(i_270) = '77' then
              if p_value(i_270) <> '777777777' then
                 update_row_status(3,v_prop_rec.incident_number, 270, v_agency);
              end if;
           end if;
       end loop;

/*274*/
      If v_prop_rec.property_involvement = '05' then
         For i_274 in 1..10 loop
            if p_type(i_274) <> '77' then
               if p_date(i_274) = '77777777' then
                  update_row_status(3,v_prop_rec.incident_number, 274, v_agency);
               end if;
            end if;
         end loop;
      end if;

/*276*/
      if v_prop_rec.property_type1 = '77' then
         if v_prop_rec.number_stolen_vehicles <> 777 then
              update_row_status(3,v_prop_rec.incident_number, 276 , v_agency);
          end if;
      end if;

/*278*/
      if v_prop_rec.property_type1 = '77' then
         if v_prop_rec.number_recovered_vehicles <> 777 then
            update_row_status(3,v_prop_rec.incident_number, 278, v_agency);
          end if;
      end if;

/*280*/
      if v_prop_rec.property_type1 = '77' then
         if v_prop_rec.drug_data_source <> '7' then
             update_row_status(3,v_prop_rec.incident_number, 280, v_agency);
         end if;
      end if;

/*282*/
      if v_prop_rec.property_type1 = '77' then
        BEGIN
         if v_prop_rec.drug_type1 <> '00' then
            update_row_status(3,v_prop_rec.incident_number, 282, v_agency);
         end if;
         if v_prop_rec.drug_type2 <> '00' then
            update_row_status(3,v_prop_rec.incident_number, 282, v_agency);
         end if;
         if v_prop_rec.drug_type3 <> '00' then
            update_row_status(3,v_prop_rec.incident_number, 282, v_agency);
         end if;
        END;
      end if;

/*284*/
      if v_prop_rec.property_type1 = '77' then
        BEGIN
         if v_prop_rec.drug_quantity1 <> '777777777777' then
            update_row_status(3,v_prop_rec.incident_number, 284, v_agency);
         end if;
         if v_prop_rec.drug_quantity2 <> '777777777777' then
            update_row_status(3,v_prop_rec.incident_number, 284, v_agency);
         end if;
         if v_prop_rec.drug_quantity3 <> '777777777777' then
            update_row_status(3,v_prop_rec.incident_number, 284, v_agency);
         end if;
        END;
      end if;

/*286*/
      if v_prop_rec.property_type1 = '77' then
        BEGIN
         if v_prop_rec.drug_uom1 <> 'NA' then
            update_row_status(3,v_prop_rec.incident_number, 286 , v_agency);
         end if;
         if v_prop_rec.drug_uom2 <> 'NA' then
            update_row_status(3,v_prop_rec.incident_number, 286, v_agency);
         end if;
         if v_prop_rec.drug_uom3 <> 'NA' then
            update_row_status(3,v_prop_rec.incident_number, 286, v_agency);
         end if;
        END;
      end if;

/*288*/
      if v_prop_rec.property_type1 in ('88','99') then
         if v_prop_rec.property_value1 <> '999999999' then
             update_row_status(3,v_prop_rec.incident_number, 288, v_agency);
         end if;
      end if;

/*290*/
      if v_prop_rec.property_type1 in ('88', '99') then
         if v_prop_rec.number_stolen_vehicles <> 777 then
             update_row_status(3,v_prop_rec.incident_number, 290, v_agency);
         end if;
      end if;

/*292*/
      if v_prop_rec.property_type1 in ('88', '99') then
         if v_prop_rec.number_recovered_vehicles <> 777 then
             update_row_status(3,v_prop_rec.incident_number, 292, v_agency);
         end if;
      end if;

/*294*/
      if v_prop_rec.property_type1 in ('88', '99') then
         if v_prop_rec.drug_data_source <> '7' then
             update_row_status(3,v_prop_rec.incident_number, 294, v_agency);
         end if;
      end if;

/*296*/
      if v_prop_rec.property_type1 in ('88', '99') then
         if v_prop_rec.drug_type1 <> '00' then
             update_row_status(3,v_prop_rec.incident_number, 296, v_agency);
         end if;
      end if;

/*298*/
      if v_prop_rec.property_type1 = '88' then
         if v_prop_rec.drug_quantity1 <> '777777777777' then
             update_row_status(3,v_prop_rec.incident_number, 298, v_agency);
         end if;
      end if;

/*300*/
      if v_prop_rec.property_type1 = '99' then
         if v_prop_rec.drug_quantity1 <> '777777777777' then
             update_row_status(3,v_prop_rec.incident_number, 300, v_agency);
         end if;
      end if;

/*302*/
       if v_prop_rec.property_type1 in ('88', '99') then
         if v_prop_rec.drug_uom1 <> 'NA' then
             update_row_status(3,v_prop_rec.incident_number, 302, v_agency);
         end if;
      end if;

/*304*/
      for i_304 in 1..10 loop
         if p_type(i_304) = '77' then
            if p_value(i_304) <> '777777777' then
               update_row_status(3,v_prop_rec.incident_number, 304, v_agency);
            end if;
         end if;
      end loop;

/*306*/
      for i_306 in 1..10 loop
         if p_type(i_306) not in ('26', '77') then
            if p_value(i_306) = '777777777' then
                update_row_status(3,v_prop_rec.incident_number, 306, v_agency);
            end if;
         end if;
      end loop;

/*308*/
      if v_prop_rec.property_involvement <> '06' then
         for i_308 in 1..10 loop
            if p_type(i_308) = '26' then
               if p_value(i_308) = '777777777'  then
                   update_row_status(3,v_prop_rec.incident_number, 308 , v_agency);
               end if;
            end if;
         end loop;
      end if;

/*Property value */
/*311*/
     for i_311 in 1..10  loop
         if p_value(i_311) = '000000000' then
            if p_type(i_311) not in ('02', '04', '05', '49') then
               update_row_status(3,v_prop_rec.incident_number, 311, v_agency);
            end if;
         end if;
     end loop;

/*316*/
     for i_316 in 1..10 loop
         if p_value(i_316) <> '777777777' then
            if p_type(i_316) = '77' then
                update_row_status(3,v_prop_rec.incident_number, 316 , v_agency);
            end if;
         end if;
     end loop;

/*Recovery date*/
/*318*/
     for i_318 in 1..10 loop
         if p_date(i_318) <> '77777777' then
            if substr(p_date(i_318),1,4) is null then
                update_row_status(3,v_prop_rec.incident_number, 318, v_agency);
            elsif substr(p_date(i_318),5,2) is null then
                   update_row_status(3,v_prop_rec.incident_number, 318, v_agency);
               elsif substr(p_date(i_318),7,2) is null then
                      update_row_status(3,v_prop_rec.incident_number, 318, v_agency);
                  elsif p_date(i_318) > to_char(sysdate, 'YYYYMMDD') then
                          update_row_status(3,v_prop_rec.incident_number, 318, v_agency);
            end if;
         end if;
     end loop;

/*320*/
     For i_320 in 1..10 loop
         if p_date(i_320) <> '77777777' then
            if p_date(i_320) < to_char(v_ibr_date, 'YYYYMMDD') then
                update_row_status(3,v_prop_rec.incident_number, 320 , v_agency);
            end if;
         end if;
     end loop;

/*322*/
    for i_322 in 1..10 loop
        if p_date(i_322) <> '77777777' then
           if p_date(i_322) > to_char(sysdate,'YYYYMMDD') then
              update_row_status(3,v_prop_rec.incident_number, 322, v_agency);
           end if;
        end if;
    end loop;

/*324*/
    if v_prop_rec.property_involvement <> '05' then
       for i_324 in 1..10 loop
          if p_date(i_324) <> '77777777' then
             update_row_status(3,v_prop_rec.incident_number, 324 , v_agency);
          end if;
       end loop;
    end if;

/*326*/
    for i_326 in 1..10 loop
        if p_date(i_326) = '77777777' then
          for j_326 in i_326+1..10 loop
            if p_date(j_326) <> '77777777' then
                update_row_status(3,v_prop_rec.incident_number, 326, v_agency);
            end if;
          end loop;
        end if;
    end loop;

/*Motor vehicles*/
/*328*/
    if v_prop_rec.number_stolen_vehicles not in (777, 999) then
       if v_prop_rec.number_stolen_vehicles not between 000 and 501 then
          update_row_status(3,v_prop_rec.incident_number, 328, v_agency);
       end if;
    end if;

/*329*/
    v_found:= 0;
    if v_prop_rec.property_involvement = '07' then
       if v_prop_rec.number_stolen_vehicles between 001 and 501 then
          for i_329 in 1..10 loop
             if p_type(i_329) in ('31', '32', '33', '34', '37', '38') then
                v_found:=1;
             end if;
          end loop;
          if v_found <> 1 then
             update_row_status(3,v_prop_rec.incident_number, 329, v_agency);
          end if;
       end if;
    end if;

/*330*/
   if v_prop_rec.property_involvement <> '07' then
      if v_prop_rec.number_stolen_vehicles <> 777 then
          update_row_status(3,v_prop_rec.incident_number, 330, v_agency);
      end if;
   end if;

/*331*/
    vehicle_cnt := 0;
    if v_prop_rec.number_stolen_vehicles between 01 and 501 then
       for i_331 in 1..10 loop
           if p_type(i_331) between '30' and '38' then
              vehicle_cnt := vehicle_cnt + 1;
           end if;
       end loop;
       if vehicle_cnt > v_prop_rec.number_stolen_vehicles then
          update_row_status(3,v_prop_rec.incident_number, 331, v_agency);
       end if;
    end if;

/*332*/
    if v_prop_rec.number_recovered_vehicles not in (777, 999) then
       if v_prop_rec.number_recovered_vehicles not between 000 and 501 then
          update_row_status(3,v_prop_rec.incident_number, 332, v_agency);
       end if;
    end if;

/*333*/
    v_found := 0;
    if v_prop_rec.property_involvement = '05' then
       if v_prop_rec.number_recovered_vehicles between 000 and 501 then
          for i_333 in 1..10 loop
              if p_type(i_333) in ('31', '33', '34', '37', '38') then
                 v_found := 1;
               end if;
          end loop;
          if v_found <> 1 then
              update_row_status(3,v_prop_rec.incident_number, 333, v_agency);
          end if;
       end if;
   end if;

/*334*/
   if v_prop_rec.property_involvement <> '05' then
      if v_prop_rec.number_recovered_vehicles <> 777 then
          update_row_status(3,v_prop_rec.incident_number, 334, v_agency);
      end if;
   end if;

/*335*/
    vehicle_cnt := 0;
    if v_prop_rec.property_involvement = '05' then
      if v_prop_rec.number_recovered_vehicles between 000 and 501 then
         for i_335 in 1..10 loop
            if p_type(i_335) between '30' and '38' then
               vehicle_cnt := vehicle_cnt + 1;
            end if;
         end loop;
         if vehicle_cnt > v_prop_rec.number_recovered_vehicles then
            update_row_status(3,v_prop_rec.incident_number, 335, v_agency);
         end if;
      end if;
    end if;

/*Drug type*/
/*340*/
    if v_prop_rec.property_involvement = '06' then
      for i_340 in 1..10 loop
        if p_type(i_340) = '26' then
           v_found := 1;
         end if;
      end loop;

      if v_found = 1 then
         for i_3401 in 1..3 loop
           if p_drug_type(i_3401) not between '00' and '06' then
              if p_drug_type(i_3401) not in ('09', '10', '11', '19', '21', '22', '29',
                                        '31' ,'32', '33', '39', '41', '42' ,'49',
                                        '51', '52', '59', '61', '62', '63', '69',
                                        '97', '99') then
               update_row_status(3,v_prop_rec.incident_number, 340, v_agency);
              end if;
           end if;
         end loop;
      end if;
    end if;

/*342*/
     v_found := 0;
     if v_prop_rec.drug_type1 <> '00' then
        for i_342 in 1..10 loop
            if p_type(i_342) = '26' then
              v_found := 1;
            end if;
        end loop;
        if v_found = 0 then
            update_row_status(3,v_prop_rec.incident_number, 342, v_agency);
        end if;
     end if;

/*344*/
    if v_prop_rec.drug_type1 = '97' or
       v_prop_rec.drug_type2 = '97' then
       update_row_status(3,v_prop_rec.incident_number, 344, v_agency);
    end if;

/*348*/
    if v_prop_rec.drug_type3 = '97' then
       for i_348 in 1..2 loop
           if p_drug_type(i_348) in  ('00', '99') then
               update_row_status(3,v_prop_rec.incident_number, 348, v_agency);
           end if;
       end loop;
    end if;

/*352*/
    v_found := 0;
    if v_prop_rec.property_involvement = '06' then
      for i_352 in 1..10 loop
         if p_type(i_352) = '26' then
           v_found := 1;
         end if;
      end loop;
      if v_found = 1 then
       if (v_prop_rec.drug_type1 = v_prop_rec.drug_type2) and
          (v_prop_rec.drug_uom1 = v_prop_rec.drug_uom2) then
            update_row_status(3,v_prop_rec.incident_number, 352, v_agency);
       elsif
          (v_prop_rec.drug_type1 = v_prop_rec.drug_type3) and
          (v_prop_rec.drug_uom1 = v_prop_rec.drug_uom3) then
            update_row_status(3,v_prop_rec.incident_number, 352, v_agency);
          elsif
             (v_prop_rec.drug_type2 = v_prop_rec.drug_type3) and
             (v_prop_rec.drug_type3 <> '00') and
             (v_prop_rec.drug_uom2 = v_prop_rec.drug_uom3) then
              update_row_status(3,v_prop_rec.incident_number, 352, v_agency);
       end if;
      end if;
    end if;

/*354*/
    if v_prop_rec.drug_type3 = '97' then
       if v_prop_rec.drug_quantity1 <> '777777777777' then
          update_row_status(3,v_prop_rec.incident_number, 354, v_agency);
       end if;
    end if;

/*356*/
    if v_prop_rec.drug_type3 = '97' then
       if v_prop_rec.drug_uom3 <> 'NA' then
          update_row_status(3,v_prop_rec.incident_number, 356, v_agency);
       end if;
    end if;

/*358*/
    if v_prop_rec.drug_type1 = '00' then
       BEGIN
         if v_prop_rec.drug_type2 <> '00' then
            update_row_status(3,v_prop_rec.incident_number, 358, v_agency);
         end if;
         if v_prop_rec.drug_type3 <> '00' then
            update_row_status(3,v_prop_rec.incident_number, 358, v_agency);
         end if;
       END;
    end if;

/*360*/
    if v_prop_rec.drug_type1 = '00' then
       if v_prop_rec.drug_data_source <> '7' then
          update_row_status(3,v_prop_rec.incident_number, 360, v_agency);
       end if;
    end if;

/*362*/
    for i_362 in 1..3 loop
       if p_drug_type(i_362) = '00' then
          if p_drug_qty(i_362) <> '777777777777' then
             update_row_status(3,v_prop_rec.incident_number, 362, v_agency);
          end if;
       end if;
    end loop;

/*364*/
     for i_364 in 1..3 loop
       if p_drug_type(i_364) = '00' then
          if p_drug_uom(i_364) <> 'NA' then
             update_row_status(3,v_prop_rec.incident_number, 364, v_agency);
          end if;
       end if;
    end loop;

/*372*/
    if v_prop_rec.drug_type1 in ('01', '02','03','04','05','06','09','10','11','19','21','22','29',
                                 '31', '32', '33', '39', '41', '42','49','51','52','59','61','62','63',
                                 '69', '99')  then
       if v_prop_rec.drug_data_source = '7' then
          update_row_status(3,v_prop_rec.incident_number, 372 , v_agency);
        end if;
    end if;

/*374*/
     for i_374 in 1..3 loop
        if p_drug_type(i_374) in ('01', '02','03','04','05','06','09','10','11','19','21','22','29',
                              '31', '32', '33', '39', '41', '42','49','51','52','59','61','62','63',
                              '69', '99')  then
           if p_drug_qty(i_374) = '777777777777' then
              update_row_status(3,v_prop_rec.incident_number, 374, v_agency);
           end if;
        end if;
     end loop;

/*376*/
    for i_376 in 1..3 loop
       if p_drug_type(i_376) in ('01', '02','03','04','05','06','09','10','11','19','21','22','29',
                              '31', '32', '33', '39', '41', '42','49','51','52','59','61','62','63',
                              '69', '99')  then
          if p_drug_uom(i_376) = 'NA' then
             update_row_status(3,v_prop_rec.incident_number, 376, v_agency);
          end if;
       end if;
    end loop;


/*380*/
    for i_380 in 1..3 loop
       if p_drug_qty(i_380) = '777777777777' then
          if p_drug_uom(i_380) <> 'NA' then
              update_row_status(3,v_prop_rec.incident_number, 380, v_agency);
          end if;
       end if;
    end loop;

/*382*/
    for i_382 in 1..3 loop
       if p_drug_qty(i_382) in ('888888888888', '999999999999') then
          if p_drug_uom(i_382) <> 'XX' then
              update_row_status(3,v_prop_rec.incident_number, 382, v_agency);
          end if;
       end if;
    end loop;

/*drug uom*/
/*386*/
    for i_386 in 1..3 loop
      if p_drug_uom(i_386) not in ('GM', 'KG', 'OZ', 'LB', 'ML',
                               'LT', 'FL', 'GL', 'DU', 'NP',
                               'NA', 'XX') then
          update_row_status(3,v_prop_rec.incident_number, 386, v_agency);
        end if;
    end loop;

/*388*/
    for i_388 in 1..3 loop
       if p_drug_uom(i_388) = 'NA' then
          if p_drug_qty(i_388) <> '777777777777' then
              update_row_status(3,v_prop_rec.incident_number, 388, v_agency);
          end if;
       end if;
    end loop;

/*389*/
     for i_389 in 1..3 loop
       if p_drug_uom(i_389) = 'XX' then
          if p_drug_qty(i_389) not in ('888888888888', '999999999999') then
              update_row_status(3,v_prop_rec.incident_number, 389, v_agency);
          end if;
       end if;
    end loop;

/*390*/
     for i_390 in 1..2 loop
        if p_drug_uom(i_390) = 'NA' then
           if p_drug_uom(i_390+1) <> 'NA' then
              update_row_status(3,v_prop_rec.incident_number, 390, v_agency);
          end if;
       end if;
    end loop;
/*392*/
    for i_392 in 1..3 loop
        if p_drug_uom(i_392) = 'NP' then
           if p_drug_type(i_392) NOT IN ('04', '29', '51') then
              update_row_status(3,v_prop_rec.incident_number, 392, v_agency);
          end if;
       end if;
    end loop;

  END;
 END LOOP;
 COMMIT;
END property_edit;

/*********************************************************OFFENDER EDITS ***************************************************/
PROCEDURE offender_edit(v_agency in varchar2) is
 BEGIN
   DBMS_OUTPUT.PUT_LINE('------offender_edit');
  FOR v_offender_rec in OFFENDER_CURSOR(v_agency) loop
   EXIT When OFFENDER_CURSOR%notfound;
    BEGIN

/*394*/
    if v_offender_rec.offender_number not between '001' and '099' then
       if v_offender_rec.offender_number <> '999' then
          update_row_status(4,v_offender_rec.incident_number, 394, v_agency);
       end if;
    end if;

/*396 - 404*/
    if v_offender_rec.offender_number = '999' then
      BEGIN
       if v_offender_rec.offender_age <> '9999' then
          update_row_status(4,v_offender_rec.incident_number, 396, v_agency);
       end if;

       if v_offender_rec.offender_sex <> 'U' then
          update_row_status(4,v_offender_rec.incident_number, 398, v_agency);
       end if;

       if v_offender_rec.offender_race <> 'U' then
          update_row_status(4,v_offender_rec.incident_number, 400, v_agency);
       end if;

       if v_offender_rec.offender_ethnic_origin <> 'U' then
          update_row_status(4,v_offender_rec.incident_number, 402, v_agency);
       end if;

        if v_offender_rec.offender_condition <> '99' then
          update_row_status(4,v_offender_rec.incident_number, 404, v_agency);
        end if;
       END;
     end if;

/*Ofender age*/
/*406*/
     If v_offender_rec.offender_age not between '0001' and '0099' OR v_offender_rec.offender_age = '7777' then
           if substr(v_offender_rec.offender_age,1,2) > '00' and
              substr(v_offender_rec.offender_age,1,2) <= substr(v_offender_rec.offender_age,3,2)
              and v_offender_rec.offender_age != '7777' then
               null;
            else
              update_row_status(4,v_offender_rec.incident_number, 406, v_agency);
            end if;
      end if;
/*408*/
     if v_offender_rec.offender_sex not in ('M','F','U') then
         update_row_status(4,v_offender_rec.incident_number, 408, v_agency);
     end if;
/*offender Race */
/*410*/
      if v_offender_rec.offender_race not in ('W', 'B', 'I', 'A', 'U', 'R') then
         update_row_status(4,v_offender_rec.incident_number, 410, v_agency);
      end if;

/*412*/
      if v_offender_rec.offender_ethnic_origin not in ('H','N', 'U','R') then
         update_row_status(4,v_offender_rec.incident_number, 412, v_agency);
      end if;

/*414*/
      if v_offender_rec.offender_condition not in ('01', '02', '03', '04', '05', '88', '99') then
         update_row_status(4,v_offender_rec.incident_number, 414, v_agency);
      end if;
  END;
 END LOOP;
 COMMIT;
END offender_edit;

/****************************************VICTIM EDITS****************************************************************************/
PROCEDURE victim_edit(v_agency in varchar2) is

type victim_offense_TABLE IS TABLE OF VARCHAR2(2)
 index by binary_integer;
v_o_link   victim_offense_table;

type victim_offender_relation_table is table of varchar2(3)
  index by binary_integer;
v_r_link   victim_offender_relation_table;

type victim_offender_link_table is table of varchar2(3)
  index by binary_integer;
v_link   victim_offender_link_table;

type victim_injury_type_table is table of varchar2(2)
  index by binary_integer;
v_injury_type  victim_injury_type_table;

i number := 0;
j number := 0;

BEGIN
   DBMS_OUTPUT.PUT_LINE('------victim_edit');
  FOR v_victim_rec in VICTIM_CURSOR(v_agency) loop
   EXIT When VICTIM_CURSOR%notfound;
    BEGIN
  /* victim offense link */
       v_o_link(1) := v_victim_rec.victim_offense_link1;
       v_o_link(2) := v_victim_rec.victim_offense_link2;
       v_o_link(3) := v_victim_rec.victim_offense_link3;
       v_o_link(4) := v_victim_rec.victim_offense_link4;
       v_o_link(5) := v_victim_rec.victim_offense_link5;
       v_o_link(6) := v_victim_rec.victim_offense_link6;
       v_o_link(7) := v_victim_rec.victim_offense_link7;
       v_o_link(8) := v_victim_rec.victim_offense_link8;
       v_o_link(9) := v_victim_rec.victim_offense_link9;
       v_o_link(10) := v_victim_rec.victim_offense_link10;

   /* victim offender link*/
       v_link(1) := v_victim_rec.victim_offender_link1;
       v_link(2) := v_victim_rec.victim_offender_link2;
       v_link(3) := v_victim_rec.victim_offender_link3;
       v_link(4) := v_victim_rec.victim_offender_link4;
       v_link(5) := v_victim_rec.victim_offender_link5;
       v_link(6) := v_victim_rec.victim_offender_link6;
       v_link(7) := v_victim_rec.victim_offender_link7;
       v_link(8) := v_victim_rec.victim_offender_link8;
       v_link(9) := v_victim_rec.victim_offender_link9;
       v_link(10) := v_victim_rec.victim_offender_link10;

    /* vicitm offender relationship link */
       v_r_link(1) := v_victim_rec.victim_offender_relationship1;
       v_r_link(2) := v_victim_rec.victim_offender_relationship2;
       v_r_link(3) := v_victim_rec.victim_offender_relationship3;
       v_r_link(4) := v_victim_rec.victim_offender_relationship4;
       v_r_link(5) := v_victim_rec.victim_offender_relationship5;
       v_r_link(6) := v_victim_rec.victim_offender_relationship6;
       v_r_link(7) := v_victim_rec.victim_offender_relationship7;
       v_r_link(8) := v_victim_rec.victim_offender_relationship8;
       v_r_link(9) := v_victim_rec.victim_offender_relationship9;
       v_r_link(10) := v_victim_rec.victim_offender_relationship10;

       v_injury_type(1) := v_victim_rec.type_of_injury1;
       v_injury_type(2) := v_victim_rec.type_of_injury2;
       v_injury_type(3) := v_victim_rec.type_of_injury3;
       v_injury_type(4) := v_victim_rec.type_of_injury4;
       v_injury_type(5) := v_victim_rec.type_of_injury5;

/*416*/
       if v_victim_rec.victim_number not between '001' and '999' then
           update_row_status(5,v_victim_rec.incident_number, 416, v_agency);
       end if;

/* vicitm offense link*/
/*418*/
       for i in 1..10 loop
         if v_o_link(i) is null then
            update_row_status(5,v_victim_rec.incident_number, 418, v_agency);
         end if;
       end loop;

/*420*/
      for i in 1..10 loop
         if v_o_link(i) not between '01' and '75' then
            if v_o_link(i) <> '77' then
               update_row_status(5,v_victim_rec.incident_number, 420, v_agency);
            end if;
         end if;
      end loop;

/*422*/
      if v_victim_rec.victim_offense_link1 = '77' then
         update_row_status(5,v_victim_rec.incident_number, 422 , v_agency);
      end if;

/*424*/
      for i in 1..10 loop
          if v_o_link(i) = '77' then
            for j in i+1..10 loop
             if v_o_link(j) <> '77' then
                update_row_status(5,v_victim_rec.incident_number, 424, v_agency);
             end if;
            end loop;
          end if;
      end loop;

/*426*/
     for j in 1..10 loop
        for i in 1..10 loop
            if (v_o_link(j) = v_o_link(i)) and (j <> i)  and (v_o_link(j) <> '77') then
               update_row_status(5,v_victim_rec.incident_number, 426 , v_agency);
            end if;
        end loop;
     end loop;

/*victim type*/
/*428*/
     if v_victim_rec.victim_type not in ('I', 'B', 'F', 'G', 'L', 'S', 'O', 'U', 'A', 'R') then
        update_row_status(5,v_victim_rec.incident_number, 428, v_agency);
     end if;

/*430*/
     if v_victim_rec.victim_type not in ('I', 'L', 'A') then
       BEGIN
        if v_victim_rec.victim_age <> '7777' then
           update_row_status(5,v_victim_rec.incident_number, 430, v_agency);
        end if;

/*432*/
        if v_victim_rec.victim_sex <> 'X' then
           update_row_status(5,v_victim_rec.incident_number, 432, v_agency);
        end if;

/*434*/
        if v_victim_rec.victim_race <> 'X' then
           update_row_status(5,v_victim_rec.incident_number, 434, v_agency);
        end if;

/*436*/
        if v_victim_rec.victim_ethnic_origin <> 'X' then
           update_row_status(5,v_victim_rec.incident_number, 436 , v_agency);
        end if;

/*438*/
        if v_victim_rec.victim_residence_status <> '77' then
           update_row_status(5,v_victim_rec.incident_number, 438, v_agency);
        end if;

/*440*/
        for i in 1..10 loop
           if v_link(i) <> '777' then
              update_row_status(5,v_victim_rec.incident_number, 440, v_agency);
           end if;
        end loop;

/*442*/
        for i in 1..10 loop
           if v_r_link(i) <> '77' then
              update_row_status(5,v_victim_rec.incident_number, 442, v_agency);
           end if;
        end loop;

/*444*/
        if v_victim_rec.level_of_injury <> '7' then
            update_row_status(5,v_victim_rec.incident_number, 444, v_agency);
         end if;

/*446*/
        for i in 1..5 loop
            if v_injury_type(i) <> '77' then
                update_row_status(5,v_victim_rec.incident_number, 446, v_agency);
            end if;
        end loop;

/*448*/
        if v_victim_rec.victim_medical_treatment <> '7' then
            update_row_status(5,v_victim_rec.incident_number, 448, v_agency);
        end if;
       END;
     END IF;

/*450*/
     if v_victim_rec.victim_type in ('I', 'L', 'A') then
       BEGIN
        if v_victim_rec.victim_age = '7777' then
           update_row_status(5,v_victim_rec.incident_number, 450, v_agency);
        end if;

/*452*/
        if v_victim_rec.victim_sex = 'R' then
           update_row_status(5,v_victim_rec.incident_number, 452, v_agency);
        end if;

/*454*/
--        if v_victim_rec.victim_race = 'R' then
--           update_row_status(5,v_victim_rec.incident_number, 454, v_agency);
--        end if;

/*456*/
--        if v_victim_rec.victim_ethnic_origin = 'R' then
--           update_row_status(5,v_victim_rec.incident_number, 456, v_agency);
--        end if;


/*458*/
        if v_victim_rec.victim_residence_status = '77' then
           update_row_status(5,v_victim_rec.incident_number, 458, v_agency);
        end if;

/*460*/
        if v_victim_rec.victim_offender_link1 = '777' then
           update_row_status(5,v_victim_rec.incident_number, 460, v_agency);
        end if;

/*462*/
        if v_victim_rec.victim_offender_relationship1 = '77' then
           update_row_status(5,v_victim_rec.incident_number, 462, v_agency);
         end if;

/*464*/
        if v_victim_rec.level_of_injury = '7' then
           update_row_status(5,v_victim_rec.incident_number, 464, v_agency);
         end if;

/*466*/
        if v_victim_rec.type_of_injury1 = '77' then
           update_row_status(5,v_victim_rec.incident_number, 466 , v_agency);
        end if;


/*468*/
        if v_victim_rec.victim_medical_treatment = '7' then
            update_row_status(5,v_victim_rec.incident_number, 468 , v_agency);
        end if;
      END;
     END IF;

/*Victim age*/
/*470*/
       if v_victim_rec.victim_age not in ('00NN', '00NB', '00BB', '7777', '9999') then
          if v_victim_rec.victim_age not between '0001' and '9999' then
             update_row_status(5,v_victim_rec.incident_number, 470, v_agency);
          end if;
       end if;
       IF v_victim_rec.victim_age = '00NA' THEN
         update_row_status(5,v_victim_rec.incident_number, 470, v_agency);
       END IF;
/*Victim Sex*
/*472*/
       if v_victim_rec.victim_sex not in ('M', 'F', 'R', 'U', 'X') then
          update_row_status(5,v_victim_rec.incident_number, 472, v_agency);
       end if;

/*victim race*/

/*474*/
       if v_victim_rec.victim_race not in ('W','B','I','A','R','U') AND (v_victim_rec.victim_type IN ('I','A','L')) then
           update_row_status(5,v_victim_rec.incident_number, 474, v_agency);
       end if;

/*vicitm origin*/
/*476*/
      if v_victim_rec.victim_ethnic_origin not in ('H','N','R','U') AND (v_victim_rec.victim_type IN ('I','A','L')) then
          update_row_status(5,v_victim_rec.incident_number, 476 , v_agency);
      end if;

/*victim residence*/
/*478*/
      if v_victim_rec.victim_residence_status not between '01' and '08' then
         if v_victim_rec.victim_residence_status not in('77', '88', '99') then
             update_row_status(5,v_victim_rec.incident_number, 478, v_agency);
         end if;
      end if;

/*victim offender link*/
/*480*/
      for i in 1..10 loop
         if v_link(i) is null then
             update_row_status(5,v_victim_rec.incident_number, 480, v_agency);
         end if;
      end loop;

/*482*/
      for i in 2..10 loop
          if v_link(i) = '999' then
              update_row_status(5,v_victim_rec.incident_number, 482, v_agency);
           end if;
      end loop;
/*484*/
      if v_link(1) = '999' then
         for i in 2..10 loop
             if v_link(i) <> '777' then
                 update_row_status(5,v_victim_rec.incident_number, 484, v_agency);
             end if;
         end loop;
      end if;
/*486*/
      for i in 1..10 loop
         if v_link(i) = '777' then
           for j in i+1..10 loop
            if v_link(j) <> '777' then
                update_row_status(5,v_victim_rec.incident_number, 486, v_agency);
            end if;
           end loop;
         end if;
      end loop;
/*488*/
      for i in 1..10 loop
        for j in 1..10 loop
            if v_link(j) = v_link(i) and j <> i  and v_link(i) <> '777' then
                update_row_status(5,v_victim_rec.incident_number, 488, v_agency);
            end if;
        end loop;
      end loop;

/*490*/
     for i in 1..10 loop
        if v_r_link(i) not between '01' and '12' then
           if v_r_link(i) not between '20' and '30' then
              if v_r_link(i) not in ('40','41', '77', '88') then
                  update_row_status(5,v_victim_rec.incident_number, 490, v_agency);
              end if;
           end if;
        end if;
     end loop;
/*494*/
     for i in 1..10 loop
         if v_r_link(i) = '77' then
           for j in i+1..10 loop
            if v_r_link(j) <> '77' then
               update_row_status(5,v_victim_rec.incident_number, 494, v_agency);
            end if;
           end loop;
         end if;
     end loop;
/*496*/
     for i in 1..10 loop
         if v_r_link(i) in ('01', '02', '29') then
            if v_victim_rec.victim_age in ('00NN','00NB','00BB') then
               update_row_status(5,v_victim_rec.incident_number, 496, v_agency);
            elsif v_victim_rec.victim_age < '0010' then
                  update_row_status(5,v_victim_rec.incident_number, 496 , v_agency);
            end if;
         end if;
     end loop;
/*498*/
    for i in 1..10 loop
        if v_link(i) <> '777' then
           if v_r_link(i) = '77' then
               update_row_status(5,v_victim_rec.incident_number, 498 , v_agency);
           end if;
        end if;
    end loop;
/*500*/
    for i in 1..10 loop
        if v_link(i) = '777' then
           if v_r_link(i) <> '77' then
               update_row_status(5,v_victim_rec.incident_number, 500, v_agency);
           end if;
        end if;
    end loop;
/*502*/
    if v_victim_rec.victim_offender_link1 = '999' then
      BEGIN
       if v_victim_rec.victim_offender_relationship1 <> '40' then
          update_row_status(5,v_victim_rec.incident_number, 502, v_agency);
       end if;
       if v_victim_rec.victim_offender_relationship1 = '40' then
          for i in 2..10 loop
              if v_r_link(i) <> '77' then
                 update_row_status(5,v_victim_rec.incident_number, 502 , v_agency);
              end if;
          end loop;
       end if;
      END;
    end if;

/*level of injury*/
/*504*/
    if v_victim_rec.victim_type in ('I', 'L') then
       if v_victim_rec.level_of_injury not in ('1', '2', '3', '4', '8', '9') then
           update_row_status(5,v_victim_rec.incident_number, 504, v_agency);
       end if;
    end if;

/*type of injury*/
/*506*/
    if v_victim_rec.victim_type in ('I', 'L') then
       if v_victim_rec.type_of_injury1 not between '00' and '07' then
          if v_victim_rec.type_of_injury1 not in ('88', '99') then
              update_row_status(5,v_victim_rec.incident_number, 506, v_agency);
          end if;
       end if;
    end if;
/*508*/
    if v_victim_rec.victim_type in ('I', 'L') then
      for i in 2..4 loop
          if v_injury_type(i) not in ('01','02','03','04','05','06','07','77') then
             update_row_status(5,v_victim_rec.incident_number, 508, v_agency);
          end if;
      end loop;
    end if;
/*510*/
    for i in 1..5 loop
       for j in 1..5 loop
           if (v_injury_type(j) = v_injury_type(i)) and (i <> j) and (v_injury_type(j) <> '77') then
               update_row_status(5,v_victim_rec.incident_number, 510, v_agency);
           end if;
       end loop;
    end loop;
/*512*/
     if v_victim_rec.victim_type in ('I', 'L') then
        if v_victim_rec.victim_medical_treatment not in ('1', '2', '3', '4', '5', '8', '9') then
           update_row_status(5,v_victim_rec.incident_number, 512, v_agency);
        end if;
     end if;
   END;
  END LOOP;
 COMMIT;
END victim_edit;


/***********************************************ARRESTEE EDITS*******************************************************/

PROCEDURE arrestee_edit(v_agency in varchar2) is

v_ibr_date date;


 BEGIN
   DBMS_OUTPUT.PUT_LINE('------arrestee_edit');
  FOR v_arrestee_rec in ARRESTEE_CURSOR(v_agency) loop
   EXIT When ARRESTEE_CURSOR%notfound;
    BEGIN
/*514*/
    if v_arrestee_rec.arrestee_number not between '01' and '99' then
       update_row_status(6,v_arrestee_rec.incident_number, 514, v_agency);
    end if;
/*agency arrest number*/
/*518*/
   if v_arrestee_rec.agency_arrest_number is null then
      update_row_status(6,v_arrestee_rec.incident_number, 518 , v_agency);
    end if;
/*520*/

/*522*/
   if v_arrestee_rec.obts_number <> '777777777' then
      BEGIN
         if substr(v_arrestee_rec.obts_number,1,8) not between '00000000' and '99999999' then
            update_row_status(6,v_arrestee_rec.incident_number, 522, v_agency);
         end if;

         if (substr(v_arrestee_rec.obts_number,9,1) not between 'A' and 'Z') then
            if (substr(v_arrestee_rec.obts_number,9,1) not between 'a' and 'z') then
               update_row_status(6,v_arrestee_rec.incident_number, 522, v_agency);
            end if;
         end if;
      END;
   end if;
/*524*/
   if v_arrestee_rec.nysid_number <> '9999999J' then
     BEGIN
      if substr(v_arrestee_rec.nysid_number,1,7) not between '0000000' and '9999999' then
         update_row_status(6,v_arrestee_rec.incident_number, 524, v_agency);
      end if;
/*
      if (substr(v_arrestee_rec.nysid_number,8,1) not between 'A' and 'Z') then
         if (substr(v_arrestee_rec.nysid_number,8,1) not between 'a' and 'z') then
             update_row_status(6,v_arrestee_rec.incident_number, 524, v_agency);
         end if;
      end if;
*/
     END;
   end if;
/*arrest date */
/*525*/

     if substr(v_arrestee_rec.arrest_date,1,4) is null then
        update_row_status(6, v_arrestee_rec.incident_number, 525, v_agency);
      end if;

     if substr(v_arrestee_rec.arrest_date,5,2) is null then
        update_row_status(6, v_arrestee_rec.incident_number, 525, v_agency);
     end if;

     if substr(v_arrestee_rec.arrest_date,7,2) is null then
        update_row_status(6, v_arrestee_rec.incident_number, 525, v_agency);
     end if;

     if v_arrestee_rec.arrest_date = '77777777' then
        update_row_status(6, v_arrestee_rec.incident_number, 525, v_agency);
      end if;

/*526*/
    Select a.agcy_ibr_date into v_ibr_date from v_agency a
      where a.agcy_ori = v_agency;

     if v_arrestee_rec.arrest_date < to_char(v_ibr_date, 'YYYYMMDD') then
        update_row_status(6, v_arrestee_rec.incident_number, 526, v_agency);
     end if;

/*528*/
     If (v_arrestee_rec.arrest_date > to_char(sysdate,'YYYYMMDD')) AND (v_arrestee_rec.arrest_date != '77777777') then
         update_row_status(6, v_arrestee_rec.incident_number, 528, v_agency);
     end if;

/*arrest type */
/*530*/
     if v_arrestee_rec.arrest_type not between '01' and '06' then
        if v_arrestee_rec.arrest_type <>  '99' then
           update_row_status(6, v_arrestee_rec.incident_number, 530, v_agency);
        end if;
     end if;
 /*arrest status*/
/*532*/
     if v_arrestee_rec.arrestee_status not between '01' and '07' then
        if v_arrestee_rec.arrestee_status not in ('88', '99') then
           update_row_status(6, v_arrestee_rec.incident_number, 532, v_agency);
        end if;
     end if;
/*juvenile release*/
/*534*/
     if v_arrestee_rec.juvenile_release_status not in ('D', 'H', 'R', 'X') then
         update_row_status(6, v_arrestee_rec.incident_number, 534, v_agency);
     end if;

 /*536*/

     if v_arrestee_rec.arrestee_age < '16' then
        if v_arrestee_rec.juvenile_release_status not in ('D', 'H', 'R') then
            update_row_status(6, v_arrestee_rec.incident_number, 536, v_agency);
        end if;
     end if;
 /*538*/
     if v_arrestee_rec.arrestee_age > 15 then
        if v_arrestee_rec.juvenile_release_status <> 'X' then
            update_row_status(6, v_arrestee_rec.incident_number, 538, v_agency);
        end if;
     end if;
/*multiple clearance ind*/
/*540*/
     if v_arrestee_rec.multiple_clearance_ind not in ('M', 'C', 'N') then
        update_row_status(6, v_arrestee_rec.incident_number, 540, v_agency);
     end if;

/*arrestee weapons*/
/*542*/
     if v_arrestee_rec.arrestee_weapons1 not between '01' and '19' then
        if v_arrestee_rec.arrestee_weapons1 not in ('77', '88', '99') then
           update_row_status(6, v_arrestee_rec.incident_number, 542, v_agency);
        end if;
     end if;

/*544*/
      if v_arrestee_rec.arrestee_weapons2 not between '01' and '19' then
        if v_arrestee_rec.arrestee_weapons2 <> '77' then
           update_row_status(6, v_arrestee_rec.incident_number, 544, v_agency);
        end if;
     end if;

/*546*/
      if v_arrestee_rec.arrestee_weapons1 between '01' and '19' then
         if v_arrestee_rec.arrestee_weapons2 = v_arrestee_rec.arrestee_weapons1 then
             update_row_status(6, v_arrestee_rec.incident_number, 546, v_agency);
        end if;
     end if;
/*548*/
      if v_arrestee_rec.arrestee_weapons1 in ('77', '88', '99') then
         if v_arrestee_rec.arrestee_weapons2 <> '77' then
             update_row_status(6, v_arrestee_rec.incident_number, 548, v_agency);
        end if;
     end if;
/*arrestee age*/
/*550*/
     if v_arrestee_rec.arrestee_age not between '01' and '99' then
         update_row_status(6, v_arrestee_rec.incident_number, 550, v_agency);
     end if;
/*arrestee sex*/
/*552*/
     if v_arrestee_rec.arrestee_sex not in ('M', 'F') then
         update_row_status(6, v_arrestee_rec.incident_number, 552, v_agency);
     end if;
/*arrestee race*/
/*554*/
     if v_arrestee_rec.arrestee_race not in ('W', 'B', 'I', 'A', 'R', 'U') then
         update_row_status(6, v_arrestee_rec.incident_number, 554, v_agency);
     end if;
/*arrestree ethinic origin*/
/*556*/
     if v_arrestee_rec.arrestee_ethnic_origin not in ('H', 'N', 'R', 'U') then
        update_row_status(6, v_arrestee_rec.incident_number, 556, v_agency);
     end if;
/*arrestee residence status*/
/*558*/
      if v_arrestee_rec.arrestee_residence_status not in ('R','N','F','U') then
         update_row_status(6, v_arrestee_rec.incident_number, 558, v_agency);
      end if;
 END;
  END LOOP;
 COMMIT;
END arrestee_edit;

/***********************************************ARREST EDITS*******************************************************/

PROCEDURE arrest_edit(v_agency in varchar2) is

v_ibr_date date;


 BEGIN
   DBMS_OUTPUT.PUT_LINE('------arrest_edit');
  FOR v_arrest_rec in ARREST_CURSOR(v_agency) loop
   EXIT When ARREST_CURSOR%notfound;
    BEGIN
/*Arrestee charge link*/
/*560*/
   if v_arrest_rec.arrestee_charge_link not between '01' and '99' then
      update_row_status(7, v_arrest_rec.incident_number, 560, v_agency);
   end if;

/*564*/
   if substr(v_arrest_rec.arrest_charge,22,1) not in ('A', 'C') then
      update_row_status(7, v_arrest_rec.incident_number, 564, v_agency);
   end if;
/*566*/
   if v_arrest_rec.arrest_charge = 'PL 35.30             ' then
       update_row_status(7, v_arrest_rec.incident_number, 566, v_agency);
   end if;
/*Arrest larceny type*/
/*568*/
   if v_arrest_rec.arrest_larceny_type not between '01' and '10' then
      if v_arrest_rec.arrest_larceny_type not in ('77','88','99') then
          update_row_status(7, v_arrest_rec.incident_number, 568, v_agency);
      end if;
   end if;

/*570*/
  if v_arrest_rec.arrest_larceny_type <> '77' then
     if v_arrest_rec.ucr_code not in ('23A','23B','23C','23D','23E','23F','23G','23H','240') then
         update_row_status(7, v_arrest_rec.incident_number, 570, v_agency);
     end if;
  end if;
/*572*/
      if v_arrest_rec.ucr_code in ('23A','23B','23C','23D','23E','23F','23G','23H') then
          if v_arrest_rec.arrest_larceny_type = '77' then
             update_row_status(7, v_arrest_rec.incident_number, 572, v_agency);
          end if;
      end if;
   END;
 END LOOP;
 COMMIT;
END arrest_edit;
END IBR_EDITS;
/