CREATE OR REPLACE PACKAGE BODY IBRP."IBR_EDITS2"   IS
  v_rec_cnt         number := 0;
  v_row_cnt         number := 0;
  v_law_code        varchar2(21);
  v_test_code       varchar2(21);
  off_tble_cnt      number := 0;
  ofd_tble_cnt      number := 0;
  prop_tble_cnt     number := 0;
  vic_tble_cnt      number := 0;
  arrestee_tble_cnt number := 0;
  arrest_tble_cnt   number := 0;
  tot_amt           number := 0;
  k                 number := 0;
  v_age_sw          varchar2(1);
  v_rec_sw          number := 0;
  v_stolen_sw       number := 0;
  v_recovered_cars  number := 0;
  v_stolen_cars     number := 0;
  v_found           number := 0;
  v_notfound        number := 0;
  v_count           number := 0;
procedure update_status(v_table in number, v_adm_id in number, v_i_number in varchar2,  v_error_code in number,v_agency in varchar2) is
  v_message  ibr_error_message_lookup.error_message%type;
 BEGIN
   if v_table = 1 then
      update ibr_admin_segment a
        set row_status = 'E'
      where a.adm_id = v_adm_id
        and row_status is null;
   end if;
   if v_table = 2 then
      update ibr_offense_segment b
        set row_status = 'E'
      where b.adm_id = v_adm_id;
      update ibr_admin_segment a
        set row_status = 'E'
      where a.adm_id = v_adm_id
         and row_status is null;
   end if;
   if v_table = 3 then
      update ibr_property_segment c
        set row_status = 'E'
      where c.adm_id = v_adm_id;
      update ibr_admin_segment a
        set row_status = 'E'
      where a.adm_id = v_adm_id
         and row_status is null;
   end if;
   if v_table = 4 then
      update ibr_offender_segment d
        set row_status = 'E'
      where d.adm_id = v_adm_id;
      update ibr_admin_segment a
        set row_status = 'E'
      where a.adm_id = v_adm_id
         and row_status is null;
   end if;
   if v_table = 5 then
      update ibr_victim_segment e
        set row_status = 'E'
      where e.adm_id = v_adm_id;
      update ibr_admin_segment a
        set row_status = 'E'
      where a.adm_id = v_adm_id
         and row_status is null;
   end if;
   if v_table = 6 then
      update ibr_arrestee_segment f
        set row_status = 'E'
      where f.adm_id = v_adm_id;
      update ibr_admin_segment a
        set row_status = 'E'
      where a.adm_id = v_adm_id
        and row_status is null;
   end if;
   if v_table = 7 then
      update ibr_arrest_charge_segment g
        set row_status = 'E'
      where g.adm_id = v_adm_id;
      update ibr_admin_segment a
        set row_status = 'E'
      where a.adm_id = v_adm_id
         and row_status is null;
   end if;
   v_rec_cnt := 0;
/*
   select count(*) into v_rec_cnt from ibr_error err
     where err.incident_number = v_i_number
       and err.error_code = v_error_code||' '||v_message;
*/
   if v_rec_cnt = 0 then
      select error_message into v_message from ibr_error_message_lookup
        where v_error_code = error_number;
      insert into ibr_errors (incident_number, error_code,agcy_ori)
                      values    (v_i_number, v_error_code||' '||v_message,v_agency);
   end if;
 END;
PROCEDURE global_segact_edit(v_agency in varchar2) is
CURSOR ADM_CURSOR is
 Select *  from ibr_admin_segment
  where ori_number = v_agency
 for update;
 v_adm_rec  adm_cursor%rowtype;
 CURSOR OFFENSE_CURSOR is
 Select * from ibr_offense_segment
   where adm_id = v_adm_rec.adm_id
   for update;
v_off_rec OFFENSE_CURSOR%rowtype;
CURSOR PROPERTY_CURSOR is
 Select * from ibr_property_segment
   where adm_id = v_adm_rec.adm_id
   for update;
v_prop_rec PROPERTY_CURSOR%rowtype;
CURSOR OFFENDER_CURSOR is
 Select * from ibr_offender_segment
  where adm_id = v_adm_rec.adm_id
   for update;
v_ofd_rec OFFENDER_CURSOR%rowtype;
CURSOR VICTIM_CURSOR is
 Select * from ibr_victim_segment
  where adm_id = v_adm_rec.adm_id
   for update;
v_vic_rec  VICTIM_CURSOR%rowtype;
CURSOR ARRESTEE_CURSOR is
 Select * from ibr_arrestee_segment
  where (adm_id = v_adm_rec.adm_id) or
      (segment_action = 'A')
   for update;
v_arrestee_rec  ARRESTEE_CURSOR%rowtype;
CURSOR ARREST_CURSOR is
 Select * from ibr_arrest_charge_segment
  where (adm_id = v_adm_rec.adm_id) or
       (segment_action = 'A')
   for update;
v_arrest_rec  ARREST_CURSOR%rowtype;
type v_admin_table is table of adm_cursor%rowtype
 index by binary_integer;
type v_offense_table is table of offense_cursor%rowtype
 index by binary_integer;
v_off_tble       v_offense_table;
type v_property_table is table of property_cursor%rowtype
 index by binary_integer;
v_prop_tble      v_property_table;
type v_offender_table is table of offender_cursor%rowtype
 index by binary_integer;
v_ofd_tble       v_offender_table;
type v_victim_table is table of victim_cursor%rowtype
 index by binary_integer;
v_vic_tble       v_victim_table;
type v_arrestee_table is table of arrestee_cursor%rowtype
 index by binary_integer;
v_arrestee_tble   v_arrestee_table;
type v_vicoff_tble is table of varchar2(2)
 index by binary_integer;
v_vicoff_t   v_vicoff_tble;
type v_vicofd_tble is table of varchar2(3)
 index by binary_integer;
v_vicofd_t   v_vicofd_tble;
type v_vicrel_tble is table of varchar2(2)
 index by binary_integer;
v_vicrel_t   v_vicrel_tble;
type v_proprdte_tble is table of varchar2(8)
 index by binary_integer;
type v_stolen_prop_type_table is table of varchar2(2)
 index by binary_integer;
v_stolen_type_t v_stolen_prop_type_table;
type v_recovered_prop_type_table is table of varchar2(2)
 index by binary_integer;
type v_stolen_prop_value_table is table of varchar2(9)
 index by binary_integer;
v_stolen_value_t v_stolen_prop_value_table;
type v_recovered_prop_value_table is table of varchar2(9)
 index by binary_integer;
BEGIN
 DBMS_OUTPUT.PUT_LINE('------global_segact_edit');
 OPEN adm_cursor;
  LOOP
   FETCH adm_cursor into v_adm_rec;
     EXIT when adm_cursor%notfound;
     BEGIN
/*600*/
       if v_adm_rec.segment_action not in ('I', 'R', 'D', 'W', 'U') then
          update_status(1, v_adm_rec.adm_id, v_adm_rec.incident_number, 600,v_agency);
       end if;
/*617*/
       if v_adm_rec.segment_type not between '1' and '8' then
          update_status(1, v_adm_rec.adm_id, v_adm_rec.incident_number, 617,v_agency);
       end if;
/*618*/
      if v_adm_rec.segment_action  in ('I', 'R') then
        BEGIN
          Select count(*) into v_rec_cnt from ibr_admin_segment
           where incident_number = v_adm_rec.incident_number;
          If v_rec_cnt > 1 then
             update_status(1, v_adm_rec.adm_id, v_adm_rec.incident_number, 618,v_agency);
          end if;
        END;
      end if;
/*620
      if v_adm_rec.segment_action  in ('I', 'R') then
        BEGIN
          Select count(*) into v_rec_cnt from ibr_offense_segment
           where incident_number = v_adm_rec.incident_number;
          --dbms_output.put_line(v_adm_rec.incident_number||' '||v_rec_cnt);
          If v_rec_cnt = 0 or v_rec_cnt is null then
             update_status(1, v_adm_rec.adm_id, v_adm_rec.incident_number, 620 AT LEAST ONE OFFENSE SEGMENT (O-SEGTYPE=2) IS REQUIRED FOR I OR R SUBMISSION',v_agency);
          end if;
        END;
      end if;
*/
/*790*/
      if v_adm_rec.incident_case_status = '01' then
        BEGIN
          Select count(*)into v_rec_cnt from ibr_arrestee_segment
           where adm_id = v_adm_rec.adm_id
             and incident_number = v_adm_rec.incident_number
             and arrestee_age > '15';
          if v_rec_cnt < 1 AND v_adm_rec.segment_action  NOT IN ('U')then
             update_status(1, v_adm_rec.adm_id, v_adm_rec.incident_number, 790,v_agency);
          end if;
        END;
      end if;
     off_tble_cnt := 0;
/* Offense segment*/
      OPEN offense_cursor;
      LOOP
       FETCH offense_cursor into v_off_rec;
        EXIT when offense_cursor%notfound;
        BEGIN
          off_tble_cnt := off_tble_cnt + 1;                                         /* load cursor row into table */
          v_off_tble(off_tble_cnt) := v_off_rec;
       --   dbms_output.put_line('off'||v_adm_rec.incident_number);
/*622*/
         Select count(*) into v_rec_cnt from sjs.incidentcharges
          where i_id = v_adm_rec.incident_number and agcy_ori = v_agency;
         if v_rec_cnt > 10 then
            update_status(2,  v_off_rec.adm_id, v_off_rec.incident_number, 622,v_agency);
         end if;
/*600*/
        if v_off_rec.segment_action not in  ('I', 'R','W','U') then
          update_status(2,  v_off_rec.adm_id, v_off_rec.incident_number, 600,v_agency);
        end if;
/*617*/
        if v_off_rec.segment_type <> '2' then
          update_status(2, v_off_rec.adm_id, v_off_rec.incident_number, 617,v_agency);
        end if;
/*602*/
        if v_off_rec.segment_action <> v_adm_rec.segment_action then
          update_status(2, v_off_rec.adm_id, v_off_rec.incident_number, 602,v_agency);
        end if;
       if v_off_rec.segment_action not in ('W', 'U') then
        BEGIN
/*691*/
        if v_off_rec.ucr_code = '220' then
           BEGIN
             if instr(v_off_rec.incident_offense_code,'A',22,1) > 0 then
               Select count(property_involvement) into v_rec_cnt from ibr_property_segment
               where adm_id = v_off_rec.adm_id
                 and incident_number = v_off_rec.incident_number
                 and property_involvement in ('01','04','88', '99');
            end if;
            if v_rec_cnt < 1 then
               update_status(2,v_off_rec.adm_id, v_off_rec.incident_number, 691,v_agency);
            end if;
           END;
        end if;
/*692*/
        if v_off_rec.ucr_code = '35B' then
           BEGIN
             if instr(v_off_rec.incident_offense_code,'C',22,1) > 0 then
              Select count(*) into v_rec_cnt from ibr_property_segment
               where adm_id = v_off_rec.adm_id
                 and incident_number = v_off_rec.incident_number
                 and property_involvement in ('01', '06');
             end if;
             if v_rec_cnt < 1 then
               update_status(2,v_off_rec.adm_id, v_off_rec.incident_number, 692,v_agency);
             end if;
           END;
        end if;
/*693*/
        if v_off_rec.ucr_code = '35A' then
          BEGIN
           if instr(v_off_rec.incident_offense_code,'C',22,1) > 0 then
             Select count(*) into v_rec_cnt from ibr_property_segment
               where adm_id = v_off_rec.adm_id
                 and incident_number = v_off_rec.incident_number
                 and property_involvement = '06'
                 and drug_type1 = '00'
                 and ((property_type1 = 26) or
                     (property_type2 = 26) or
                     (property_type3 = 26) or
                     (property_type4 = 26) or
                     (property_type5 = 26) or
                     (property_type6 = 26) or
                     (property_type7 = 26) or
                     (property_type8 = 26) or
                     (property_type9 = 26) or
                     (property_type10 = 26));
             if v_rec_cnt > 0 then
                update_status(2,v_off_rec.adm_id, v_off_rec.incident_number, 693,v_agency);
             end if;
           end if;
         END;
        end if;
/*694*/
      if instr(v_off_rec.incident_offense_code,'C',22,1) > 0 then
        if v_off_rec.ucr_code in ('35A','39A','39B','39C','39D') then
          BEGIN
            Select count(*) into v_rec_cnt from ibr_property_segment
              where adm_id = v_off_rec.adm_id
                and incident_number = v_off_rec.incident_number
                and property_involvement = '06';
           if v_rec_cnt < 1 then
              update_status(2,v_off_rec.adm_id, v_off_rec.incident_number, 694,v_agency);
           end if;
          END;
        end if;
      end if;
/*696*/
        if v_off_rec.ucr_code = '90A' then
          BEGIN
           if instr(v_off_rec.incident_offense_code,'C',22,1) > 0 then
              Select count(*) into v_rec_cnt from ibr_property_segment
               where adm_id = v_off_rec.adm_id
                 and incident_number = v_off_rec.incident_number
                 and property_involvement in ('06','03','05','07','88','99');
           end if;
           if v_rec_cnt < 1 then
              update_status(2,v_off_rec.adm_id, v_off_rec.incident_number, 696,v_agency);
           end if;
          END;
        end if;
/*697*/
       if v_off_rec.ucr_code = '220' then
          BEGIN
           if instr(v_off_rec.incident_offense_code,'C',22,1) > 0 then
              Select count(*) into v_rec_cnt from ibr_property_segment
               where adm_id = v_off_rec.adm_id
                 and incident_number = v_off_rec.incident_number
                 and property_involvement in ('01','04','05','07','88','99');
           end if;
           if v_rec_cnt < 1 then
              update_status(2,v_off_rec.adm_id, v_off_rec.incident_number, 697,v_agency);
           end if;
          END;
        end if;
/*698*/
        if v_off_rec.ucr_code in ('100','510') then
          BEGIN
           if instr(v_off_rec.incident_offense_code,'C',22,1) > 0 then
              Select count(*) into v_rec_cnt from ibr_property_segment
               where adm_id = v_off_rec.adm_id
                 and incident_number = v_off_rec.incident_number
                 and property_involvement in ('01','05','07','88','99');
           end if;
           if v_rec_cnt < 1 then
              update_status(2,v_off_rec.adm_id, v_off_rec.incident_number, 698,v_agency);
           end if;
          END;
        end if;
/*699*/
        if v_off_rec.ucr_code = '26C' then
          BEGIN
           if instr(v_off_rec.incident_offense_code,'C',22,1) > 0 then
              Select count(*) into v_rec_cnt from ibr_property_segment
               where adm_id = v_off_rec.adm_id
                 and incident_number = v_off_rec.incident_number
                 and property_involvement in ('01','05','06','07','88','99');
           end if;
           if v_rec_cnt < 1 then
              update_status(2,v_off_rec.adm_id, v_off_rec.incident_number, 699,v_agency);
           end if;
          END;
        end if;
/*700*/
       if v_off_rec.ucr_code in ('120','210','240','270','23A','23B','23C','23D','23E','23F','23G','23H',
                                '26A','26B','26D','26E') then
          BEGIN
           if instr(v_off_rec.incident_offense_code,'C',22,1) > 0 then
              Select count(*) into v_rec_cnt from ibr_property_segment
               where adm_id = v_off_rec.adm_id
                 and incident_number = v_off_rec.incident_number
                 and property_involvement in ('05','07');
           end if;
           if v_rec_cnt < 1 then
              update_status(2,v_off_rec.adm_id, v_off_rec.incident_number, 700,v_agency);
           end if;
          END;
        end if;
/*702*/
       if v_off_rec.ucr_code = '200' then
          BEGIN
           if instr(v_off_rec.incident_offense_code,'C',22,1) > 0 then
              Select count(*) into v_rec_cnt from ibr_property_segment
               where adm_id = v_off_rec.adm_id
                 and incident_number = v_off_rec.incident_number
                 and property_involvement = '02'
                 and (property_type1 in ('31','33','34','36','37','38','41','42','43','44','45','46','47')) or
                     (property_type2 in ('31','33','34','36','37','38','41','42','43','44','45','46','47')) or
                     (property_type3 in ('31','33','34','36','37','38','41','42','43','44','45','46','47')) or
                     (property_type4 in ('31','33','34','36','37','38','41','42','43','44','45','46','47')) or
                     (property_type5 in ('31','33','34','36','37','38','41','42','43','44','45','46','47')) or
                     (property_type6 in ('31','33','34','36','37','38','41','42','43','44','45','46','47')) or
                     (property_type7 in ('31','33','34','36','37','38','41','42','43','44','45','46','47')) or
                     (property_type8 in ('31','33','34','36','37','38','41','42','43','44','45','46','47')) or
                     (property_type9 in ('31','33','34','36','37','38','41','42','43','44','45','46','47')) or
                     (property_type10 in ('31','33','34','36','37','38','41','42','43','44','45','46','47'));
           end if;
           if v_rec_cnt < 1 then
              update_status(2,v_off_rec.adm_id, v_off_rec.incident_number, 702,v_agency);
           end if;
          END;
       end if;
/*704*/
       if v_off_rec.ucr_code = '250' then
          BEGIN
           if instr(v_off_rec.incident_offense_code,'C',22,1) > 0 then
              Select count(*) into v_rec_cnt from ibr_property_segment
               where adm_id = v_off_rec.adm_id
                 and incident_number = v_off_rec.incident_number
                 and property_involvement in ('03','05','06');
           end if;
           if v_rec_cnt < 1 then
              update_status(2,v_off_rec.adm_id, v_off_rec.incident_number, 704,v_agency);
           end if;
          END;
       end if;
/*706*/
       if v_off_rec.ucr_code = '280' then
          BEGIN
           if instr(v_off_rec.incident_offense_code,'C',22,1) > 0 then
              Select count(*) into v_rec_cnt from ibr_property_segment
               where adm_id = v_off_rec.adm_id
                 and incident_number = v_off_rec.incident_number
                 and property_involvement in ('05','06','07');
           end if;
           if v_rec_cnt < 1 then
              update_status(2,v_off_rec.adm_id, v_off_rec.incident_number, 706,v_agency);
           end if;
          END;
       end if;
/*708*/
       if v_off_rec.ucr_code = '290' then
          BEGIN
           if instr(v_off_rec.incident_offense_code,'C',22,1) > 0 then
              Select count(*) into v_rec_cnt from ibr_property_segment
               where adm_id = v_off_rec.adm_id
                 and incident_number = v_off_rec.incident_number
                 and property_involvement in ('02','04');
           end if;
           if v_rec_cnt < 1 then
              update_status(2,v_off_rec.adm_id, v_off_rec.incident_number, 708,v_agency);
           end if;
          END;
       end if;
/*728 */
       if v_off_rec.ucr_code = '240'  OR v_off_rec.incident_larceny_type = '10' then
          BEGIN
           if instr(v_off_rec.incident_offense_code,'C',22,1) > 0 then
              Select count(*) into v_rec_cnt from ibr_property_segment
               where adm_id = v_off_rec.adm_id
                 and incident_number = v_off_rec.incident_number
                 and property_involvement ='07'
                 and (property_type1 in ('31','33','34','37','38')) or
                     (property_type2 in ('31','33','34','37','38')) or
                     (property_type3 in ('31','33','34','37','38')) or
                     (property_type4 in ('31','33','34','37','38')) or
                     (property_type5 in ('31','33','34','37','38')) or
                     (property_type6 in ('31','33','34','37','38')) or
                     (property_type7 in ('31','33','34','37','38')) or
                     (property_type8 in ('31','33','34','37','38')) or
                     (property_type9 in ('31','33','34','37','38')) or
                     (property_type10 in ('31','33','34','37','38'));
           end if;
           if v_rec_cnt < 1 then
              update_status(2,v_off_rec.adm_id, v_off_rec.incident_number, 728,v_agency);
           end if;
          END;
       end if;
/*732*/
       if v_off_rec.ucr_code = '240'  OR v_off_rec.incident_larceny_type = '10' then
          BEGIN
           if instr(v_off_rec.incident_offense_code,'C',22,1) > 0 then
              Select count(*) into v_rec_cnt from ibr_property_segment
               where adm_id = v_off_rec.adm_id
                 and incident_number = v_off_rec.incident_number
                 and property_involvement ='07'
                 and number_stolen_vehicles <> '777';
           end if;
           if v_rec_cnt < 1 then
              update_status(2,v_off_rec.adm_id, v_off_rec.incident_number, 732,v_agency);
           end if;
          END;
       end if;
/*742*/
      if v_off_rec.ucr_code = '35A' then
       if instr(v_off_rec.incident_offense_code,'C',22,1) > 0 then
        BEGIN
         Select count(*) into v_rec_cnt from ibr_property_segment
          where adm_id = v_off_rec.adm_id
            and property_involvement = '06'
            and drug_data_source in ('1', '2', '9')
            and ((property_type1 = '26') or
                (property_type2 = '26') or
                (property_type3 = '26') or
                (property_type4 = '26') or
                (property_type5 = '26') or
                (property_type6 = '26') or
                (property_type7 = '26') or
                (property_type8 = '26') or
                (property_type9 = '26') or
                (property_type10 = '26'));
--Begin Added BY CI 08/29/2001 for bug no 49
            if v_rec_cnt < 1 then
			 update_status(2,v_off_rec.adm_id, v_off_rec.incident_number, 742,v_agency);
            end if;
--End Added BY CI 08/29/2001 for bug no 49
        END;
       end if;
      end if;
    END;                   /* test for segment action */
     end if;
     END;                   /* end outmost begin*/
    END LOOP;               /* end outmost for*/
/* 576, 577*/
    BEGIN
     v_law_code := null;
     if off_tble_cnt > 0 then
        if v_off_tble(1).segment_action in ('W', 'U') then
           v_law_code := rtrim(substr(v_off_tble(1).incident_offense_code,1,3))||
                         rtrim(substr(v_off_tble(1).incident_offense_code,4,9))||
                         rtrim(substr(v_off_tble(1).incident_offense_code,13,6))||
                         substr(v_off_tble(1).incident_offense_code,19,1)||
                         substr(v_off_tble(1).incident_offense_code,20,1)||
                         substr(v_off_tble(1).incident_offense_code,21,1);
         end if;
      end if;
/* 576  577 */
     v_test_code := null;
     if off_tble_cnt > 0 then
        if v_off_tble(1).segment_action in ('W', 'U') then
           if v_off_tble(1).ucr_code <> '09C' then
              if substr(v_off_tble(1).incident_offense_code,22,1) not in ('A', 'C') then
                 update_status(2, v_off_tble(1).adm_id, v_off_tble(1).incident_number, 577 ,v_agency);
              elsif substr(v_off_tble(1).incident_offense_code,22,1) = 'A' then
--                    select sjslawatt into v_test_code from qry_tmp_nys_lawinfo_att
--                          where sjslawatt = v_law_code;
                      v_test_code := v_law_code;
                    if v_test_code is null then
                       update_status(2, v_off_tble(1).adm_id, v_off_tble(1).incident_number, 576 ,v_agency);
                    end if;
                 else
--                    select sjslawcom into v_test_code from qry_tmp_nys_lawinfo_com
--                          where sjslawcom = v_law_code;
                      v_test_code := v_law_code;
                    if v_test_code is null then
                       update_status(2, v_off_tble(1).adm_id, v_off_tble(1).incident_number, 576 ,v_agency);
                    end if;
              end if;
            end if;
          end if;
       end if;
     END;
 /* 580  581 */
    BEGIN
     v_test_code := null;
     if off_tble_cnt > 0 then
        if v_off_tble(1).segment_action in ('W', 'U') then
           For off_cnt_580 in 2..off_tble_cnt loop
            if v_off_tble(off_cnt_580).ucr_code <> '09C' then
               if v_off_tble(off_cnt_580).incident_offense_code is not null then
                  if substr(v_off_tble(off_cnt_580).incident_offense_code,22,1) = 'A' then
--                     select sjslawatt into v_test_code from qry_tmp_nys_lawinfo_att
--                     where sjslawatt = v_law_code;
                      v_test_code := v_law_code;
                     if v_test_code is null then
                       update_status(2, v_off_tble(1).adm_id, v_off_tble(1).incident_number, 580 ,v_agency);
                     end if;
                  else
--                    select sjslawcom into v_test_code from qry_tmp_nys_lawinfo_com
--                    where sjslawcom = v_law_code;
                      v_test_code := v_law_code;
                    if v_test_code is null then
                       update_status(2, v_off_tble(1).adm_id, v_off_tble(1).incident_number, 580 ,v_agency);
                    end if;
                 end if;
              end if;
           end if;
          End loop;
       end if;
      end if;
    END;
/* 578 */  /* 07/17/00 */
    BEGIN
     if off_tble_cnt > 0 then
      if v_off_tble(1).segment_action in ('W', 'U') then
         if  v_off_tble(1).incident_larceny_type not between '01' and '09' then
                 if  v_off_tble(1).incident_larceny_type not in ('77', '88', '99') then
                     update_status(2, v_off_tble(1).adm_id, v_off_tble(1).incident_number, 578 ,v_agency);
                 end if;
             end if;
         end if;
     end if;
   END;
 /* 582 */  /* 07/17/00 */
    BEGIN
     if off_tble_cnt > 1 then
      if v_off_tble(1).segment_action in ('W', 'U') then
         for off_cnt_582 in 2..off_tble_cnt loop
          if v_off_tble(off_cnt_582).incident_larceny_type not in ('01', '02', '03', '04', '05', '06',
                                                                   '07', '08', '09', '77', '  ') then
             update_status(2, v_off_tble(1).adm_id, v_off_tble(1).incident_number, 578 ,v_agency);
          end if;
         end loop;
       end if;
     end if;
   END;
/*624  626*/                    /*after rows are loaded into table */
     BEGIN
      FOR off_cnt_624 in 1..off_tble_cnt loop
          if off_cnt_624 <> off_tble_cnt then
            if (v_off_tble(off_cnt_624).offense_number = v_off_tble(off_cnt_624+1).offense_number) then
               update_status(2, v_off_tble(off_cnt_624).adm_id, v_off_tble(off_cnt_624).incident_number, 624 ,v_agency);
            end if;
          end if;
       end loop;
       For off_cnt_626 in 1..off_tble_cnt loop
          if off_cnt_626 <> off_tble_cnt then
             if (v_off_tble(off_cnt_626).incident_offense_code = v_off_tble(off_cnt_626+1).incident_offense_code) and
                (v_off_tble(off_cnt_626).incident_larceny_type = v_off_tble(off_cnt_626+1).incident_larceny_type) then
                 update_status(2, v_off_tble(off_cnt_626).adm_id, v_off_tble(off_cnt_626).incident_number, 626,v_agency);
             end if;
          end if;
       end loop;
/*766*/
       <<edit_766>>
       for off_cnt_766 in 1..off_tble_cnt loop
         if v_off_tble(off_cnt_766).ucr_code = '120' then
            BEGIN
             Select count(*) into v_rec_cnt from ibr_victim_segment
              where adm_id = v_off_tble(off_cnt_766).adm_id
                and victim_type in ('I','L')
                and ((victim_offense_link1 = v_off_tble(off_cnt_766).offense_number) or
                    (victim_offense_link2 = v_off_tble(off_cnt_766).offense_number) or
                    (victim_offense_link3 = v_off_tble(off_cnt_766).offense_number) or
                    (victim_offense_link4 = v_off_tble(off_cnt_766).offense_number) or
                    (victim_offense_link5 = v_off_tble(off_cnt_766).offense_number) or
                    (victim_offense_link6 = v_off_tble(off_cnt_766).offense_number) or
                    (victim_offense_link7 = v_off_tble(off_cnt_766).offense_number) or
                    (victim_offense_link8 = v_off_tble(off_cnt_766).offense_number) or
                    (victim_offense_link9 = v_off_tble(off_cnt_766).offense_number) or
                    (victim_offense_link10 = v_off_tble(off_cnt_766).offense_number));
                if v_rec_cnt > 0 then
                   exit edit_766;
                end if;
            END;
            if v_rec_cnt = 0 and v_adm_rec.segment_action in ('I', 'R') then
               update_status(2, v_off_rec.adm_id, v_off_rec.incident_number, 766,v_agency);
            end if;
        end if;
       end loop;
    END;                                          /* end out most begin*/
    CLOSE OFFENSE_CURSOR;
    prop_tble_cnt := 0;
/* property segment processing*/
     OPEN property_cursor;
      LOOP
       Fetch property_cursor into v_prop_rec;
        EXIT when property_cursor%notfound;
        BEGIN
          prop_tble_cnt := prop_tble_cnt+1;                                              /* load property cursor row into table */
          v_prop_tble(prop_tble_cnt):= v_prop_rec;
       --   dbms_output.put_line('prop'||v_adm_rec.incident_number);
/*600*/
        if v_prop_rec.segment_action not in ('I', 'R', 'W', 'U') then
          update_status(3, v_prop_tble(prop_tble_cnt).adm_id, v_prop_tble(prop_tble_cnt).incident_number, 600,v_agency);
        end if;
/*617*/
        if v_prop_rec.segment_type <> '3' then
           update_status(3, v_prop_tble(prop_tble_cnt).adm_id, v_prop_tble(prop_tble_cnt).incident_number, 617,v_agency);
        end if;
       END;                       /*end fetch begin*/
      END LOOP;                   /*end cursor for loop*/
                                  /*after cursor rows placed into table*/
      BEGIN
        v_rec_sw := 0;
        v_stolen_sw := 0;
/*632*/
        If prop_tble_cnt > 6 then
            update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 632,v_agency);
        end if;
      /*690*/
       v_found := 0;
       for off_cnt_690 in 1..off_tble_cnt loop
         if v_off_tble(off_cnt_690).ucr_code in ('200', '90A', '510','250','290','270','210','26A','26B','26C','26D','26E',
                                               '23A', '23B','23C','23D', '23E','23F','23G','23H','240','120','280',
                                               '35A','35B','39A','39B','39C','39D','100') then
            if instr(v_off_tble(off_cnt_690).incident_offense_code,'A',22,1) > 0 then
              v_found := 1;
              For prop_cnt_690 in 1..prop_tble_cnt loop
               if v_prop_tble(prop_cnt_690).property_involvement = 01 then
                 v_found := 0;
                 exit;
               end if;
              end loop;
            end if;
         end if;
       end loop;
       if v_found = 1 then
         update_status(2, v_off_tble(1).adm_id, v_off_tble(1).incident_number, 690,v_agency);
       end if;
/*630*/
        if prop_tble_cnt > 0 then
          For prop_cnt_630 in 1..prop_tble_cnt loop
            if (prop_cnt_630<>prop_tble_cnt) and (v_prop_tble(prop_cnt_630).property_involvement = v_prop_tble(prop_cnt_630+1).property_involvement) then
                update_status(3, v_prop_tble(prop_cnt_630).adm_id, v_prop_tble(prop_cnt_630).incident_number, 630,v_agency) ;
            end if;
            if  v_prop_tble(prop_cnt_630).property_involvement = '05' then
                if v_prop_tble(prop_cnt_630).number_recovered_vehicles <> 777 then
                   v_recovered_cars := v_prop_tble(prop_cnt_630).number_recovered_vehicles;
                   v_rec_sw := 1;
                end if;
            end if;
            if  v_prop_tble(prop_cnt_630).property_involvement = '07' then
                if v_prop_tble(prop_cnt_630).number_stolen_vehicles <> 777 then
                   v_stolen_cars := v_prop_tble(prop_cnt_630).number_stolen_vehicles;
                   v_stolen_sw:= 1;
                end if;
            end if;
          end loop;
          if v_rec_sw = 1 then
            if v_stolen_sw = 1 then
               if v_recovered_cars > v_stolen_cars then
                  update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 740 ,v_agency);
               end if;
            end if;
          end if;
 /*884*/ <<edit_884>>
        v_found := 0;
        tot_amt := 0;
        for off_cnt_884 in 1..off_tble_cnt loop
           if substr(v_off_tble(off_cnt_884).incident_offense_code,1,14) = 'PL 145.05     ' then
             <<inner_884>>
              For prop_cnt_884 in 1..prop_tble_cnt loop
                  if v_prop_tble(prop_cnt_884).property_involvement in ('02','04') then
                      v_stolen_value_t(1) := v_prop_tble(prop_cnt_884).property_value1;
                      v_stolen_value_t(2) := v_prop_tble(prop_cnt_884).property_value2;
                      v_stolen_value_t(3) := v_prop_tble(prop_cnt_884).property_value3;
                      v_stolen_value_t(4) := v_prop_tble(prop_cnt_884).property_value4;
                      v_stolen_value_t(5) := v_prop_tble(prop_cnt_884).property_value5;
                      v_stolen_value_t(6) := v_prop_tble(prop_cnt_884).property_value6;
                      v_stolen_value_t(7) := v_prop_tble(prop_cnt_884).property_value7;
                      v_stolen_value_t(8) := v_prop_tble(prop_cnt_884).property_value8;
                      v_stolen_value_t(9) := v_prop_tble(prop_cnt_884).property_value9;
                      v_stolen_value_t(10) := v_prop_tble(prop_cnt_884).property_value10;
                      v_found := 1;
                      for j_884 in 1..10 loop
                         if v_stolen_value_t(j_884) <> '777777777' then
                            tot_amt := tot_amt + to_number(v_stolen_value_t(j_884));
                         end if;
                      end loop;
                      exit inner_884;
                  end if;
              end loop inner_884;
              if v_found = 1 then
                 if tot_amt < 251 then
                    update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 884,v_agency);
                 end if;
              else
                 update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 884,v_agency);
              end if;
           end if;
         end loop edit_884;
 /*886*/ <<edit_886>>
        v_found := 0;
        tot_amt := 0;
        for off_cnt_886 in 1..off_tble_cnt loop
           if substr(v_off_tble(off_cnt_886).incident_offense_code,1,14) = 'PL 145.10     ' then
             <<inner_886>>
              For prop_cnt_886 in 1..prop_tble_cnt loop
                  if v_prop_tble(prop_cnt_886).property_involvement in ('02','04') then
                      v_stolen_value_t(1) := v_prop_tble(prop_cnt_886).property_value1;
                      v_stolen_value_t(2) := v_prop_tble(prop_cnt_886).property_value2;
                      v_stolen_value_t(3) := v_prop_tble(prop_cnt_886).property_value3;
                      v_stolen_value_t(4) := v_prop_tble(prop_cnt_886).property_value4;
                      v_stolen_value_t(5) := v_prop_tble(prop_cnt_886).property_value5;
                      v_stolen_value_t(6) := v_prop_tble(prop_cnt_886).property_value6;
                      v_stolen_value_t(7) := v_prop_tble(prop_cnt_886).property_value7;
                      v_stolen_value_t(8) := v_prop_tble(prop_cnt_886).property_value8;
                      v_stolen_value_t(9) := v_prop_tble(prop_cnt_886).property_value9;
                      v_stolen_value_t(10) := v_prop_tble(prop_cnt_886).property_value10;
                      v_found := 1;
                      for j_886 in 1..10 loop
                         if v_stolen_value_t(j_886) <> '777777777' then
                            tot_amt := tot_amt + to_number(v_stolen_value_t(j_886));
                         end if;
                      end loop;
                      exit inner_886;
                  end if;
              end loop inner_886;
              if v_found = 1 then
                 if tot_amt < 1501 then
                    update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 886,v_agency);
                 end if;
              else
                 update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 886,v_agency);
              end if;
           end if;
         end loop edit_886;
 /*890*/ <<edit_890>>
        v_found := 0;
        tot_amt := 0;
        for off_cnt_890 in 1..off_tble_cnt loop
           if substr(v_off_tble(off_cnt_890).incident_offense_code,1,14) = 'PL 155.30   01' then
             <<inner_890>>
              For prop_cnt_890 in 1..prop_tble_cnt loop
                  if v_prop_tble(prop_cnt_890).property_involvement = '07' then
                      v_stolen_value_t(1) := v_prop_tble(prop_cnt_890).property_value1;
                      v_stolen_value_t(2) := v_prop_tble(prop_cnt_890).property_value2;
                      v_stolen_value_t(3) := v_prop_tble(prop_cnt_890).property_value3;
                      v_stolen_value_t(4) := v_prop_tble(prop_cnt_890).property_value4;
                      v_stolen_value_t(5) := v_prop_tble(prop_cnt_890).property_value5;
                      v_stolen_value_t(6) := v_prop_tble(prop_cnt_890).property_value6;
                      v_stolen_value_t(7) := v_prop_tble(prop_cnt_890).property_value7;
                      v_stolen_value_t(8) := v_prop_tble(prop_cnt_890).property_value8;
                      v_stolen_value_t(9) := v_prop_tble(prop_cnt_890).property_value9;
                      v_stolen_value_t(10) := v_prop_tble(prop_cnt_890).property_value10;
                      v_found := 1;
                      for j_890 in 1..10 loop
                         if v_stolen_value_t(j_890) <> '777777777' then
                            tot_amt := tot_amt + to_number(v_stolen_value_t(j_890));
                         end if;
                      end loop;
                      exit inner_890;
                  end if;
              end loop inner_890;
              if v_found = 1 then
                 if tot_amt < 1001 then
                    update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 890,v_agency);
                 end if;
              else
                 update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 890,v_agency);
              end if;
           end if;
         end loop edit_890;
/*892*/ <<edit_892>>
       for off_cnt_892 in 1..off_tble_cnt loop
           if substr(v_off_tble(off_cnt_892).incident_offense_code,1,14) = 'PL 155.30   04' then
             <<inner_892>>
              For prop_cnt_892 in 1..prop_tble_cnt loop
                  if v_prop_tble(prop_cnt_892).property_involvement = '07' then
                     if ((v_prop_tble(prop_cnt_892).property_type1 <> '02') and
                        (v_prop_tble(prop_cnt_892).property_type2 <> '02') and
                        (v_prop_tble(prop_cnt_892).property_type3 <> '02') and
                        (v_prop_tble(prop_cnt_892).property_type4 <> '02') and
                        (v_prop_tble(prop_cnt_892).property_type5 <> '02') and
                        (v_prop_tble(prop_cnt_892).property_type6 <> '02') and
                        (v_prop_tble(prop_cnt_892).property_type7 <> '02') and
                        (v_prop_tble(prop_cnt_892).property_type8 <> '02') and
                        (v_prop_tble(prop_cnt_892).property_type9 <> '02') and
                        (v_prop_tble(prop_cnt_892).property_type10 <> '02')) then
                          update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 892,v_agency);
                     else
                         v_found := 1;
                         exit inner_892;
                     end if;
                  end if;
              end loop inner_892;
              if v_found <> 1 then
                 update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 892,v_agency);
              end if;
           end if;
       end loop edit_892;
/*894*/ <<edit_894>>
       for off_cnt_894 in 1..off_tble_cnt loop
           if substr(v_off_tble(off_cnt_894).incident_offense_code,1,14) = 'PL 155.30   07' then
             <<inner_894>>
              For prop_cnt_894 in 1..prop_tble_cnt loop
                  if v_prop_tble(prop_cnt_894).property_involvement = '07' then
                     if ((v_prop_tble(prop_cnt_894).property_type1 <> '39') and
                        (v_prop_tble(prop_cnt_894).property_type2 <> '39') and
                        (v_prop_tble(prop_cnt_894).property_type3 <> '39') and
                        (v_prop_tble(prop_cnt_894).property_type4 <> '39') and
                        (v_prop_tble(prop_cnt_894).property_type5 <> '39') and
                        (v_prop_tble(prop_cnt_894).property_type6 <> '39') and
                        (v_prop_tble(prop_cnt_894).property_type7 <> '39') and
                        (v_prop_tble(prop_cnt_894).property_type8 <> '39') and
                        (v_prop_tble(prop_cnt_894).property_type9 <> '39') and
                        (v_prop_tble(prop_cnt_894).property_type10 <> '39')) then
                          update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 894,v_agency);
                     else
                         v_found := 1;
                         exit inner_894;
                     end if;
                  end if;
              end loop inner_894;
          --    if v_found <> 1 then
          --       update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 894  NYS LAW CITATION IMPLIES PROPERTY TYPE OF FIREARMS(39) ON STOLEN PROPERTY SEGMENT(07)',v_agency);
          --    end if;
           end if;
       end loop edit_894;
/*896*/ <<edit_896>>
       for off_cnt_896 in 1..off_tble_cnt loop
           if substr(v_off_tble(off_cnt_896).incident_offense_code,1,14) = 'PL 155.30   08' AND
                substr(v_off_tble(off_cnt_896).incident_offense_code,22,1) = 'C' then
DBMS_OUTPUT.PUT_LINE('EDITS 896 '||v_off_tble(off_cnt_896).incident_offense_code);
             <<inner_896>>
              For prop_cnt_896 in 1..prop_tble_cnt loop
                  if v_prop_tble(prop_cnt_896).property_involvement = '07' then
                     v_stolen_type_t(1) := v_prop_tble(prop_cnt_896).property_type1;
                     v_stolen_type_t(2) := v_prop_tble(prop_cnt_896).property_type2;
                     v_stolen_type_t(3) := v_prop_tble(prop_cnt_896).property_type3;
                     v_stolen_type_t(4) := v_prop_tble(prop_cnt_896).property_type4;
                     v_stolen_type_t(5) := v_prop_tble(prop_cnt_896).property_type5;
                     v_stolen_type_t(6) := v_prop_tble(prop_cnt_896).property_type6;
                     v_stolen_type_t(7) := v_prop_tble(prop_cnt_896).property_type7;
                     v_stolen_type_t(8) := v_prop_tble(prop_cnt_896).property_type8;
                     v_stolen_type_t(9) := v_prop_tble(prop_cnt_896).property_type9;
                     v_stolen_type_t(10) := v_prop_tble(prop_cnt_896).property_type10;
                     v_stolen_value_t(1) := v_prop_tble(prop_cnt_896).property_value1;
                     v_stolen_value_t(2) := v_prop_tble(prop_cnt_896).property_value2;
                     v_stolen_value_t(3) := v_prop_tble(prop_cnt_896).property_value3;
                     v_stolen_value_t(4) := v_prop_tble(prop_cnt_896).property_value4;
                     v_stolen_value_t(5) := v_prop_tble(prop_cnt_896).property_value5;
                     v_stolen_value_t(6) := v_prop_tble(prop_cnt_896).property_value6;
                     v_stolen_value_t(7) := v_prop_tble(prop_cnt_896).property_value7;
                     v_stolen_value_t(8) := v_prop_tble(prop_cnt_896).property_value8;
                     v_stolen_value_t(9) := v_prop_tble(prop_cnt_896).property_value9;
                     v_stolen_value_t(10) := v_prop_tble(prop_cnt_896).property_value10;
                     <<inner_j_896>>
                     for j_896 in 1..10 loop
                        if v_stolen_type_t(j_896) in ('31','33','34','37') then
                           if v_stolen_value_t(j_896) < 101 then
                              update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 896,v_agency);
                           else
                              v_found := 1;
                              exit inner_j_896;
                           end if;
                        end if;
                     end loop inner_j_896;
                     if v_found <> 1 then
                        update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 896,v_agency);
                     else
                        exit inner_896;
                     end if;
                  end if;
              end loop inner_896;
           end if;
       end loop edit_896;
/*898*/ <<edit_898>>
        v_found := 0;
        tot_amt := 0;
        for off_cnt_898 in 1..off_tble_cnt loop
           if substr(v_off_tble(off_cnt_898).incident_offense_code,1,14) = 'PL 155.35     ' AND
                substr(v_off_tble(off_cnt_898).incident_offense_code,22,1) != 'A' then
             <<inner_898>>
              For prop_cnt_898 in 1..prop_tble_cnt loop
                  if v_prop_tble(prop_cnt_898).property_involvement = '07' then
                      v_stolen_value_t(1) := v_prop_tble(prop_cnt_898).property_value1;
                      v_stolen_value_t(2) := v_prop_tble(prop_cnt_898).property_value2;
                      v_stolen_value_t(3) := v_prop_tble(prop_cnt_898).property_value3;
                      v_stolen_value_t(4) := v_prop_tble(prop_cnt_898).property_value4;
                      v_stolen_value_t(5) := v_prop_tble(prop_cnt_898).property_value5;
                      v_stolen_value_t(6) := v_prop_tble(prop_cnt_898).property_value6;
                      v_stolen_value_t(7) := v_prop_tble(prop_cnt_898).property_value7;
                      v_stolen_value_t(8) := v_prop_tble(prop_cnt_898).property_value8;
                      v_stolen_value_t(9) := v_prop_tble(prop_cnt_898).property_value9;
                      v_stolen_value_t(10) := v_prop_tble(prop_cnt_898).property_value10;
                      v_found := 1;
                      for j_898 in 1..10 loop
                         if v_stolen_value_t(j_898) <> '777777777' then
                            tot_amt := tot_amt + to_number(v_stolen_value_t(j_898));
                         end if;
                      end loop;
                      exit inner_898;
                  end if;
              end loop inner_898;
              if v_found = 1 then
                 if tot_amt < 3001 then
                    update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 898,v_agency);
                 end if;
              else
                 update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 898,v_agency);
              end if;
           end if;
         end loop edit_898;
/*900*/ <<edit_900>>
        v_found := 0;
        tot_amt := 0;
        for off_cnt_900 in 1..off_tble_cnt loop
           if substr(v_off_tble(off_cnt_900).incident_offense_code,1,14) = 'PL 155.40     '  AND
                substr(v_off_tble(off_cnt_900).incident_offense_code,22,1) != 'A' then
             <<inner_900>>
              For prop_cnt_900 in 1..prop_tble_cnt loop
                  if v_prop_tble(prop_cnt_900).property_involvement = '07' then
                      v_stolen_value_t(1) := v_prop_tble(prop_cnt_900).property_value1;
                      v_stolen_value_t(2) := v_prop_tble(prop_cnt_900).property_value2;
                      v_stolen_value_t(3) := v_prop_tble(prop_cnt_900).property_value3;
                      v_stolen_value_t(4) := v_prop_tble(prop_cnt_900).property_value4;
                      v_stolen_value_t(5) := v_prop_tble(prop_cnt_900).property_value5;
                      v_stolen_value_t(6) := v_prop_tble(prop_cnt_900).property_value6;
                      v_stolen_value_t(7) := v_prop_tble(prop_cnt_900).property_value7;
                      v_stolen_value_t(8) := v_prop_tble(prop_cnt_900).property_value8;
                      v_stolen_value_t(9) := v_prop_tble(prop_cnt_900).property_value9;
                      v_stolen_value_t(10) := v_prop_tble(prop_cnt_900).property_value10;
                      v_found := 1;
                      for j_900 in 1..10 loop
                         if v_stolen_value_t(j_900) <> '777777777' then
                            tot_amt := tot_amt + to_number(v_stolen_value_t(j_900));
                         end if;
                      end loop;
                      exit inner_900;
                  end if;
              end loop inner_900;
              if v_found = 1 then
                 if tot_amt < 50001 then
                    update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 900 ,v_agency);
                 end if;
              else
                 update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 900,v_agency);
              end if;
           end if;
         end loop edit_900;
/*902*/ <<edit_902>>
        v_found := 0;
        tot_amt := 0;
        for off_cnt_902 in 1..off_tble_cnt loop
           if substr(v_off_tble(off_cnt_902).incident_offense_code,1,14) = 'PL 155.42     ' then
             <<inner_902>>
              For prop_cnt_902 in 1..prop_tble_cnt loop
                  if v_prop_tble(prop_cnt_902).property_involvement = '07' then
                      v_stolen_value_t(1) := v_prop_tble(prop_cnt_902).property_value1;
                      v_stolen_value_t(2) := v_prop_tble(prop_cnt_902).property_value2;
                      v_stolen_value_t(3) := v_prop_tble(prop_cnt_902).property_value3;
                      v_stolen_value_t(4) := v_prop_tble(prop_cnt_902).property_value4;
                      v_stolen_value_t(5) := v_prop_tble(prop_cnt_902).property_value5;
                      v_stolen_value_t(6) := v_prop_tble(prop_cnt_902).property_value6;
                      v_stolen_value_t(7) := v_prop_tble(prop_cnt_902).property_value7;
                      v_stolen_value_t(8) := v_prop_tble(prop_cnt_902).property_value8;
                      v_stolen_value_t(9) := v_prop_tble(prop_cnt_902).property_value9;
                      v_stolen_value_t(10) := v_prop_tble(prop_cnt_902).property_value10;
                      v_found := 1;
                      for j_902 in 1..10 loop
                         if v_stolen_value_t(j_902) <> '777777777' then
                            tot_amt := tot_amt + to_number(v_stolen_value_t(j_902));
                         end if;
                      end loop;
                      exit inner_902;
                  end if;
              end loop inner_902;
              if v_found = 1 then
                 if tot_amt < 1000001 then
                    update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 902,v_agency);
                 end if;
              else
                 update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 902,v_agency);
              end if;
           end if;
         end loop edit_902;
/*906*/ <<edit_906>>
        v_found := 0;
         for off_cnt_906 in 1..off_tble_cnt loop
           if substr(v_off_tble(off_cnt_906).incident_offense_code,1,14) = 'PL 156.25   03' and
               substr(v_off_tble(off_cnt_906).incident_offense_code,22,1) = 'C' and
              v_off_tble(off_cnt_906).computer_used = '1' then
             <<inner_906>>
              For prop_cnt_906 in 1..prop_tble_cnt loop
                  if v_prop_tble(prop_cnt_906).property_involvement = '04' then
                     if ((v_prop_tble(prop_cnt_906).property_type1 <> '13') and
                        (v_prop_tble(prop_cnt_906).property_type2 <> '13') and
                        (v_prop_tble(prop_cnt_906).property_type3 <> '13') and
                        (v_prop_tble(prop_cnt_906).property_type4 <> '13') and
                        (v_prop_tble(prop_cnt_906).property_type5 <> '13') and
                        (v_prop_tble(prop_cnt_906).property_type6 <> '13') and
                        (v_prop_tble(prop_cnt_906).property_type7 <> '13') and
                        (v_prop_tble(prop_cnt_906).property_type8 <> '13') and
                        (v_prop_tble(prop_cnt_906).property_type9 <> '13') and
                        (v_prop_tble(prop_cnt_906).property_type10 <> '13')) then
                         update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 906,v_agency);
                     else
                        v_found := 1;
                        exit inner_906;
                     end if;
                  end if;
              end loop inner_906;
              if v_found <> 1 then
                  update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 906 ,v_agency);
              end if;
           end if;
         end loop edit_906;
/*908*/ <<edit_908>>
       for off_cnt_908 in 1..off_tble_cnt loop
           if(substr(v_off_tble(off_cnt_908).incident_offense_code,1,14) = 'PL 156.25   04') and
              (substr(v_off_tble(off_cnt_908).incident_offense_code,22,1) = 'C') and
              (v_off_tble(off_cnt_908).computer_used = '1') then
             <<inner_908>>
              For prop_cnt_908 in 1..prop_tble_cnt loop
                  if v_prop_tble(prop_cnt_908).property_involvement = '04' then
                     v_stolen_type_t(1) := v_prop_tble(prop_cnt_908).property_type1;
                     v_stolen_type_t(2) := v_prop_tble(prop_cnt_908).property_type2;
                     v_stolen_type_t(3) := v_prop_tble(prop_cnt_908).property_type3;
                     v_stolen_type_t(4) := v_prop_tble(prop_cnt_908).property_type4;
                     v_stolen_type_t(5) := v_prop_tble(prop_cnt_908).property_type5;
                     v_stolen_type_t(6) := v_prop_tble(prop_cnt_908).property_type6;
                     v_stolen_type_t(7) := v_prop_tble(prop_cnt_908).property_type7;
                     v_stolen_type_t(8) := v_prop_tble(prop_cnt_908).property_type8;
                     v_stolen_type_t(9) := v_prop_tble(prop_cnt_908).property_type9;
                     v_stolen_type_t(10) := v_prop_tble(prop_cnt_908).property_type10;
                     v_stolen_value_t(1) := v_prop_tble(prop_cnt_908).property_value1;
                     v_stolen_value_t(2) := v_prop_tble(prop_cnt_908).property_value2;
                     v_stolen_value_t(3) := v_prop_tble(prop_cnt_908).property_value3;
                     v_stolen_value_t(4) := v_prop_tble(prop_cnt_908).property_value4;
                     v_stolen_value_t(5) := v_prop_tble(prop_cnt_908).property_value5;
                     v_stolen_value_t(6) := v_prop_tble(prop_cnt_908).property_value6;
                     v_stolen_value_t(7) := v_prop_tble(prop_cnt_908).property_value7;
                     v_stolen_value_t(8) := v_prop_tble(prop_cnt_908).property_value8;
                     v_stolen_value_t(9) := v_prop_tble(prop_cnt_908).property_value9;
                     v_stolen_value_t(10) := v_prop_tble(prop_cnt_908).property_value10;
                     <<inner_j_908>>
                     for j_908 in 1..10 loop
                        if v_stolen_type_t(j_908) = '13' then
                           if v_stolen_value_t(j_908) < 1001 then
                              update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 908,v_agency);
                           else
                              v_found := 1;
                              exit inner_j_908;
                           end if;
                        end if;
                     end loop inner_j_908;
                     if v_found <> 1 then
                        update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 908 ,v_agency);
                     else
                        exit inner_908;
                     end if;
                  end if;
              end loop inner_908;
           end if;
       end loop edit_908;
/*912*/ <<edit_912>>
       for off_cnt_912 in 1..off_tble_cnt loop
           if substr(v_off_tble(off_cnt_912).incident_offense_code,1,14) = 'PL 156.30   01' and
              substr(v_off_tble(off_cnt_912).incident_offense_code,22,1) = 'C' and
              v_off_tble(off_cnt_912).computer_used = '1' then
             <<inner_912>>
              For prop_cnt_912 in 1..prop_tble_cnt loop
                  if v_prop_tble(prop_cnt_912).property_involvement = '07' then
                     v_stolen_type_t(1) := v_prop_tble(prop_cnt_912).property_type1;
                     v_stolen_type_t(2) := v_prop_tble(prop_cnt_912).property_type2;
                     v_stolen_type_t(3) := v_prop_tble(prop_cnt_912).property_type3;
                     v_stolen_type_t(4) := v_prop_tble(prop_cnt_912).property_type4;
                     v_stolen_type_t(5) := v_prop_tble(prop_cnt_912).property_type5;
                     v_stolen_type_t(6) := v_prop_tble(prop_cnt_912).property_type6;
                     v_stolen_type_t(7) := v_prop_tble(prop_cnt_912).property_type7;
                     v_stolen_type_t(8) := v_prop_tble(prop_cnt_912).property_type8;
                     v_stolen_type_t(9) := v_prop_tble(prop_cnt_912).property_type9;
                     v_stolen_type_t(10) := v_prop_tble(prop_cnt_912).property_type10;
                     v_stolen_value_t(1) := v_prop_tble(prop_cnt_912).property_value1;
                     v_stolen_value_t(2) := v_prop_tble(prop_cnt_912).property_value2;
                     v_stolen_value_t(3) := v_prop_tble(prop_cnt_912).property_value3;
                     v_stolen_value_t(4) := v_prop_tble(prop_cnt_912).property_value4;
                     v_stolen_value_t(5) := v_prop_tble(prop_cnt_912).property_value5;
                     v_stolen_value_t(6) := v_prop_tble(prop_cnt_912).property_value6;
                     v_stolen_value_t(7) := v_prop_tble(prop_cnt_912).property_value7;
                     v_stolen_value_t(8) := v_prop_tble(prop_cnt_912).property_value8;
                     v_stolen_value_t(9) := v_prop_tble(prop_cnt_912).property_value9;
                     v_stolen_value_t(10) := v_prop_tble(prop_cnt_912).property_value10;
                     <<inner_j_912>>
                     for j_912 in 1..10 loop
                        if v_stolen_type_t(j_912) = '13' then
                           if v_stolen_value_t(j_912) < 2501 then
                              update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 912,v_agency);
                           else
                              v_found := 1;
                              exit inner_j_912;
                           end if;
                        end if;
                     end loop inner_j_912;
                     if v_found <> 1 then
                        update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 912,v_agency);
                     else
                        exit inner_912;
                     end if;
                  end if;
              end loop inner_912;
           end if;
       end loop edit_912;
/*924*/ <<edit_924>>
        for off_cnt_924 in 1..off_tble_cnt loop
           if v_off_tble(off_cnt_924).incident_offense_code in ('PL 165.09         AM2C',
                                                                'PL 165.09 01      AM2C',
                                                                'PL 165.09 02      AM2C',
                                                                'PL 165.10         EF1C') then
              <<inner_924>>
              For prop_cnt_924 in 1..prop_tble_cnt loop
                  if v_prop_tble(prop_cnt_924).property_involvement = '07' then
                     v_stolen_type_t(1) := v_prop_tble(prop_cnt_924).property_type1;
                     v_stolen_type_t(2) := v_prop_tble(prop_cnt_924).property_type2;
                     v_stolen_type_t(3) := v_prop_tble(prop_cnt_924).property_type3;
                     v_stolen_type_t(4) := v_prop_tble(prop_cnt_924).property_type4;
                     v_stolen_type_t(5) := v_prop_tble(prop_cnt_924).property_type5;
                     v_stolen_type_t(6) := v_prop_tble(prop_cnt_924).property_type6;
                     v_stolen_type_t(7) := v_prop_tble(prop_cnt_924).property_type7;
                     v_stolen_type_t(8) := v_prop_tble(prop_cnt_924).property_type8;
                     v_stolen_type_t(9) := v_prop_tble(prop_cnt_924).property_type9;
                     v_stolen_type_t(10) := v_prop_tble(prop_cnt_924).property_type10;
                     <<inner_j_924>>
                     for j_924 in 1..10 loop
                        if v_stolen_type_t(j_924) = '23' then
                           v_found := 1;
                           exit inner_924;
                        end if;
                     end loop inner_j_924;
                     if v_found <> 1 then
                           update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 924 ,v_agency);
                     end if;
                  end if;
              end loop inner_924;
           end if;
       end loop edit_924;
/*926*/ <<edit_926>>
        v_found := 0;
        tot_amt := 0;
        for off_cnt_926 in 1..off_tble_cnt loop
           if v_off_tble(off_cnt_926).incident_offense_code = 'PL 176.15         EF2C' then
             <<inner_926>>
              For prop_cnt_926 in 1..prop_tble_cnt loop
                  if v_prop_tble(prop_cnt_926).property_involvement = '07' then
                      v_stolen_value_t(1) := v_prop_tble(prop_cnt_926).property_value1;
                      v_stolen_value_t(2) := v_prop_tble(prop_cnt_926).property_value2;
                      v_stolen_value_t(3) := v_prop_tble(prop_cnt_926).property_value3;
                      v_stolen_value_t(4) := v_prop_tble(prop_cnt_926).property_value4;
                      v_stolen_value_t(5) := v_prop_tble(prop_cnt_926).property_value5;
                      v_stolen_value_t(6) := v_prop_tble(prop_cnt_926).property_value6;
                      v_stolen_value_t(7) := v_prop_tble(prop_cnt_926).property_value7;
                      v_stolen_value_t(8) := v_prop_tble(prop_cnt_926).property_value8;
                      v_stolen_value_t(9) := v_prop_tble(prop_cnt_926).property_value9;
                      v_stolen_value_t(10) := v_prop_tble(prop_cnt_926).property_value10;
                      v_found := 1;
                      for j_926 in 1..10 loop
                         if v_stolen_value_t(j_926) <> '777777777' then
                            tot_amt := tot_amt + to_number(v_stolen_value_t(j_926));
                         end if;
                      end loop;
                      exit inner_926;
                  end if;
              end loop inner_926;
              if v_found = 1 then
                 if tot_amt < 1001 then
                    update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 926,v_agency);
                 end if;
              else
                 update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 926,v_agency);
              end if;
           end if;
         end loop edit_926;
/*928*/ <<edit_928>>
        v_found := 0;
        tot_amt := 0;
        for off_cnt_928 in 1..off_tble_cnt loop
           if substr(v_off_tble(off_cnt_928).incident_offense_code,1,14) = 'PL 176.20     ' then
             <<inner_928>>
              For prop_cnt_928 in 1..prop_tble_cnt loop
                  if v_prop_tble(prop_cnt_928).property_involvement = '07' then
                      v_stolen_value_t(1) := v_prop_tble(prop_cnt_928).property_value1;
                      v_stolen_value_t(2) := v_prop_tble(prop_cnt_928).property_value2;
                      v_stolen_value_t(3) := v_prop_tble(prop_cnt_928).property_value3;
                      v_stolen_value_t(4) := v_prop_tble(prop_cnt_928).property_value4;
                      v_stolen_value_t(5) := v_prop_tble(prop_cnt_928).property_value5;
                      v_stolen_value_t(6) := v_prop_tble(prop_cnt_928).property_value6;
                      v_stolen_value_t(7) := v_prop_tble(prop_cnt_928).property_value7;
                      v_stolen_value_t(8) := v_prop_tble(prop_cnt_928).property_value8;
                      v_stolen_value_t(9) := v_prop_tble(prop_cnt_928).property_value9;
                      v_stolen_value_t(10) := v_prop_tble(prop_cnt_928).property_value10;
                      v_found := 1;
                      for j_928 in 1..10 loop
                         if v_stolen_value_t(j_928) <> '777777777' then
                            tot_amt := tot_amt + to_number(v_stolen_value_t(j_928));
                         end if;
                      end loop;
                      exit inner_928;
                  end if;
              end loop inner_928;
              if v_found = 1 then
                 if tot_amt < 3001 then
                    update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 928,v_agency);
                 end if;
              else
                 update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 928,v_agency);
              end if;
           end if;
         end loop edit_928;
/*930*/ <<edit_930>>
        v_found := 0;
        tot_amt := 0;
        for off_cnt_930 in 1..off_tble_cnt loop
           if substr(v_off_tble(off_cnt_930).incident_offense_code,1,14) = 'PL 176.25     ' then
             <<inner_930>>
              For prop_cnt_930 in 1..prop_tble_cnt loop
                  if v_prop_tble(prop_cnt_930).property_involvement = '07' then
                      v_stolen_value_t(1) := v_prop_tble(prop_cnt_930).property_value1;
                      v_stolen_value_t(2) := v_prop_tble(prop_cnt_930).property_value2;
                      v_stolen_value_t(3) := v_prop_tble(prop_cnt_930).property_value3;
                      v_stolen_value_t(4) := v_prop_tble(prop_cnt_930).property_value4;
                      v_stolen_value_t(5) := v_prop_tble(prop_cnt_930).property_value5;
                      v_stolen_value_t(6) := v_prop_tble(prop_cnt_930).property_value6;
                      v_stolen_value_t(7) := v_prop_tble(prop_cnt_930).property_value7;
                      v_stolen_value_t(8) := v_prop_tble(prop_cnt_930).property_value8;
                      v_stolen_value_t(9) := v_prop_tble(prop_cnt_930).property_value9;
                      v_stolen_value_t(10) := v_prop_tble(prop_cnt_930).property_value10;
                      v_found := 1;
                      for j_930 in 1..10 loop
                         if v_stolen_value_t(j_930) <> '777777777' then
                            tot_amt := tot_amt + to_number(v_stolen_value_t(j_930));
                         end if;
                      end loop;
                      exit inner_930;
                  end if;
              end loop inner_930;
              if v_found = 1 then
                 if tot_amt < 50001 then
                    update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 930 ,v_agency);
                 end if;
              else
                 update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 930,v_agency);
              end if;
           end if;
         end loop edit_930;
/*932*/ <<edit_932>>
        v_found := 0;
        tot_amt := 0;
        for off_cnt_932 in 1..off_tble_cnt loop
           if substr(v_off_tble(off_cnt_932).incident_offense_code,1,14) = 'PL 176.30     ' then
             <<inner_932>>
              For prop_cnt_932 in 1..prop_tble_cnt loop
                  if v_prop_tble(prop_cnt_932).property_involvement = '07' then
                      v_stolen_value_t(1) := v_prop_tble(prop_cnt_932).property_value1;
                      v_stolen_value_t(2) := v_prop_tble(prop_cnt_932).property_value2;
                      v_stolen_value_t(3) := v_prop_tble(prop_cnt_932).property_value3;
                      v_stolen_value_t(4) := v_prop_tble(prop_cnt_932).property_value4;
                      v_stolen_value_t(5) := v_prop_tble(prop_cnt_932).property_value5;
                      v_stolen_value_t(6) := v_prop_tble(prop_cnt_932).property_value6;
                      v_stolen_value_t(7) := v_prop_tble(prop_cnt_932).property_value7;
                      v_stolen_value_t(8) := v_prop_tble(prop_cnt_932).property_value8;
                      v_stolen_value_t(9) := v_prop_tble(prop_cnt_932).property_value9;
                      v_stolen_value_t(10) := v_prop_tble(prop_cnt_932).property_value10;
                      v_found := 1;
                      for j_932 in 1..10 loop
                         if v_stolen_value_t(j_932) <> '777777777' then
                            tot_amt := tot_amt + to_number(v_stolen_value_t(j_932));
                         end if;
                      end loop;
                      exit inner_932;
                  end if;
              end loop inner_932;
              if v_found = 1 then
                 if tot_amt < 100001 then
                    update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 932,v_agency);
                 end if;
              else
                 update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 932,v_agency);
              end if;
           end if;
         end loop edit_932;
/*934*/ <<edit_934>>
       for off_cnt_934 in 1..off_tble_cnt loop
           if substr(v_off_tble(off_cnt_934).incident_offense_code,1,14) = 'PL 180.52   01' then
             <<inner_934>>
              For prop_cnt_934 in 1..prop_tble_cnt loop
                  if v_prop_tble(prop_cnt_934).property_involvement = '07' then
                     v_stolen_type_t(1) := v_prop_tble(prop_cnt_934).property_type1;
                     v_stolen_type_t(2) := v_prop_tble(prop_cnt_934).property_type2;
                     v_stolen_type_t(3) := v_prop_tble(prop_cnt_934).property_type3;
                     v_stolen_type_t(4) := v_prop_tble(prop_cnt_934).property_type4;
                     v_stolen_type_t(5) := v_prop_tble(prop_cnt_934).property_type5;
                     v_stolen_type_t(6) := v_prop_tble(prop_cnt_934).property_type6;
                     v_stolen_type_t(7) := v_prop_tble(prop_cnt_934).property_type7;
                     v_stolen_type_t(8) := v_prop_tble(prop_cnt_934).property_type8;
                     v_stolen_type_t(9) := v_prop_tble(prop_cnt_934).property_type9;
                     v_stolen_type_t(10) := v_prop_tble(prop_cnt_934).property_type10;
                     v_stolen_value_t(1) := v_prop_tble(prop_cnt_934).property_value1;
                     v_stolen_value_t(2) := v_prop_tble(prop_cnt_934).property_value2;
                     v_stolen_value_t(3) := v_prop_tble(prop_cnt_934).property_value3;
                     v_stolen_value_t(4) := v_prop_tble(prop_cnt_934).property_value4;
                     v_stolen_value_t(5) := v_prop_tble(prop_cnt_934).property_value5;
                     v_stolen_value_t(6) := v_prop_tble(prop_cnt_934).property_value6;
                     v_stolen_value_t(7) := v_prop_tble(prop_cnt_934).property_value7;
                     v_stolen_value_t(8) := v_prop_tble(prop_cnt_934).property_value8;
                     v_stolen_value_t(9) := v_prop_tble(prop_cnt_934).property_value9;
                     v_stolen_value_t(10) := v_prop_tble(prop_cnt_934).property_value10;
                     <<inner_j_934>>
                     for j_934 in 1..10 loop
                        if v_stolen_type_t(j_934) = '12' then
                           if v_stolen_value_t(j_934) >1500 then
                              update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 934,v_agency);
                           else
                              v_found := 1;
                              exit inner_j_934;
                           end if;
                        end if;
                     end loop inner_j_934;
                     if v_found <> 1 then
                        update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 934 ,v_agency);
                     else
                        exit inner_934;
                     end if;
                  end if;
              end loop inner_934;
           end if;
       end loop edit_934;
/*936*/ <<edit_936>>
       for off_cnt_936 in 1..off_tble_cnt loop
           if substr(v_off_tble(off_cnt_936).incident_offense_code,1,14) = 'PL 180.52   01' then
             <<inner_936>>
              For prop_cnt_936 in 1..prop_tble_cnt loop
                  if v_prop_tble(prop_cnt_936).property_involvement = '07' then
                     v_stolen_type_t(1) := v_prop_tble(prop_cnt_936).property_type1;
                     v_stolen_type_t(2) := v_prop_tble(prop_cnt_936).property_type2;
                     v_stolen_type_t(3) := v_prop_tble(prop_cnt_936).property_type3;
                     v_stolen_type_t(4) := v_prop_tble(prop_cnt_936).property_type4;
                     v_stolen_type_t(5) := v_prop_tble(prop_cnt_936).property_type5;
                     v_stolen_type_t(6) := v_prop_tble(prop_cnt_936).property_type6;
                     v_stolen_type_t(7) := v_prop_tble(prop_cnt_936).property_type7;
                     v_stolen_type_t(8) := v_prop_tble(prop_cnt_936).property_type8;
                     v_stolen_type_t(9) := v_prop_tble(prop_cnt_936).property_type9;
                     v_stolen_type_t(10) := v_prop_tble(prop_cnt_936).property_type10;
                     v_stolen_value_t(1) := v_prop_tble(prop_cnt_936).property_value1;
                     v_stolen_value_t(2) := v_prop_tble(prop_cnt_936).property_value2;
                     v_stolen_value_t(3) := v_prop_tble(prop_cnt_936).property_value3;
                     v_stolen_value_t(4) := v_prop_tble(prop_cnt_936).property_value4;
                     v_stolen_value_t(5) := v_prop_tble(prop_cnt_936).property_value5;
                     v_stolen_value_t(6) := v_prop_tble(prop_cnt_936).property_value6;
                     v_stolen_value_t(7) := v_prop_tble(prop_cnt_936).property_value7;
                     v_stolen_value_t(8) := v_prop_tble(prop_cnt_936).property_value8;
                     v_stolen_value_t(9) := v_prop_tble(prop_cnt_936).property_value9;
                     v_stolen_value_t(10) := v_prop_tble(prop_cnt_936).property_value10;
                     <<inner_j_936>>
                     for j_936 in 1..10 loop
                        if v_stolen_type_t(j_936) = '12' then
                           if v_stolen_value_t(j_936) > 1500 then
                              update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 936,v_agency);
                           else
                              v_found := 1;
                              exit inner_j_936;
                           end if;
                        end if;
                     end loop inner_j_936;
                     if v_found <> 1 then
                        update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 936,v_agency);
                     else
                        exit inner_936;
                     end if;
                  end if;
              end loop inner_936;
           end if;
       end loop edit_936;
/*938*/ <<edit_938>>
       for off_cnt_938 in 1..off_tble_cnt loop
           if substr(v_off_tble(off_cnt_938).incident_offense_code,1,14) in ('PL 180.53   01','PL 180.53   02') then
             <<inner_938>>
              For prop_cnt_938 in 1..prop_tble_cnt loop
                  if v_prop_tble(prop_cnt_938).property_involvement = '07' then
                     v_stolen_type_t(1) := v_prop_tble(prop_cnt_938).property_type1;
                     v_stolen_type_t(2) := v_prop_tble(prop_cnt_938).property_type2;
                     v_stolen_type_t(3) := v_prop_tble(prop_cnt_938).property_type3;
                     v_stolen_type_t(4) := v_prop_tble(prop_cnt_938).property_type4;
                     v_stolen_type_t(5) := v_prop_tble(prop_cnt_938).property_type5;
                     v_stolen_type_t(6) := v_prop_tble(prop_cnt_938).property_type6;
                     v_stolen_type_t(7) := v_prop_tble(prop_cnt_938).property_type7;
                     v_stolen_type_t(8) := v_prop_tble(prop_cnt_938).property_type8;
                     v_stolen_type_t(9) := v_prop_tble(prop_cnt_938).property_type9;
                     v_stolen_type_t(10) := v_prop_tble(prop_cnt_938).property_type10;
                     v_stolen_value_t(1) := v_prop_tble(prop_cnt_938).property_value1;
                     v_stolen_value_t(2) := v_prop_tble(prop_cnt_938).property_value2;
                     v_stolen_value_t(3) := v_prop_tble(prop_cnt_938).property_value3;
                     v_stolen_value_t(4) := v_prop_tble(prop_cnt_938).property_value4;
                     v_stolen_value_t(5) := v_prop_tble(prop_cnt_938).property_value5;
                     v_stolen_value_t(6) := v_prop_tble(prop_cnt_938).property_value6;
                     v_stolen_value_t(7) := v_prop_tble(prop_cnt_938).property_value7;
                     v_stolen_value_t(8) := v_prop_tble(prop_cnt_938).property_value8;
                     v_stolen_value_t(9) := v_prop_tble(prop_cnt_938).property_value9;
                     v_stolen_value_t(10) := v_prop_tble(prop_cnt_938).property_value10;
                     <<inner_j_938>>
                     for j_938 in 1..10 loop
                        if v_stolen_type_t(j_938) = '12' then
                           if v_stolen_value_t(j_938) < 1501 then
                              update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 938,v_agency);
                           else
                              v_found := 1;
                              exit inner_j_938;
                           end if;
                        end if;
                     end loop inner_j_938;
                     if v_found <> 1 then
                        update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 938,v_agency);
                     else
                        exit inner_938;
                     end if;
                  end if;
              end loop inner_938;
           end if;
       end loop edit_938;
/*940*/ v_found:= 0;
        <<edit_940>>
        for off_cnt_940 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_940).incident_offense_code,1,14) = 'PL 215.15   02' then
            <<outer_940>>
            For prop_cnt_940 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_940).property_involvement in ('02', '04') then
                    v_found:= 1;
                    exit outer_940;
                end if;
            end loop;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 940,v_agency);
            end if;
          end if;
        end loop;
/*942*/ v_found:= 0;
        <<edit_942>>
        for off_cnt_942 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_942).incident_offense_code,1,14) = 'PL 220.06   05' then
            <<outer_942>>
            For prop_cnt_942 in 1..prop_tble_cnt loop
                if (v_prop_tble(prop_cnt_942).property_involvement = '06') then
                   if v_prop_tble(prop_cnt_942).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_942;
                   end if;
                   if v_prop_tble(prop_cnt_942).drug_type1 in ('10','11','19') then
                      v_found := 1;
                      exit outer_942;
                   end if;
                   if v_prop_tble(prop_cnt_942).drug_type2 in ('10','11','19') then
                      v_found := 1;
                      exit outer_942;
                   end if;
                   if v_prop_tble(prop_cnt_942).drug_type3 in ('10','11','19') then
                      v_found := 1;
                      exit outer_942;
                   end if;
                end if;
            end loop outer_942;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 942,v_agency);
            end if;
          end if;
        end loop edit_942;
/*944*/ v_found:= 0;
        <<edit_944>>
        for off_cnt_944 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_944).incident_offense_code,1,14) = 'PL 220.09   02' then
            <<outer_944>>
            For prop_cnt_944 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_944).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_944).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_944;
                   end if;
                   if v_prop_tble(prop_cnt_944).drug_type1 in ('32','33') then
                      v_found := 1;
                      exit outer_944;
                   end if;
                   if v_prop_tble(prop_cnt_944).drug_type2 in ('32','33') then
                      v_found := 1;
                      exit outer_944;
                   end if;
                   if v_prop_tble(prop_cnt_944).drug_type3 in ('32','33') then
                      v_found := 1;
                      exit outer_944;
                   end if;
                end if;
            end loop outer_944;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 944 ,v_agency);
            end if;
          end if;
        end loop edit_944;
/*946*/ v_found:= 0;
        <<edit_946>>
        for off_cnt_946 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_946).incident_offense_code,1,14) = 'PL 220.09   05' then
            <<outer_946>>
            For prop_cnt_946 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_946).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_946).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_946;
                   end if;
                   if v_prop_tble(prop_cnt_946).drug_type1 = '22' then
                      v_found := 1;
                      exit outer_946;
                   end if;
                   if v_prop_tble(prop_cnt_946).drug_type2 = '22' then
                      v_found := 1;
                      exit outer_946;
                   end if;
                   if v_prop_tble(prop_cnt_946).drug_type3 = '22' then
                      v_found := 1;
                      exit outer_946;
                   end if;
                end if;
            end loop outer_946;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 946,v_agency);
            end if;
          end if;
        end loop edit_946;
/*948*/ v_found:= 0;
        <<edit_948>>
        for off_cnt_948 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_948).incident_offense_code,1,14) in ('PL 220.09   06','PL 220.09   06')  then
            <<outer_948>>
            For prop_cnt_948 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_948).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_948).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_948;
                   end if;
                   if v_prop_tble(prop_cnt_948).drug_type1 in ('21','22','29') then
                      v_found := 1;
                      exit outer_948;
                   end if;
                   if v_prop_tble(prop_cnt_948).drug_type2 in ('21','22','29') then
                      v_found := 1;
                      exit outer_948;
                   end if;
                   if v_prop_tble(prop_cnt_948).drug_type3 in ('21','22','29') then
                      v_found := 1;
                      exit outer_948;
                   end if;
                end if;
            end loop outer_948;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 948,v_agency);
            end if;
          end if;
        end loop edit_948;
/*950*/ v_found:= 0;
        <<edit_950>>
        for off_cnt_950 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_950).incident_offense_code,1,14) in ('PL 220.09   08','PL 220.09   09')  then
            <<outer_950>>
            For prop_cnt_950 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_950).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_950).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_950;
                   end if;
                   if v_prop_tble(prop_cnt_950).drug_type1 in ('41','42','49') then
                      v_found := 1;
                      exit outer_950;
                   end if;
                   if v_prop_tble(prop_cnt_950).drug_type2 in ('41','42','49') then
                      v_found := 1;
                      exit outer_950;
                   end if;
                   if v_prop_tble(prop_cnt_950).drug_type3 in ('41','42','49') then
                      v_found := 1;
                      exit outer_950;
                   end if;
                end if;
            end loop outer_950;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 950 ,v_agency);
            end if;
          end if;
        end loop edit_950;
/*952*/ v_found:= 0;
        <<edit_952>>
        for off_cnt_952 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_952).incident_offense_code,1,14) = 'PL 220.09   12'  then
            <<outer_952>>
            For prop_cnt_952 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_952).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_952).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_952;
                   end if;
                   if v_prop_tble(prop_cnt_952).drug_type1 = '05' then
                      v_found := 1;
                      exit outer_952;
                   end if;
                   if v_prop_tble(prop_cnt_952).drug_type2 = '05' then
                      v_found := 1;
                      exit outer_952;
                   end if;
                   if v_prop_tble(prop_cnt_952).drug_type3 = '05' then
                      v_found := 1;
                      exit outer_952;
                   end if;
                end if;
            end loop outer_952;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 952,v_agency);
            end if;
          end if;
        end loop edit_952;
/*954*/ v_found:= 0;
        <<edit_954>>
        for off_cnt_954 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_954).incident_offense_code,1,14) = 'PL 220.16   01'  then
            <<outer_954>>
            For prop_cnt_954 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_954).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_954).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_954;
                   end if;
                   if v_prop_tble(prop_cnt_954).drug_type1 in ('01','02','03','04','05','06','09','10','11','19') then
                      v_found := 1;
                      exit outer_954;
                   end if;
                   if v_prop_tble(prop_cnt_954).drug_type2 in ('01','02','03','04','05','06','09','10','11','19') then
                      v_found := 1;
                      exit outer_954;
                   end if;
                   if v_prop_tble(prop_cnt_954).drug_type3 in ('01','02','03','04','05','06','09','10','11','19') then
                      v_found := 1;
                      exit outer_954;
                   end if;
                end if;
            end loop outer_954;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 954,v_agency);
            end if;
          end if;
        end loop edit_954;
/*956*/ v_found:= 0;
        <<edit_956>>
        for off_cnt_956 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_956).incident_offense_code,1,14) = 'PL 220.16   02'  then
            <<outer_956>>
            For prop_cnt_956 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_956).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_956).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_956;
                   end if;
                   if v_prop_tble(prop_cnt_956).drug_type1 in ('31','32','33','39','21','22','29') then
                      v_found := 1;
                      exit outer_956;
                   end if;
                   if v_prop_tble(prop_cnt_956).drug_type2 in ('31','32','33','39','21','22','29') then
                      v_found := 1;
                      exit outer_956;
                   end if;
                   if v_prop_tble(prop_cnt_956).drug_type3 in ('31','32','33','39','21','22','29') then
                      v_found := 1;
                      exit outer_956;
                   end if;
                end if;
            end loop outer_956;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 956,v_agency);
            end if;
          end if;
        end loop edit_956;
/*958*/ v_found:= 0;
        <<edit_958>>
        for off_cnt_958 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_958).incident_offense_code,1,14) = 'PL 220.16   03'  then
            <<outer_958>>
            For prop_cnt_958 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_958).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_958).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_958;
                   end if;
                   if v_prop_tble(prop_cnt_958).drug_type1 in ('31','32','33','39') then
                      v_found := 1;
                      exit outer_958;
                   end if;
                   if v_prop_tble(prop_cnt_958).drug_type2 in ('31','32','33','39') then
                      v_found := 1;
                      exit outer_958;
                   end if;
                   if v_prop_tble(prop_cnt_958).drug_type3 in ('31','32','33','39') then
                      v_found := 1;
                      exit outer_958;
                   end if;
                end if;
            end loop outer_958;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 958 ,v_agency);
            end if;
          end if;
        end loop edit_958;
/*960*/ v_found:= 0;
        <<edit_960>>
        for off_cnt_960 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_960).incident_offense_code,1,14) = 'PL 220.16   04'  then
            <<outer_960>>
            For prop_cnt_960 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_960).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_960).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_960;
                   end if;
                   if v_prop_tble(prop_cnt_960).drug_type1 = '22' then
                      v_found := 1;
                      exit outer_960;
                   end if;
                   if v_prop_tble(prop_cnt_960).drug_type2 = '22' then
                      v_found := 1;
                      exit outer_960;
                   end if;
                   if v_prop_tble(prop_cnt_960).drug_type3 = '22' then
                      v_found := 1;
                      exit outer_960;
                   end if;
                end if;
            end loop outer_960;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 960,v_agency);
            end if;
          end if;
        end loop edit_960;
/*962*/ v_found:= 0;
        <<edit_962>>
        for off_cnt_962 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_962).incident_offense_code,1,14) in ('PL 220.16   05', 'PL 220.16   06')  then
            <<outer_962>>
            For prop_cnt_962 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_962).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_962).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_962;
                   end if;
                   if v_prop_tble(prop_cnt_962).drug_type1 in ('21','22','29') then
                      v_found := 1;
                      exit outer_962;
                   end if;
                   if v_prop_tble(prop_cnt_962).drug_type2 in ('21','22','29') then
                      v_found := 1;
                      exit outer_962;
                   end if;
                   if v_prop_tble(prop_cnt_962).drug_type3 in ('21','22','29') then
                      v_found := 1;
                      exit outer_962;
                   end if;
                end if;
            end loop outer_962;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 962,v_agency);
            end if;
          end if;
        end loop edit_962;
/*964*/ v_found:= 0;
        <<edit_964>>
        for off_cnt_964 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_964).incident_offense_code,1,14) = ('PL 220.16   07')  then
            <<outer_964>>
            For prop_cnt_964 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_964).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_964).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_964;
                   end if;
                   if v_prop_tble(prop_cnt_964).drug_type1 in ('32','33') then
                      v_found := 1;
                      exit outer_964;
                   end if;
                   if v_prop_tble(prop_cnt_964).drug_type2 in ('32','33') then
                      v_found := 1;
                      exit outer_964;
                   end if;
                   if v_prop_tble(prop_cnt_964).drug_type3 in ('32','33') then
                      v_found := 1;
                      exit outer_964;
                   end if;
                end if;
            end loop outer_964;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 964,v_agency);
            end if;
          end if;
        end loop edit_964;
/*966*/ v_found:= 0;
        <<edit_966>>
        for off_cnt_966 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_966).incident_offense_code,1,14) = 'PL 220.16   08'  then
            <<outer_966>>
            For prop_cnt_966 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_966).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_966).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_966;
                   end if;
                   if v_prop_tble(prop_cnt_966).drug_type1 in ('31','32','33','39') then
                      v_found := 1;
                      exit outer_966;
                   end if;
                   if v_prop_tble(prop_cnt_966).drug_type2 in ('31','32','33','39') then
                      v_found := 1;
                      exit outer_966;
                   end if;
                   if v_prop_tble(prop_cnt_966).drug_type3 in ('31','32','33','39') then
                      v_found := 1;
                      exit outer_966;
                   end if;
                end if;
            end loop outer_966;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 966,v_agency);
            end if;
          end if;
        end loop edit_966;
/*968*/ v_found:= 0;
        <<edit_968>>
        for off_cnt_968 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_968).incident_offense_code,1,14) = 'PL 220.16   09'  then
            <<outer_968>>
            For prop_cnt_968 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_968).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_968).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_968;
                   end if;
                   if v_prop_tble(prop_cnt_968).drug_type1 = '22' then
                      v_found := 1;
                      exit outer_968;
                   end if;
                   if v_prop_tble(prop_cnt_968).drug_type2 = '22' then
                      v_found := 1;
                      exit outer_968;
                   end if;
                   if v_prop_tble(prop_cnt_968).drug_type3 = '22' then
                      v_found := 1;
                      exit outer_968;
                   end if;
                end if;
            end loop outer_968;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 968,v_agency);
            end if;
          end if;
        end loop edit_968;
/*970*/ v_found:= 0;
        <<edit_970>>
        for off_cnt_970 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_970).incident_offense_code,1,14) in ('PL 220.16   10', 'PL 220.16   11') then
            <<outer_970>>
            For prop_cnt_970 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_970).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_970).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_970;
                   end if;
                   if v_prop_tble(prop_cnt_970).drug_type1 in ('21','22','29') then
                      v_found := 1;
                      exit outer_970;
                   end if;
                   if v_prop_tble(prop_cnt_970).drug_type2 in ('21','22','29') then
                      v_found := 1;
                      exit outer_970;
                   end if;
                   if v_prop_tble(prop_cnt_970).drug_type3 in ('21','22','29') then
                      v_found := 1;
                      exit outer_970;
                   end if;
                end if;
            end loop outer_970;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 970,v_agency);
            end if;
          end if;
        end loop edit_970;
/*972*/ v_found:= 0;
        <<edit_972>>
        for off_cnt_972 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_972).incident_offense_code,1,14) = 'PL 220.16   12'  then
            <<outer_972>>
            For prop_cnt_972 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_972).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_972).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_972;
                   end if;
                   if v_prop_tble(prop_cnt_972).drug_type1 in ('01','02','03','04','05','06','09','10','11','19') then
                      v_found := 1;
                      exit outer_972;
                   end if;
                   if v_prop_tble(prop_cnt_972).drug_type2 in ('01','02','03','04','05','06','09','10','11','19') then
                      v_found := 1;
                      exit outer_972;
                   end if;
                   if v_prop_tble(prop_cnt_972).drug_type3 in ('01','02','03','04','05','06','09','10','11','19') then
                      v_found := 1;
                      exit outer_972;
                   end if;
                end if;
            end loop outer_972;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 972,v_agency);
            end if;
          end if;
        end loop edit_972;
/*974*/ v_found:= 0;
        <<edit_974>>
        for off_cnt_974 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_974).incident_offense_code,1,14) = 'PL 220.18   01'  then
            <<outer_974>>
            For prop_cnt_974 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_974).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_974).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_974;
                   end if;
                   if v_prop_tble(prop_cnt_974).drug_type1 in ('01','02','03','04','05','06','09','10','11','19') then
                      v_found := 1;
                      exit outer_974;
                   end if;
                   if v_prop_tble(prop_cnt_974).drug_type2 in ('01','02','03','04','05','06','09','10','11','19') then
                      v_found := 1;
                      exit outer_974;
                   end if;
                   if v_prop_tble(prop_cnt_974).drug_type3 in ('01','02','03','04','05','06','09','10','11','19') then
                      v_found := 1;
                      exit outer_974;
                   end if;
                end if;
            end loop outer_974;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 974,v_agency);
            end if;
          end if;
        end loop edit_974;
/*976*/ v_found:= 0;
        <<edit_976>>
        for off_cnt_976 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_976).incident_offense_code,1,14) = ('PL 220.18   02')  then
            <<outer_976>>
            For prop_cnt_976 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_976).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_976).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_976;
                   end if;
                   if v_prop_tble(prop_cnt_976).drug_type1 in ('32','33') then
                      v_found := 1;
                      exit outer_976;
                   end if;
                   if v_prop_tble(prop_cnt_976).drug_type2 in ('32','33') then
                      v_found := 1;
                      exit outer_976;
                   end if;
                   if v_prop_tble(prop_cnt_976).drug_type3 in ('32','33') then
                      v_found := 1;
                      exit outer_976;
                   end if;
                end if;
            end loop outer_976;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 976,v_agency);
            end if;
          end if;
        end loop edit_976;
/*978*/ v_found:= 0;
        <<edit_978>>
        for off_cnt_978 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_978).incident_offense_code,1,14) = 'PL 220.18   03'  then
            <<outer_978>>
            For prop_cnt_978 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_978).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_978).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_978;
                   end if;
                   if v_prop_tble(prop_cnt_978).drug_type1 in ('31','32','33','39') then
                      v_found := 1;
                      exit outer_978;
                   end if;
                   if v_prop_tble(prop_cnt_978).drug_type2 in ('31','32','33','39') then
                      v_found := 1;
                      exit outer_978;
                   end if;
                   if v_prop_tble(prop_cnt_978).drug_type3 in ('31','32','33','39') then
                      v_found := 1;
                      exit outer_978;
                   end if;
                end if;
            end loop outer_978;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 978,v_agency);
            end if;
          end if;
        end loop edit_978;
/*980*/ v_found:= 0;
        <<edit_980>>
        for off_cnt_980 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_980).incident_offense_code,1,14) = 'PL 220.18   04'  then
            <<outer_980>>
            For prop_cnt_980 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_980).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_980).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_980;
                   end if;
                   if v_prop_tble(prop_cnt_980).drug_type1 = '22' then
                      v_found := 1;
                      exit outer_980;
                   end if;
                   if v_prop_tble(prop_cnt_980).drug_type2 = '22' then
                      v_found := 1;
                      exit outer_980;
                   end if;
                   if v_prop_tble(prop_cnt_980).drug_type3 = '22' then
                      v_found := 1;
                      exit outer_980;
                   end if;
                end if;
            end loop outer_980;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 980,v_agency);
            end if;
          end if;
        end loop edit_980;
/*982*/ v_found:= 0;
        <<edit_982>>
        for off_cnt_982 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_982).incident_offense_code,1,14) in ('PL 220.18   05', 'PL 220.18   06') then
            <<outer_982>>
            For prop_cnt_982 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_982).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_982).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_982;
                   end if;
                   if v_prop_tble(prop_cnt_982).drug_type1 in ('21','22','29') then
                      v_found := 1;
                      exit outer_982;
                   end if;
                   if v_prop_tble(prop_cnt_982).drug_type2 in ('21','22','29') then
                      v_found := 1;
                      exit outer_982;
                   end if;
                   if v_prop_tble(prop_cnt_982).drug_type3 in ('21','22','29') then
                      v_found := 1;
                      exit outer_982;
                   end if;
                end if;
            end loop outer_982;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 982,v_agency);
            end if;
          end if;
        end loop edit_982;
/*984*/ v_found:= 0;
        <<edit_984>>
        for off_cnt_984 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_984).incident_offense_code,1,14) = 'PL 220.18   07'  then
            <<outer_984>>
            For prop_cnt_984 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_984).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_984).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_984;
                   end if;
                   if v_prop_tble(prop_cnt_984).drug_type1 = '05' then
                      v_found := 1;
                      exit outer_984;
                   end if;
                   if v_prop_tble(prop_cnt_984).drug_type2 = '05' then
                      v_found := 1;
                      exit outer_984;
                   end if;
                   if v_prop_tble(prop_cnt_984).drug_type3 = '05' then
                      v_found := 1;
                      exit outer_984;
                   end if;
                end if;
            end loop outer_984;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 984,v_agency);
            end if;
          end if;
        end loop edit_984;
/*986*/ v_found:= 0;
        <<edit_986>>
        for off_cnt_986 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_986).incident_offense_code,1,14) = 'PL 220.21   01'  then
            <<outer_986>>
            For prop_cnt_986 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_986).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_986).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_986;
                   end if;
                   if v_prop_tble(prop_cnt_986).drug_type1 in ('01','02','03','04','05','06','09','10','11','19') then
                      v_found := 1;
                      exit outer_986;
                   end if;
                   if v_prop_tble(prop_cnt_986).drug_type2 in ('01','02','03','04','05','06','09','10','11','19') then
                      v_found := 1;
                      exit outer_986;
                   end if;
                   if v_prop_tble(prop_cnt_986).drug_type3 in ('01','02','03','04','05','06','09','10','11','19') then
                      v_found := 1;
                      exit outer_986;
                   end if;
                end if;
            end loop outer_986;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 986,v_agency);
            end if;
          end if;
        end loop edit_986;
/*988*/ v_found:= 0;
        <<edit_988>>
        for off_cnt_988 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_988).incident_offense_code,1,14) = 'PL 220.21   02'  then
            <<outer_988>>
            For prop_cnt_988 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_988).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_988).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_988;
                   end if;
                   if v_prop_tble(prop_cnt_988).drug_type1 = '05' then
                      v_found := 1;
                      exit outer_988;
                   end if;
                   if v_prop_tble(prop_cnt_988).drug_type2 = '05' then
                      v_found := 1;
                      exit outer_988;
                   end if;
                   if v_prop_tble(prop_cnt_988).drug_type3 = '05' then
                      v_found := 1;
                      exit outer_988;
                   end if;
                end if;
            end loop outer_988;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 988,v_agency);
            end if;
          end if;
        end loop edit_988;
/*990*/ v_found:= 0;
        <<edit_990>>
        for off_cnt_990 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_990).incident_offense_code,1,14) = 'PL 220.34   01'  then
            <<outer_990>>
            For prop_cnt_990 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_990).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_990).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_990;
                   end if;
                   if v_prop_tble(prop_cnt_990).drug_type1 in ('01','02','03','04','05','06','09','10','11','19') then
                      v_found := 1;
                      exit outer_990;
                   end if;
                   if v_prop_tble(prop_cnt_990).drug_type2 in ('01','02','03','04','05','06','09','10','11','19') then
                      v_found := 1;
                      exit outer_990;
                   end if;
                   if v_prop_tble(prop_cnt_990).drug_type3 in ('01','02','03','04','05','06','09','10','11','19') then
                      v_found := 1;
                      exit outer_990;
                   end if;
                end if;
            end loop outer_990;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 990,v_agency);
            end if;
          end if;
        end loop edit_990;
/*992*/ v_found:= 0;
        <<edit_992>>
        for off_cnt_992 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_992).incident_offense_code,1,14) = 'PL 220.34   02' then
            <<outer_992>>
            For prop_cnt_992 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_992).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_992).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_992;
                   end if;
                   if v_prop_tble(prop_cnt_992).drug_type1 in ('41','42','49') then
                      v_found := 1;
                      exit outer_992;
                   end if;
                   if v_prop_tble(prop_cnt_992).drug_type2 in ('41','42','49') then
                      v_found := 1;
                      exit outer_992;
                   end if;
                   if v_prop_tble(prop_cnt_992).drug_type3 in ('41','42','49') then
                      v_found := 1;
                      exit outer_992;
                   end if;
                end if;
            end loop outer_992;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 992,v_agency);
            end if;
          end if;
        end loop edit_992;
/*994*/ v_found:= 0;
        <<edit_994>>
        for off_cnt_994 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_994).incident_offense_code,1,14) = 'PL 220.34   03' then
            <<outer_994>>
            For prop_cnt_994 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_994).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_994).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_994;
                   end if;
                   if v_prop_tble(prop_cnt_994).drug_type1 in ('51','52','59') then
                      v_found := 1;
                      exit outer_994;
                   end if;
                   if v_prop_tble(prop_cnt_994).drug_type2 in ('51','52','59') then
                      v_found := 1;
                      exit outer_994;
                   end if;
                   if v_prop_tble(prop_cnt_994).drug_type3 in ('51','52','59') then
                      v_found := 1;
                      exit outer_994;
                   end if;
                end if;
            end loop outer_994;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 994 ,v_agency);
            end if;
          end if;
        end loop edit_994;
/*996*/ v_found:= 0;
        <<edit_996>>
        for off_cnt_996 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_996).incident_offense_code,1,14) = 'PL 220.34   05'  then
            <<outer_996>>
            For prop_cnt_996 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_996).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_996).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_996;
                   end if;
                   if v_prop_tble(prop_cnt_996).drug_type1 = '05' then
                      v_found := 1;
                      exit outer_996;
                   end if;
                   if v_prop_tble(prop_cnt_996).drug_type2 = '05' then
                      v_found := 1;
                      exit outer_996;
                   end if;
                   if v_prop_tble(prop_cnt_996).drug_type3 = '05' then
                      v_found := 1;
                      exit outer_996;
                   end if;
                end if;
            end loop outer_996;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 996 ,v_agency);
            end if;
          end if;
        end loop edit_996;
/*998*/ v_found:= 0;
        <<edit_998>>
        for off_cnt_998 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_998).incident_offense_code,1,14) = 'PL 220.39   01'  then
            <<outer_998>>
            For prop_cnt_998 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_998).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_998).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_998;
                   end if;
                   if v_prop_tble(prop_cnt_998).drug_type1 in ('01','02','03','04','05','06','09','10','11','19') then
                      v_found := 1;
                      exit outer_998;
                   end if;
                   if v_prop_tble(prop_cnt_998).drug_type2 in ('01','02','03','04','05','06','09','10','11','19') then
                      v_found := 1;
                      exit outer_998;
                   end if;
                   if v_prop_tble(prop_cnt_998).drug_type3 in ('01','02','03','04','05','06','09','10','11','19') then
                      v_found := 1;
                      exit outer_998;
                   end if;
                end if;
            end loop outer_998;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 998,v_agency);
            end if;
          end if;
        end loop edit_998;
/*1000*/v_found:= 0;
        <<edit_1000>>
        for off_cnt_1000 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_1000).incident_offense_code,1,14) = 'PL 220.39   02'  then
            <<outer_1000>>
            For prop_cnt_1000 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_1000).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_1000).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_1000;
                   end if;
                   if v_prop_tble(prop_cnt_1000).drug_type1 in ('21','22','29','31','33','39') then
                      v_found := 1;
                      exit outer_1000;
                   end if;
                   if v_prop_tble(prop_cnt_1000).drug_type2 in ('21','22','29','31','33','39') then
                      v_found := 1;
                      exit outer_1000;
                   end if;
                   if v_prop_tble(prop_cnt_1000).drug_type3 in ('21','22','29','31','33','39') then
                      v_found := 1;
                      exit outer_1000;
                   end if;
                end if;
            end loop outer_1000;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 1000,v_agency);
            end if;
          end if;
        end loop edit_1000;
/*1002*/v_found:= 0;
        <<edit_1002>>
        for off_cnt_1002 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_1002).incident_offense_code,1,14) = 'PL 220.39   03'  then
            <<outer_1002>>
            For prop_cnt_1002 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_1002).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_1002).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_1002;
                   end if;
                   if v_prop_tble(prop_cnt_1002).drug_type1 in ('31','32','33','39') then
                      v_found := 1;
                      exit outer_1002;
                   end if;
                   if v_prop_tble(prop_cnt_1002).drug_type2 in ('31','32','33','39') then
                      v_found := 1;
                      exit outer_1002;
                   end if;
                   if v_prop_tble(prop_cnt_1002).drug_type3 in ('31','32','33','39') then
                      v_found := 1;
                      exit outer_1002;
                   end if;
                end if;
            end loop outer_1002;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 1002,v_agency);
            end if;
          end if;
        end loop edit_1002;
/*1004*/v_found:= 0;
        <<edit_1004>>
        for off_cnt_1004 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_1004).incident_offense_code,1,14) = 'PL 220.39   04'  then
            <<outer_1004>>
            For prop_cnt_1004 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_1004).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_1004).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_1004;
                   end if;
                   if v_prop_tble(prop_cnt_1004).drug_type1 = '22' then
                      v_found := 1;
                      exit outer_1004;
                   end if;
                   if v_prop_tble(prop_cnt_1004).drug_type2 = '22' then
                      v_found := 1;
                      exit outer_1004;
                   end if;
                   if v_prop_tble(prop_cnt_1004).drug_type3 = '22' then
                      v_found := 1;
                      exit outer_1004;
                   end if;
                end if;
            end loop outer_1004;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 1004,v_agency);
            end if;
          end if;
        end loop edit_1004;
/*1006*/v_found:= 0;
        <<edit_1006>>
        for off_cnt_1006 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_1006).incident_offense_code,1,14) in ('PL 220.39   05','PL 220.39   06')  then
            <<outer_1006>>
            For prop_cnt_1006 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_1006).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_1006).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_1006;
                   end if;
                   if v_prop_tble(prop_cnt_1006).drug_type1 in ('21','22','29') then
                      v_found := 1;
                      exit outer_1006;
                   end if;
                   if v_prop_tble(prop_cnt_1006).drug_type2 in ('21','22','29') then
                      v_found := 1;
                      exit outer_1006;
                   end if;
                   if v_prop_tble(prop_cnt_1006).drug_type3 in ('21','22','29') then
                      v_found := 1;
                      exit outer_1006;
                   end if;
                end if;
            end loop outer_1006;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 1006,v_agency);
            end if;
          end if;
        end loop edit_1006;
/*1008*/v_found:= 0;
        <<edit_1008>>
        for off_cnt_1008 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_1008).incident_offense_code,1,14) = 'PL 220.39   07'  then
            <<outer_1008>>
            For prop_cnt_1008 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_1008).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_1008).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_1008;
                   end if;
                   if v_prop_tble(prop_cnt_1008).drug_type1 in ('32','33') then
                      v_found := 1;
                      exit outer_1008;
                   end if;
                   if v_prop_tble(prop_cnt_1008).drug_type2 in ('32','33') then
                      v_found := 1;
                      exit outer_1008;
                   end if;
                   if v_prop_tble(prop_cnt_1008).drug_type3 in ('32','33') then
                      v_found := 1;
                      exit outer_1008;
                   end if;
                end if;
            end loop outer_1008;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 1008,v_agency);
            end if;
          end if;
        end loop edit_1008;
/*1010*/ v_found:= 0;
        <<edit_1010>>
        for off_cnt_1010 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_1010).incident_offense_code,1,14) = 'PL 220.41   01'  then
            <<outer_1010>>
            For prop_cnt_1010 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_1010).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_1010).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_1010;
                   end if;
                   if v_prop_tble(prop_cnt_1010).drug_type1 in ('01','02','03','04','05','06','09','10','11','19') then
                      v_found := 1;
                      exit outer_1010;
                   end if;
                   if v_prop_tble(prop_cnt_1010).drug_type2 in ('01','02','03','04','05','06','09','10','11','19') then
                      v_found := 1;
                      exit outer_1010;
                   end if;
                   if v_prop_tble(prop_cnt_1010).drug_type3 in ('01','02','03','04','05','06','09','10','11','19') then
                      v_found := 1;
                      exit outer_1010;
                   end if;
                end if;
            end loop outer_1010;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 1010,v_agency);
            end if;
          end if;
        end loop edit_1010;
/*1012*/v_found:= 0;
        <<edit_1012>>
        for off_cnt_1012 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_1012).incident_offense_code,1,14) = 'PL 220.41   02'  then
            <<outer_1012>>
            For prop_cnt_1012 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_1012).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_1012).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_1012;
                   end if;
                   if v_prop_tble(prop_cnt_1012).drug_type1 in ('32','33') then
                      v_found := 1;
                      exit outer_1012;
                   end if;
                   if v_prop_tble(prop_cnt_1012).drug_type2 in ('32','33') then
                      v_found := 1;
                      exit outer_1012;
                   end if;
                   if v_prop_tble(prop_cnt_1012).drug_type3 in ('32','33') then
                      v_found := 1;
                      exit outer_1012;
                   end if;
                end if;
            end loop outer_1012;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 1012,v_agency);
            end if;
          end if;
        end loop edit_1012;
/*1014*/v_found:= 0;
        <<edit_1014>>
        for off_cnt_1014 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_1014).incident_offense_code,1,14) = 'PL 220.41   03'  then
            <<outer_1014>>
            For prop_cnt_1014 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_1014).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_1014).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_1014;
                   end if;
                   if v_prop_tble(prop_cnt_1014).drug_type1 in ('31','32','33','39') then
                      v_found := 1;
                      exit outer_1014;
                   end if;
                   if v_prop_tble(prop_cnt_1014).drug_type2 in ('31','32','33','39') then
                      v_found := 1;
                      exit outer_1014;
                   end if;
                   if v_prop_tble(prop_cnt_1014).drug_type3 in ('31','32','33','39') then
                      v_found := 1;
                      exit outer_1014;
                   end if;
                end if;
            end loop outer_1014;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 1014 ,v_agency);
            end if;
          end if;
        end loop edit_1014;
/*1016*/v_found:= 0;
        <<edit_1016>>
        for off_cnt_1016 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_1016).incident_offense_code,1,14) = 'PL 220.41   04'  then
            <<outer_1016>>
            For prop_cnt_1016 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_1016).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_1016).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_1016;
                   end if;
                   if v_prop_tble(prop_cnt_1016).drug_type1 = '22' then
                      v_found := 1;
                      exit outer_1016;
                   end if;
                   if v_prop_tble(prop_cnt_1016).drug_type2 = '22' then
                      v_found := 1;
                      exit outer_1016;
                   end if;
                   if v_prop_tble(prop_cnt_1016).drug_type3 = '22' then
                      v_found := 1;
                      exit outer_1016;
                   end if;
                end if;
            end loop outer_1016;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 1016,v_agency);
            end if;
          end if;
        end loop edit_1016;
/*1018*/v_found:= 0;
        <<edit_1018>>
        for off_cnt_1018 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_1018).incident_offense_code,1,14) in ('PL 220.41   05', 'PL 220.41   06') then
            <<outer_1018>>
            For prop_cnt_1018 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_1018).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_1018).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_1018;
                   end if;
                   if v_prop_tble(prop_cnt_1018).drug_type1 in ('21','22','29') then
                      v_found := 1;
                      exit outer_1018;
                   end if;
                   if v_prop_tble(prop_cnt_1018).drug_type2 in ('21','22','29') then
                      v_found := 1;
                      exit outer_1018;
                   end if;
                   if v_prop_tble(prop_cnt_1018).drug_type3 in ('21','22','29') then
                      v_found := 1;
                      exit outer_1018;
                   end if;
                end if;
            end loop outer_1018;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 1018,v_agency);
            end if;
          end if;
        end loop edit_1018;
/*1020*/v_found:= 0;
        <<edit_1020>>
        for off_cnt_1020 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_1020).incident_offense_code,1,14) = 'PL 220.41   07'  then
            <<outer_1020>>
            For prop_cnt_1020 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_1020).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_1020).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_1020;
                   end if;
                   if v_prop_tble(prop_cnt_1020).drug_type1 = '05' then
                      v_found := 1;
                      exit outer_1020;
                   end if;
                   if v_prop_tble(prop_cnt_1020).drug_type2 = '05' then
                      v_found := 1;
                      exit outer_1020;
                   end if;
                   if v_prop_tble(prop_cnt_1020).drug_type3 = '05' then
                      v_found := 1;
                      exit outer_1020;
                   end if;
                end if;
            end loop outer_1020;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 1020 ,v_agency);
            end if;
          end if;
        end loop edit_1020;
/*1022*/ v_found:= 0;
        <<edit_1022>>
        for off_cnt_1022 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_1022).incident_offense_code,1,14) = 'PL 220.43   01'  then
            <<outer_1022>>
            For prop_cnt_1022 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_1022).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_1022).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_1022;
                   end if;
                   if v_prop_tble(prop_cnt_1022).drug_type1 in ('01','02','03','04','05','06','09','10','11','19') then
                      v_found := 1;
                      exit outer_1022;
                   end if;
                   if v_prop_tble(prop_cnt_1022).drug_type2 in ('01','02','03','04','05','06','09','10','11','19') then
                      v_found := 1;
                      exit outer_1022;
                   end if;
                   if v_prop_tble(prop_cnt_1022).drug_type3 in ('01','02','03','04','05','06','09','10','11','19') then
                      v_found := 1;
                      exit outer_1022;
                   end if;
                end if;
            end loop outer_1022;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 1022,v_agency);
            end if;
          end if;
        end loop edit_1022;
/*1024*/v_found:= 0;
        <<edit_1024>>
        for off_cnt_1024 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_1024).incident_offense_code,1,14) = 'PL 220.43   02'  then
            <<outer_1024>>
            For prop_cnt_1024 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_1024).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_1024).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_1024;
                   end if;
                   if v_prop_tble(prop_cnt_1024).drug_type1 = '05' then
                      v_found := 1;
                      exit outer_1024;
                   end if;
                   if v_prop_tble(prop_cnt_1024).drug_type2 = '05' then
                      v_found := 1;
                      exit outer_1024;
                   end if;
                   if v_prop_tble(prop_cnt_1024).drug_type3 = '05' then
                      v_found := 1;
                      exit outer_1024;
                   end if;
                end if;
            end loop outer_1024;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 1024 ,v_agency);
            end if;
          end if;
        end loop edit_1024;
/*1026*/v_found:= 0;
        <<edit_1026>>
        for off_cnt_1026 in 1..off_tble_cnt loop
          if substr(v_off_tble(off_cnt_1026).incident_offense_code,1,14)
           in ('PL 221.05     ','PL 221.10     ',
               'PL 221.10   01','PL 221.10   02','PL 221.15     ','PL 221.20     ',
               'PL 221.25     ','PL 221.30     ','PL 221.35     ','PL 221.40     ',
               'PL 221.45     ','PL 221.50     ','PL 221.55     ') then
            <<outer_1026>>
            For prop_cnt_1026 in 1..prop_tble_cnt loop
                if v_prop_tble(prop_cnt_1026).property_involvement = '06' then
                   if v_prop_tble(prop_cnt_1026).drug_type3 = '97' then
                      v_found := 1;
                      exit outer_1026;
                   end if;
                   if v_prop_tble(prop_cnt_1026).drug_type1 = '51' then
                      v_found := 1;
                      exit outer_1026;
                   end if;
                   if v_prop_tble(prop_cnt_1026).drug_type2 = '51' then
                      v_found := 1;
                      exit outer_1026;
                   end if;
                   if v_prop_tble(prop_cnt_1026).drug_type3 = '51' then
                      v_found := 1;
                      exit outer_1026;
                   end if;
                end if;
            end loop outer_1026;
            if v_found <> 1 then
                update_status(3, v_prop_tble(1).adm_id, v_prop_tble(1).incident_number, 1026,v_agency);
            end if;
          end if;
        end loop edit_1026;
       end if;   /* outmost IF*/
    END;        /*out most begin*/
    CLOSE PROPERTY_CURSOR;
/* Offender Processing*/
     ofd_tble_cnt:=0;
     OPEN OFFENDER_CURSOR;
     LOOP
      Fetch offender_cursor into v_ofd_rec;
      EXIT when offender_cursor%notfound;
       BEGIN
        ofd_tble_cnt := ofd_tble_cnt+1;                                                  /* load offender cursor row into table */
        v_ofd_tble(ofd_tble_cnt):= v_ofd_rec;
      --  dbms_output.put_line('ofd'||v_adm_rec.incident_number);
/*600*/
       if v_ofd_rec.segment_action not in ('I', 'R', 'W') then
          update_status(4, v_ofd_rec.adm_id, v_ofd_rec.incident_number, 600 ,v_agency);
       end if;
/*617*/
       if v_ofd_rec.segment_type <> '4' then
          update_status(4, v_ofd_rec.adm_id, v_ofd_rec.incident_number, 617,v_agency);
       end if;
        Select count(*) into v_rec_cnt from ibr_offender_segment
         where incident_number = v_adm_rec.incident_number;
/*638*/
         if v_rec_cnt > 99 then
            update_status(4, v_ofd_rec.adm_id, v_ofd_rec.incident_number, 638 ,v_agency);
         end if;
/*634*/
         if v_adm_rec.segment_action in ('I', 'R') then
            if v_rec_cnt < 1 then
               update_status(4, v_ofd_rec.adm_id, v_ofd_rec.incident_number, 634 ,v_agency);
            end if;
         end if;
/*744*/
       if v_adm_rec.incident_case_status between '10' and '14' then
          select count(*)  into v_rec_cnt from ibr_offender_segment
            where adm_id = v_adm_rec.adm_id
              and incident_number = v_adm_rec.incident_number
              and offender_number <> '999';
           if v_rec_cnt < 1 then
               update_status(4, v_ofd_rec.adm_id, v_ofd_rec.incident_number, 744,v_agency);
           end if;
/*745*/
          Select count(*) into v_rec_cnt from ibr_offender_segment
            where adm_id = v_adm_rec.adm_id
              and incident_number = v_adm_rec.incident_number
              and offender_age <> '9999';
           if v_rec_cnt < 1 then
               update_status(4, v_ofd_rec.adm_id, v_ofd_rec.incident_number, 745 ,v_agency);
           end if;
/*746*/
         Select count(*) into v_rec_cnt from ibr_offender_segment
            where adm_id = v_adm_rec.adm_id
              and incident_number = v_adm_rec.incident_number
              and offender_sex not in ('U','R');
           if v_rec_cnt < 1 then
               update_status(4, v_ofd_rec.adm_id, v_ofd_rec.incident_number, 746,v_agency);
           end if;
/*747*/
           Select count(*) into v_rec_cnt from ibr_offender_segment
            where adm_id = v_adm_rec.adm_id
              and incident_number = v_adm_rec.incident_number
              and offender_race not in ('U','R');
           if v_rec_cnt < 1 then
               update_status(4, v_ofd_rec.adm_id, v_ofd_rec.incident_number, 747,v_agency);
           end if;
       end if;
     END;            /* outmost Begin*/
   END LOOP;         /*cursor for loop*/
/*636*/                                /*after rows insertred into table*/
      BEGIN
       if ofd_tble_cnt > 1 then
         for ofd_cnt_636 in 1..ofd_tble_cnt loop
             if ofd_cnt_636<>ofd_tble_cnt then
               if v_ofd_tble(ofd_cnt_636).offender_number = v_ofd_tble(ofd_cnt_636+1).offender_number then
                   update_status(4, v_ofd_tble(ofd_cnt_636).adm_id, v_ofd_tble(ofd_cnt_636).incident_number, 636 ,v_agency);
                end if;
             end if;
/*640*/
               if v_ofd_tble(ofd_cnt_636).offender_number = '999' then
                 if ofd_tble_cnt > 1 then
                    update_status(4, v_ofd_tble(ofd_cnt_636).adm_id, v_ofd_tble(ofd_cnt_636).incident_number, 640 ,v_agency);
                 end if;
               end if;
/*653*/
             if v_adm_rec.incident_case_status = '14' then
                if v_ofd_tble(ofd_cnt_636).offender_age < '0016' then
                   v_age_sw := 'T';
                end if;
             end if;
         end loop;
        if v_adm_rec.incident_case_status = '14' then
           if v_age_sw <> 'T' then
              update_status(4, v_ofd_tble(1).adm_id, v_ofd_tble(1).incident_number, 653,v_agency);
           end if;
        end if;
       end if;
      END;                   /*outmost begin*/
    CLOSE OFFENDER_CURSOR;
/*victim processing*/
     vic_tble_cnt:= 0;
     OPEN VICTIM_CURSOR;
      LOOP
      FETCH VICTIM_CURSOR into v_vic_rec;
      EXIT when VICTIM_CURSOR%notfound;
       BEGIN
       vic_tble_cnt := vic_tble_cnt + 1;                                        /*load victim cursor rows into table */
       v_vic_tble(vic_tble_cnt) := v_vic_rec;
     --  dbms_output.put_line('vic'||v_adm_rec.incident_number);
/*600*/
      if v_adm_rec.segment_action not in ('I', 'R','W') then
         update_status(5, v_vic_rec.adm_id, v_vic_rec.incident_number, 600,v_agency);
      end if;
/*617*/
      if v_vic_rec.segment_type <> '5' then
         update_status(5, v_vic_rec.adm_id, v_vic_rec.incident_number, 617,v_agency);
      end if;
       Select count(*) into v_rec_cnt from ibr_victim_segment
         where adm_id = v_vic_rec.adm_id
           and victim_type = 'S';
/*680*/
         if v_rec_cnt > 1 then
            update_status(5, v_vic_rec.adm_id, v_vic_rec.incident_number, 680,v_agency);
         end if;
         Select count(*) into v_rec_cnt from ibr_victim_segment
          where incident_number = v_adm_rec.incident_number;
/*646*/
         if v_rec_cnt > 999 then
            update_status(5, v_vic_rec.adm_id, v_vic_rec.incident_number, 646,v_agency);
         end if;
/*642*/
         if v_adm_rec.segment_action in ('I', 'R') then
            if v_rec_cnt < 1 then
               update_status(5, v_vic_rec.adm_id, v_vic_rec.incident_number, 642 ,v_agency);
            end if;
         end if;
/*644*/
         if v_rec_cnt > 1 then
            v_vic_tble(k).victim_number := v_vic_rec.victim_number;
         end if;
       END;                    /* outmost Begin*/
      END LOOP;               /*end cursor for loop*/
                              /* After rows inserted into table*/
      BEGIN
         FOR vic_cnt_644 in 1..vic_tble_cnt loop
            if vic_cnt_644 <> vic_tble_cnt then
               if v_vic_tble(vic_cnt_644).victim_number = v_vic_tble(vic_cnt_644 + 1).victim_number then
                  update_status(5, v_vic_tble(vic_cnt_644).adm_id, v_vic_tble(vic_cnt_644).incident_number, 644 ,v_agency);
               end if;
            end if;
         end loop;
/*676*/  <<edit_676>>
         for vic_cnt_676 in 1..vic_tble_cnt loop
           v_vicoff_t(1) := v_vic_tble(vic_cnt_676).victim_offense_link1;               /*load 1 - 10 occurences of vicitm offense */
           v_vicoff_t(2) := v_vic_tble(vic_cnt_676).victim_offense_link2;
           v_vicoff_t(3) := v_vic_tble(vic_cnt_676).victim_offense_link3;
           v_vicoff_t(4) := v_vic_tble(vic_cnt_676).victim_offense_link4;
           v_vicoff_t(5) := v_vic_tble(vic_cnt_676).victim_offense_link5;
           v_vicoff_t(6) := v_vic_tble(vic_cnt_676).victim_offense_link6;
           v_vicoff_t(7) := v_vic_tble(vic_cnt_676).victim_offense_link7;
           v_vicoff_t(8) := v_vic_tble(vic_cnt_676).victim_offense_link8;
           v_vicoff_t(9) := v_vic_tble(vic_cnt_676).victim_offense_link9;
           v_vicoff_t(10) := v_vic_tble(vic_cnt_676).victim_offense_link10;
           v_found:=0;
           <<outer_676>>
           for vic_off_cnt_676 in 1..10 loop
            if v_vicoff_t(vic_off_cnt_676) <> '77' then
              <<inner_676>>                                                                        /* if the vic/ofd link <> 77 */
              for off_cnt_676 in 1..off_tble_cnt loop                                              /* then for each occurence in the offense table */
               if v_vicoff_t(vic_off_cnt_676) = v_off_tble(off_cnt_676).offense_number then        /* the vic/off link must link to an offense */
                  v_found:=1;                                                                      /* Found */
                  exit inner_676;                                                                  /* Stop looking get next one */
               end if;
              end loop inner_676;
              if v_found = 0 then                                                                 /* not found */
                 update_status(5, v_vic_tble(vic_cnt_676).adm_id, v_vic_tble(vic_cnt_676).incident_number, 676 ,v_agency);
              else
                 v_found:=0;                                                                      /* reset switch*/
              end if;
            end if;
           end loop outer_676;
         end loop edit_676;
/*678*/  <<edit_678>>
        v_notfound := 0;
	for off_cnt_678 in 1..off_tble_cnt loop
          v_found := 0;
         	<<victims_678>>
		for vic_cnt_678 in 1..vic_tble_cnt loop /* no of victims */
           		v_vicoff_t(1) := v_vic_tble(vic_cnt_678).victim_offense_link1;
           		v_vicoff_t(2) := v_vic_tble(vic_cnt_678).victim_offense_link2;
           		v_vicoff_t(3) := v_vic_tble(vic_cnt_678).victim_offense_link3;
           		v_vicoff_t(4) := v_vic_tble(vic_cnt_678).victim_offense_link4;
           		v_vicoff_t(5) := v_vic_tble(vic_cnt_678).victim_offense_link5;
           		v_vicoff_t(6) := v_vic_tble(vic_cnt_678).victim_offense_link6;
           		v_vicoff_t(7) := v_vic_tble(vic_cnt_678).victim_offense_link7;
           		v_vicoff_t(8) := v_vic_tble(vic_cnt_678).victim_offense_link8;
           		v_vicoff_t(9) := v_vic_tble(vic_cnt_678).victim_offense_link9;
           		v_vicoff_t(10) := v_vic_tble(vic_cnt_678).victim_offense_link10;
                        <<link_678>>
			for vic_off_cnt_678 in 1..10 loop
 			 if v_vicoff_t(vic_off_cnt_678) = v_off_tble(off_cnt_678).offense_number then
                 			v_found := 1;
                 			exit victims_678;
               			end if;
			end loop link_678;
                 end loop victims_678;
                 if v_found = 0 THEN
                   v_notfound := 1;
                 end if;
        end loop edit_678;
        if v_notfound = 1 AND v_adm_rec.segment_action NOT IN ('U') then
        	update_status(5, v_adm_rec.adm_id, v_adm_rec.incident_number, 678,v_agency);
        end if;
/*684*/  <<edit_684>>
         v_found := 0;
         for vic_cnt_684 in 1..vic_tble_cnt loop
           if v_vic_tble(vic_cnt_684).victim_type = 'S' then
               v_vicoff_t(1) := v_vic_tble(vic_cnt_684).victim_offense_link1;               /*load 1 - 10 occurences of vicitm offense */
               v_vicoff_t(2) := v_vic_tble(vic_cnt_684).victim_offense_link2;
               v_vicoff_t(3) := v_vic_tble(vic_cnt_684).victim_offense_link3;
               v_vicoff_t(4) := v_vic_tble(vic_cnt_684).victim_offense_link4;
               v_vicoff_t(5) := v_vic_tble(vic_cnt_684).victim_offense_link5;
               v_vicoff_t(6) := v_vic_tble(vic_cnt_684).victim_offense_link6;
               v_vicoff_t(7) := v_vic_tble(vic_cnt_684).victim_offense_link7;
               v_vicoff_t(8) := v_vic_tble(vic_cnt_684).victim_offense_link8;
               v_vicoff_t(9) := v_vic_tble(vic_cnt_684).victim_offense_link9;
               v_vicoff_t(10) := v_vic_tble(vic_cnt_684).victim_offense_link10;
               <<outer_684>>
               for vic_off_cnt_684 in 1..10 loop
                 if v_vicoff_t(vic_off_cnt_684) <> '77' then
                    <<inner_684>>
                    for off_cnt_684 in 1..off_tble_cnt loop
                       if v_vicoff_t(vic_off_cnt_684) = v_off_tble(off_cnt_684).offense_number then
                          if v_off_tble(off_cnt_684).ucr_code not between '90A' and '90Z' then
                             if v_off_tble(off_cnt_684).ucr_code not in ('35A','35B','39A','39B','39C','39D','90B','90G','370','40A','40B','520','720','999','90Z') then
                                update_status(5, v_vic_tble(vic_cnt_684).adm_id, v_vic_tble(vic_cnt_684).incident_number, 684 ,v_agency);
                             end if;
                          end if;
                       end if;
                    end loop inner_684;
                 end if;
               end loop outer_684;
            end if;
         end loop edit_684;
/*686*/ <<edit_686>>
        v_found := 0;
        for vic_cnt_686 in 1..vic_tble_cnt loop
          v_vicofd_t(1) := v_vic_tble(vic_cnt_686).victim_offender_link1;             /*load 1 - 10 occurences of victim offender */
          v_vicofd_t(2) := v_vic_tble(vic_cnt_686).victim_offender_link2;
          v_vicofd_t(3) := v_vic_tble(vic_cnt_686).victim_offender_link3;
          v_vicofd_t(4) := v_vic_tble(vic_cnt_686).victim_offender_link4;
          v_vicofd_t(5) := v_vic_tble(vic_cnt_686).victim_offender_link5;
          v_vicofd_t(6) := v_vic_tble(vic_cnt_686).victim_offender_link6;
          v_vicofd_t(7) := v_vic_tble(vic_cnt_686).victim_offender_link7;
          v_vicofd_t(8) := v_vic_tble(vic_cnt_686).victim_offender_link8;
          v_vicofd_t(9) := v_vic_tble(vic_cnt_686).victim_offender_link9;
          v_vicofd_t(10) := v_vic_tble(vic_cnt_686).victim_offender_link10;
          v_found:=0;
          <<outer_686>>
          for vic_off_cnt_686 in 1..10 loop
            if v_vicofd_t(vic_off_cnt_686) <> '777' then
               <<inner_686>>
               for off_cnt_686 in 1..ofd_tble_cnt loop
                 if v_vicofd_t(vic_off_cnt_686) = v_ofd_tble(off_cnt_686).offender_number then
                    v_found := 1;
                    exit inner_686;
                 end if;
               end loop inner_686;
               if v_found = 0 then
                  update_status(5, v_vic_tble(vic_cnt_686).adm_id, v_vic_tble(vic_cnt_686).incident_number, 686,v_agency);
               end if;
             end if;
           end loop outer_686;
         end loop edit_686;
/* 748-754*/
        <<edit_748_754>>
        for vic_cnt_748 in 1..vic_tble_cnt loop
          v_vicoff_t(1) := v_vic_tble(vic_cnt_748).victim_offense_link1;
          v_vicoff_t(2) := v_vic_tble(vic_cnt_748).victim_offense_link2;
          v_vicoff_t(3) := v_vic_tble(vic_cnt_748).victim_offense_link3;
          v_vicoff_t(4) := v_vic_tble(vic_cnt_748).victim_offense_link4;
          v_vicoff_t(5) := v_vic_tble(vic_cnt_748).victim_offense_link5;
          v_vicoff_t(6) := v_vic_tble(vic_cnt_748).victim_offense_link6;
          v_vicoff_t(7) := v_vic_tble(vic_cnt_748).victim_offense_link7;
          v_vicoff_t(8) := v_vic_tble(vic_cnt_748).victim_offense_link8;
          v_vicoff_t(9) := v_vic_tble(vic_cnt_748).victim_offense_link9;
          v_vicoff_t(10) := v_vic_tble(vic_cnt_748).victim_offense_link10;
          v_vicofd_t(1) := v_vic_tble(vic_cnt_748).victim_offender_link1;
          v_vicofd_t(2) := v_vic_tble(vic_cnt_748).victim_offender_link2;
          v_vicofd_t(3) := v_vic_tble(vic_cnt_748).victim_offender_link3;
          v_vicofd_t(4) := v_vic_tble(vic_cnt_748).victim_offender_link4;
          v_vicofd_t(5) := v_vic_tble(vic_cnt_748).victim_offender_link5;
          v_vicofd_t(6) := v_vic_tble(vic_cnt_748).victim_offender_link6;
          v_vicofd_t(7) := v_vic_tble(vic_cnt_748).victim_offender_link7;
          v_vicofd_t(8) := v_vic_tble(vic_cnt_748).victim_offender_link8;
          v_vicofd_t(9) := v_vic_tble(vic_cnt_748).victim_offender_link9;
          v_vicofd_t(10) := v_vic_tble(vic_cnt_748).victim_offender_link10;
          v_found := 0;
          <<outer_ucr>>
          for vic_off_cnt_748 in 1..10 loop
            if v_vicoff_t(vic_off_cnt_748) not in ('77', '88','99') then
               <<inner_ucr>>
               for off_cnt_748 in 1..off_tble_cnt loop
                 if v_vicoff_t(vic_off_cnt_748) = v_off_tble(off_cnt_748).offense_number then
                    if v_off_tble(off_cnt_748).ucr_code = '09C' then
                       v_found := 1;
                       exit outer_ucr;
                    end if;
                 end if;
               end loop inner_ucr;
            end if;
          end loop outer_ucr;
          if v_found = 1 then
           <<outer_748_754>>
           for vic_ofd_cnt_748 in 1..10 loop
              if v_vicofd_t(vic_ofd_cnt_748) not in ('77', '88', '99') then
                 <<inner_748_754>>
                 for ofd_cnt_748 in 1..ofd_tble_cnt loop
                 if v_vicofd_t(vic_ofd_cnt_748) = v_ofd_tble(ofd_cnt_748).offender_number then
                   BEGIN
                    if v_ofd_tble(ofd_cnt_748).offender_number = '999' then
                        update_status(5, v_vic_tble(vic_cnt_748).adm_id, v_vic_tble(vic_cnt_748).incident_number, 748,v_agency);
                    end if;
                    if v_ofd_tble(ofd_cnt_748).offender_age = '9999' then
                       update_status(5, v_vic_tble(vic_cnt_748).adm_id, v_vic_tble(vic_cnt_748).incident_number, 750,v_agency);
                    end if;
                    if v_ofd_tble(ofd_cnt_748).offender_sex in ('U','R') then
                       update_status(5, v_vic_tble(vic_cnt_748).adm_id, v_vic_tble(vic_cnt_748).incident_number, 752,v_agency);
                    end if;
                    if v_ofd_tble(ofd_cnt_748).offender_race in ('U','R') then
                        update_status(5, v_vic_tble(vic_cnt_748).adm_id, v_vic_tble(vic_cnt_748).incident_number, 754,v_agency);
                    end if;
                   END;
                 end if;
                 end loop inner_748_754;
               end if;
            end loop outer_748_754;
          end if;
         end loop edit_748_754;
/*756*/ <<edit_756>>
        for vic_cnt_756 in 1..vic_tble_cnt loop                                     /* for each record in the victim table */
         v_vicoff_t(1) := v_vic_tble(vic_cnt_756).victim_offense_link1;                 /*load 1 - 10 occurences of vicitm offense  for each row in cursor vicitm table*/
         v_vicoff_t(2) := v_vic_tble(vic_cnt_756).victim_offense_link2;
         v_vicoff_t(3) := v_vic_tble(vic_cnt_756).victim_offense_link3;
         v_vicoff_t(4) := v_vic_tble(vic_cnt_756).victim_offense_link4;
         v_vicoff_t(5) := v_vic_tble(vic_cnt_756).victim_offense_link5;
         v_vicoff_t(6) := v_vic_tble(vic_cnt_756).victim_offense_link6;
         v_vicoff_t(7) := v_vic_tble(vic_cnt_756).victim_offense_link7;
         v_vicoff_t(8) := v_vic_tble(vic_cnt_756).victim_offense_link8;
         v_vicoff_t(9) := v_vic_tble(vic_cnt_756).victim_offense_link9;
         v_vicoff_t(10) := v_vic_tble(vic_cnt_756).victim_offense_link10;
         <<outer_756>>
         for vic_off_cnt_756 in 1..10 loop                                                  /* for each of 1-10 occurences of victim offense */
           if v_vicoff_t(vic_off_cnt_756) <> '77' then                                      /* if vicitm offense <> '77' */
              <<inner_756>>
              for off_cnt_756 in 1..off_tble_cnt loop                                       /* then for each offense in v_off_tble */
                if v_vicoff_t(vic_off_cnt_756) = v_off_tble(off_cnt_756).offense_number then         /* if the vicitm offense link = occurense in off tble */
-- ADDED BY CI 09/19/2001 BUG NO 66
--                   if v_off_tble(off_cnt_756).ucr_code in ('13A','13B','13C','90F','09A',
--                                                 '09B','09C','100','11A','11B',
--                                                 '11C','11D','11E','36A','36B') then
			   if v_off_tble(off_cnt_756).ucr_code in ('13A','13B','13C','09A','09B','09C','100','11A','11B','11C','11D','36A','36B','90F') THEN
-- ADDED BY CI 09/19/2001 BUG NO 66
                      if v_vic_tble(vic_cnt_756).victim_type not in ('I','L', 'A') then          /* then the vicitm sex must be M or F */
                         update_status(5, v_vic_tble(vic_cnt_756).adm_id, v_vic_tble(vic_cnt_756).incident_number, 756,v_agency);
                      end if;
                   end if;
                end if;
              end loop inner_756;
           end if;
         end loop outer_756;
        end loop edit_756;
/*758*/ <<edit_758>>
        for vic_cnt_758 in 1..vic_tble_cnt loop                                     /* for each record in the victim table */
          v_vicoff_t(1) := v_vic_tble(vic_cnt_758).victim_offense_link1;                 /*load 1 - 10 occurences of vicitm offense  for each row in cursor vicitm table*/
          v_vicoff_t(2) := v_vic_tble(vic_cnt_758).victim_offense_link2;
          v_vicoff_t(3) := v_vic_tble(vic_cnt_758).victim_offense_link3;
          v_vicoff_t(4) := v_vic_tble(vic_cnt_758).victim_offense_link4;
          v_vicoff_t(5) := v_vic_tble(vic_cnt_758).victim_offense_link5;
          v_vicoff_t(6) := v_vic_tble(vic_cnt_758).victim_offense_link6;
          v_vicoff_t(7) := v_vic_tble(vic_cnt_758).victim_offense_link7;
          v_vicoff_t(8) := v_vic_tble(vic_cnt_758).victim_offense_link8;
          v_vicoff_t(9) := v_vic_tble(vic_cnt_758).victim_offense_link9;
          v_vicoff_t(10) := v_vic_tble(vic_cnt_758).victim_offense_link10;
          <<outer_758>>
          for vic_off_cnt_758 in 1..10 loop                                                  /* for each of 1-10 occurences of victim offense */
            if v_vicoff_t(vic_off_cnt_758) <> '77' then                                      /* if vicitm offense <> '77' */
                <<inner_758>>
                for off_cnt_758 in 1..off_tble_cnt loop                                      /* then for each offense in v_off_tble */
                  if v_vicoff_t(vic_off_cnt_758) = v_off_tble(off_cnt_758).offense_number then         /* if the vicitm offense link = occurense in off tble */
                     if v_off_tble(off_cnt_758).ucr_code in ('200','90A','510','220','250',
                                                   '290','270','210','26A','26B',
                                                   '26C','26D','26E','23A','23B',
                                                   '23C','23D','23E','23F','23G',
                                                   '23H','240','120','280') then
                        if v_vic_tble(vic_cnt_758).victim_type = 'S' then          /* then the vicitm sex must be M or F */
                           update_status(5, v_vic_tble(vic_cnt_758).adm_id, v_vic_tble(vic_cnt_758).incident_number, 758,v_agency);
                        end if;
                     end if;
                  end if;
                end loop inner_758;
            end if;
          end loop outer_758;
        end loop edit_758;
/*762*/ <<edit_762>>
        for vic_cnt_762 in 1..vic_tble_cnt loop                                     /* for each record in the victim table */
          v_vicoff_t(1) := v_vic_tble(vic_cnt_762).victim_offense_link1;                 /*load 1 - 10 occurences of vicitm offense  for each row in cursor vicitm table*/
          v_vicoff_t(2) := v_vic_tble(vic_cnt_762).victim_offense_link2;
          v_vicoff_t(3) := v_vic_tble(vic_cnt_762).victim_offense_link3;
          v_vicoff_t(4) := v_vic_tble(vic_cnt_762).victim_offense_link4;
          v_vicoff_t(5) := v_vic_tble(vic_cnt_762).victim_offense_link5;
          v_vicoff_t(6) := v_vic_tble(vic_cnt_762).victim_offense_link6;
          v_vicoff_t(7) := v_vic_tble(vic_cnt_762).victim_offense_link7;
          v_vicoff_t(8) := v_vic_tble(vic_cnt_762).victim_offense_link8;
          v_vicoff_t(9) := v_vic_tble(vic_cnt_762).victim_offense_link9;
          v_vicoff_t(10) := v_vic_tble(vic_cnt_762).victim_offense_link10;
          <<outer_762>>
          for vic_off_cnt_762 in 1..10 loop                                                  /* for each of 1-10 occurences of victim offense */
            if v_vicoff_t(vic_off_cnt_762) <> '77' then                                      /* if vicitm offense <> '77' */
                <<inner_762>>
                for off_cnt_762 in 1..off_tble_cnt loop                              /* then for each offense in v_off_tble */
                  if v_vicoff_t(vic_off_cnt_762) = v_off_tble(off_cnt_762).offense_number then         /* if the vicitm offense link = occurense in off tble */
                     if v_off_tble(off_cnt_762).ucr_code in ('35A','35B','39A','39B','39C','39D','40A','40B','40C','370','520','720','90B','90C','90D','90F','90G','90J','90Z','999') THEN
                        if v_vic_tble(vic_cnt_762).victim_type <> 'S' then                /* then the vicitm sex must be M or F */
                           update_status(5, v_vic_tble(vic_cnt_762).adm_id, v_vic_tble(vic_cnt_762).incident_number, 762,v_agency);                      
                        end if;
                     end if;
                  end if;
                end loop inner_762;
            end if;
          end loop outer_762;
         end loop edit_762;
/*768*/  <<edit_768>>
         for vic_cnt_768 in 1..vic_tble_cnt loop                                     /* for each record in the victim table */
           v_vicoff_t(1) := v_vic_tble(vic_cnt_768).victim_offense_link1;                 /*load 1 - 10 occurences of vicitm offense  for each row in cursor vicitm table*/
           v_vicoff_t(2) := v_vic_tble(vic_cnt_768).victim_offense_link2;
           v_vicoff_t(3) := v_vic_tble(vic_cnt_768).victim_offense_link3;
           v_vicoff_t(4) := v_vic_tble(vic_cnt_768).victim_offense_link4;
           v_vicoff_t(5) := v_vic_tble(vic_cnt_768).victim_offense_link5;
           v_vicoff_t(6) := v_vic_tble(vic_cnt_768).victim_offense_link6;
           v_vicoff_t(7) := v_vic_tble(vic_cnt_768).victim_offense_link7;
           v_vicoff_t(8) := v_vic_tble(vic_cnt_768).victim_offense_link8;
           v_vicoff_t(9) := v_vic_tble(vic_cnt_768).victim_offense_link9;
           v_vicoff_t(10) := v_vic_tble(vic_cnt_768).victim_offense_link10;
           <<outer_768>>
           for vic_off_cnt_768 in 1..10 loop                                                  /* for each of 1-10 occurences of victim offense */
             if v_vicoff_t(vic_off_cnt_768) <> '77' then                                      /* if vicitm offense <> '77' */
                 <<inner_768>>
                 for off_cnt_768 in 1..v_off_tble.count loop                              /* then for each offense in v_off_tble */
                   if v_vicoff_t(vic_off_cnt_768) = v_off_tble(off_cnt_768).offense_number then         /* if the vicitm offense link = occurense in off tble */
                      if v_off_tble(off_cnt_768).ucr_code in ('11A', '36B') then          /* if the ucr code for offense is  11a or 36b    */
                         if v_vic_tble(vic_cnt_768).victim_sex in ('M','F') then          /* then the vicitm sex must be M or F */
                            null;
                         else
                             update_status(5, v_vic_tble(vic_cnt_768).adm_id, v_vic_tble(vic_cnt_768).incident_number, 768,v_agency);
                         end if;
                      end if;
                   end if;
                 end loop inner_768;
             end if;
           end loop outer_768;
         end loop edit_768;
/*772*/  <<edit_772>>
         for vic_cnt_772 in 1..vic_tble_cnt loop                                 /* for each record in the vicitm table*/
           v_vicrel_t(1) := v_vic_tble(vic_cnt_772).victim_offender_relationship1;    /* load 1 - 10 occurences of victim offender relation*/
           v_vicrel_t(2) := v_vic_tble(vic_cnt_772).victim_offender_relationship2;
           v_vicrel_t(3) := v_vic_tble(vic_cnt_772).victim_offender_relationship3;
           v_vicrel_t(4) := v_vic_tble(vic_cnt_772).victim_offender_relationship4;
           v_vicrel_t(5) := v_vic_tble(vic_cnt_772).victim_offender_relationship5;
           v_vicrel_t(6) := v_vic_tble(vic_cnt_772).victim_offender_relationship6;
           v_vicrel_t(7) := v_vic_tble(vic_cnt_772).victim_offender_relationship7;
           v_vicrel_t(8) := v_vic_tble(vic_cnt_772).victim_offender_relationship8;
           v_vicrel_t(9) := v_vic_tble(vic_cnt_772).victim_offender_relationship9;
           v_vicrel_t(10) := v_vic_tble(vic_cnt_772).victim_offender_relationship10;
           v_vicofd_t(1) := v_vic_tble(vic_cnt_772).victim_offender_link1;             /*load 1 - 10 occurences of victim offender */
           v_vicofd_t(2) := v_vic_tble(vic_cnt_772).victim_offender_link2;
           v_vicofd_t(3) := v_vic_tble(vic_cnt_772).victim_offender_link3;
           v_vicofd_t(4) := v_vic_tble(vic_cnt_772).victim_offender_link4;
           v_vicofd_t(5) := v_vic_tble(vic_cnt_772).victim_offender_link5;
           v_vicofd_t(6) := v_vic_tble(vic_cnt_772).victim_offender_link6;
           v_vicofd_t(7) := v_vic_tble(vic_cnt_772).victim_offender_link7;
           v_vicofd_t(8) := v_vic_tble(vic_cnt_772).victim_offender_link8;
           v_vicofd_t(9) := v_vic_tble(vic_cnt_772).victim_offender_link9;
           v_vicofd_t(10) := v_vic_tble(vic_cnt_772).victim_offender_link10;
           for vic_rel_cnt_772 in 1..10 loop                                                         /* for each of 1-10 occurences of vicitm relation */
             if v_vicrel_t(vic_rel_cnt_772) in ('01','02','22','29') then                            /* if the relation code is */
                if v_vic_tble(vic_cnt_772).victim_sex = 'F' then                                     /* if the vicitm sex for incident is F */
                   for ofd_cnt_772 in 1..ofd_tble_cnt loop                                           /* then loop thru victim offender table*/
                       if v_vicofd_t(vic_rel_cnt_772) = v_ofd_tble(ofd_cnt_772).offender_number then     /* if victim offender link = offender number */
                          if v_ofd_tble(ofd_cnt_772).offender_sex = 'M' then                         /* the sex must be M */
                             null;
                          else
                             update_status(5, v_vic_tble(vic_cnt_772).adm_id, v_vic_tble(vic_cnt_772).incident_number, 772,v_agency);
                          end if;
                       end if;
                   end loop inner_772;
                end if;
              end if;
           end loop outer_772;
         end loop edit_772;
/*774*/  <<edit_774>>
         for vic_cnt_774 in 1..vic_tble_cnt loop                                          /* for each record in the victim table */
           v_vicrel_t(1) := v_vic_tble(vic_cnt_774).victim_offender_relationship1;         /* load 1 - 10 occurences of victim offender relation*/
           v_vicrel_t(2) := v_vic_tble(vic_cnt_774).victim_offender_relationship2;
           v_vicrel_t(3) := v_vic_tble(vic_cnt_774).victim_offender_relationship3;
           v_vicrel_t(4) := v_vic_tble(vic_cnt_774).victim_offender_relationship4;
           v_vicrel_t(5) := v_vic_tble(vic_cnt_774).victim_offender_relationship5;
           v_vicrel_t(6) := v_vic_tble(vic_cnt_774).victim_offender_relationship6;
           v_vicrel_t(7) := v_vic_tble(vic_cnt_774).victim_offender_relationship7;
           v_vicrel_t(8) := v_vic_tble(vic_cnt_774).victim_offender_relationship8;
           v_vicrel_t(9) := v_vic_tble(vic_cnt_774).victim_offender_relationship9;
           v_vicrel_t(10) := v_vic_tble(vic_cnt_774).victim_offender_relationship10;
           v_vicofd_t(1) := v_vic_tble(vic_cnt_774).victim_offender_link1;                 /*load 1 - 10 occurences of victim offender */
           v_vicofd_t(2) := v_vic_tble(vic_cnt_774).victim_offender_link2;
           v_vicofd_t(3) := v_vic_tble(vic_cnt_774).victim_offender_link3;
           v_vicofd_t(4) := v_vic_tble(vic_cnt_774).victim_offender_link4;
           v_vicofd_t(5) := v_vic_tble(vic_cnt_774).victim_offender_link5;
           v_vicofd_t(6) := v_vic_tble(vic_cnt_774).victim_offender_link6;
           v_vicofd_t(7) := v_vic_tble(vic_cnt_774).victim_offender_link7;
           v_vicofd_t(8) := v_vic_tble(vic_cnt_774).victim_offender_link8;
           v_vicofd_t(9) := v_vic_tble(vic_cnt_774).victim_offender_link9;
           v_vicofd_t(10) := v_vic_tble(vic_cnt_774).victim_offender_link10;
           <<outer_774>>
           for vic_rel_cnt_774 in 1..10 loop                                                   /* for each of 1-10 occurences of victim relation */
            if v_vicrel_t(vic_rel_cnt_774) in ('01', '02', '22', '29') then                    /* if the relation code is */
              if v_vic_tble(vic_cnt_774).victim_sex = 'M' then                                 /* if the vicitm sex for the incident is M */
                 <<inner_774>>
                 for ofd_cnt_774 in 1..ofd_tble_cnt loop                                       /* for each row in the offender cursor table */
                    if v_vicofd_t(vic_rel_cnt_774) = v_ofd_tble(ofd_cnt_774).offender_number then  /* if offender number = vic ofd link for this record */
                       if v_ofd_tble(ofd_cnt_774).offender_sex ='F' then                             /* sex must be F */
                          null;
                       else
                          update_status(5, v_vic_tble(vic_cnt_774).adm_id, v_vic_tble(vic_cnt_774).incident_number, 774,v_agency);
                       end if;
                    end if;
                 end loop inner_774;
              end if;
            end if;
           end loop outer_774;
         end loop edit_774;
/*776*/  <<edit_776>>
         for vic_cnt_776 in 1..vic_tble_cnt loop                                      /* for each record in the victim table */
           v_vicrel_t(1) := v_vic_tble(vic_cnt_776).victim_offender_relationship1;         /* load 1 - 10 occurences of victim offender relation*/
           v_vicrel_t(2) := v_vic_tble(vic_cnt_776).victim_offender_relationship2;
           v_vicrel_t(3) := v_vic_tble(vic_cnt_776).victim_offender_relationship3;
           v_vicrel_t(4) := v_vic_tble(vic_cnt_776).victim_offender_relationship4;
           v_vicrel_t(5) := v_vic_tble(vic_cnt_776).victim_offender_relationship5;
           v_vicrel_t(6) := v_vic_tble(vic_cnt_776).victim_offender_relationship6;
           v_vicrel_t(7) := v_vic_tble(vic_cnt_776).victim_offender_relationship7;
           v_vicrel_t(8) := v_vic_tble(vic_cnt_776).victim_offender_relationship8;
           v_vicrel_t(9) := v_vic_tble(vic_cnt_776).victim_offender_relationship9;
           v_vicrel_t(10) := v_vic_tble(vic_cnt_776).victim_offender_relationship10;
           v_vicofd_t(1) := v_vic_tble(vic_cnt_776).victim_offender_link1;                  /*load 1 - 10 occurences of victim offender */
           v_vicofd_t(2) := v_vic_tble(vic_cnt_776).victim_offender_link2;
           v_vicofd_t(3) := v_vic_tble(vic_cnt_776).victim_offender_link3;
           v_vicofd_t(4) := v_vic_tble(vic_cnt_776).victim_offender_link4;
           v_vicofd_t(5) := v_vic_tble(vic_cnt_776).victim_offender_link5;
           v_vicofd_t(6) := v_vic_tble(vic_cnt_776).victim_offender_link6;
           v_vicofd_t(7) := v_vic_tble(vic_cnt_776).victim_offender_link7;
           v_vicofd_t(8) := v_vic_tble(vic_cnt_776).victim_offender_link8;
           v_vicofd_t(9) := v_vic_tble(vic_cnt_776).victim_offender_link9;
           v_vicofd_t(10) := v_vic_tble(vic_cnt_776).victim_offender_link10;
           for vic_rel_cnt_776 in 1..10 loop                                             /* for each of 1-10 occurences of victim relation */
           if v_vicrel_t(vic_rel_cnt_776) in ('01', '02','29') then                           /* if the relation code is */
              if v_vic_tble(vic_cnt_776).victim_sex = 'M' then                                 /* if the vicitm sex for the incident is M */
                for ofd_cnt_776 in 1..ofd_tble_cnt loop                                       /* for each row in the offender cursor table */
                  if v_vicofd_t(vic_rel_cnt_776) = v_ofd_tble(ofd_cnt_776).offender_number then  /* if offender number = vic ofd link for this record */
                     if (v_ofd_tble(ofd_cnt_776).offender_age = '9999') or
                        (v_ofd_tble(ofd_cnt_776).offender_age > '0010') then
                        null;
                     else
                        update_status(5, v_vic_tble(vic_cnt_776).adm_id, v_vic_tble(vic_cnt_776).incident_number, 776,v_agency);
                     end if;
                  end if;
                end loop inner_776;
              end if;
            end if;
           end loop outer_776;
         end loop edit_776;
/*778*/
        for vic_cnt_778 in 1..vic_tble_cnt loop                                          /* for each record in the victim table */
         v_vicrel_t(1) := v_vic_tble(vic_cnt_778).victim_offender_relationship1;         /* load 1 - 10 occurences of victim offender relation*/
         v_vicrel_t(2) := v_vic_tble(vic_cnt_778).victim_offender_relationship2;
         v_vicrel_t(3) := v_vic_tble(vic_cnt_778).victim_offender_relationship3;
         v_vicrel_t(4) := v_vic_tble(vic_cnt_778).victim_offender_relationship4;
         v_vicrel_t(5) := v_vic_tble(vic_cnt_778).victim_offender_relationship5;
         v_vicrel_t(6) := v_vic_tble(vic_cnt_778).victim_offender_relationship6;
         v_vicrel_t(7) := v_vic_tble(vic_cnt_778).victim_offender_relationship7;
         v_vicrel_t(8) := v_vic_tble(vic_cnt_778).victim_offender_relationship8;
         v_vicrel_t(9) := v_vic_tble(vic_cnt_778).victim_offender_relationship9;
         v_vicrel_t(10) := v_vic_tble(vic_cnt_778).victim_offender_relationship10;
         v_vicofd_t(1) := v_vic_tble(vic_cnt_778).victim_offender_link1;                  /*load 1 - 10 occurences of victim offender */
         v_vicofd_t(2) := v_vic_tble(vic_cnt_778).victim_offender_link2;
         v_vicofd_t(3) := v_vic_tble(vic_cnt_778).victim_offender_link3;
         v_vicofd_t(4) := v_vic_tble(vic_cnt_778).victim_offender_link4;
         v_vicofd_t(5) := v_vic_tble(vic_cnt_778).victim_offender_link5;
         v_vicofd_t(6) := v_vic_tble(vic_cnt_778).victim_offender_link6;
         v_vicofd_t(7) := v_vic_tble(vic_cnt_778).victim_offender_link7;
         v_vicofd_t(8) := v_vic_tble(vic_cnt_778).victim_offender_link8;
         v_vicofd_t(9) := v_vic_tble(vic_cnt_778).victim_offender_link9;
         v_vicofd_t(10) := v_vic_tble(vic_cnt_778).victim_offender_link10;
         for vic_rel_cnt_778 in 1..10 loop                                                     /* for each of 1-10 occurences of victim relation */
          if v_vicrel_t(vic_rel_cnt_778) = '27' then                                           /* if the relation code is */
             for ofd_cnt_778 in 1..ofd_tble_cnt loop                                           /* for each row in the offender cursor table */
                  if v_vicofd_t(vic_rel_cnt_778) = v_ofd_tble(ofd_cnt_778).offender_number then          /* if offender number = vic ofd link for this record */
                     if v_ofd_tble(ofd_cnt_778).offender_sex = v_vic_tble(vic_cnt_778).victim_sex then   /* victim and offender sex must be the same*/
                        null;
                     else
                        update_status(5, v_vic_tble(vic_cnt_778).adm_id, v_vic_tble(vic_cnt_778).incident_number, 778,v_agency);                                                         /* set flag to true */
                     end if;
                  end if;
              end loop;
          end if;
         end loop;
        end loop;
/*780*/
        for vic_cnt_780 in 1..vic_tble_cnt loop                                      /* for each record in the victim table */
         v_vicrel_t(1) := v_vic_tble(vic_cnt_780).victim_offender_relationship1;         /* load 1 - 10 occurences of victim offender relation*/
         v_vicrel_t(2) := v_vic_tble(vic_cnt_780).victim_offender_relationship2;
         v_vicrel_t(3) := v_vic_tble(vic_cnt_780).victim_offender_relationship3;
         v_vicrel_t(4) := v_vic_tble(vic_cnt_780).victim_offender_relationship4;
         v_vicrel_t(5) := v_vic_tble(vic_cnt_780).victim_offender_relationship5;
         v_vicrel_t(6) := v_vic_tble(vic_cnt_780).victim_offender_relationship6;
         v_vicrel_t(7) := v_vic_tble(vic_cnt_780).victim_offender_relationship7;
         v_vicrel_t(8) := v_vic_tble(vic_cnt_780).victim_offender_relationship8;
         v_vicrel_t(9) := v_vic_tble(vic_cnt_780).victim_offender_relationship9;
         v_vicrel_t(10) := v_vic_tble(vic_cnt_780).victim_offender_relationship10;
         v_vicofd_t(1) := v_vic_tble(vic_cnt_780).victim_offender_link1;                  /*load 1 - 10 occurences of victim offender */
         v_vicofd_t(2) := v_vic_tble(vic_cnt_780).victim_offender_link2;
         v_vicofd_t(3) := v_vic_tble(vic_cnt_780).victim_offender_link3;
         v_vicofd_t(4) := v_vic_tble(vic_cnt_780).victim_offender_link4;
         v_vicofd_t(5) := v_vic_tble(vic_cnt_780).victim_offender_link5;
         v_vicofd_t(6) := v_vic_tble(vic_cnt_780).victim_offender_link6;
         v_vicofd_t(7) := v_vic_tble(vic_cnt_780).victim_offender_link7;
         v_vicofd_t(8) := v_vic_tble(vic_cnt_780).victim_offender_link8;
         v_vicofd_t(9) := v_vic_tble(vic_cnt_780).victim_offender_link9;
         v_vicofd_t(10) := v_vic_tble(vic_cnt_780).victim_offender_link10;
         for vic_rel_cnt_780 in 1..10 loop                                                   /* for each of 1-10 occurences of victim relation */
          if v_vicrel_t(vic_rel_cnt_780) in ('03','06') then                                 /* if the relation code is */
             for ofd_cnt_780 in 1..ofd_tble_cnt loop                                 /* for each row in the offender cursor table */
                  if v_vicofd_t(vic_rel_cnt_780) = v_ofd_tble(ofd_cnt_780).offender_number then        /* if offender number = vic ofd link for this record */
                     if v_vic_tble(vic_cnt_780).victim_age = '9999' then                 /* if age is unknown, set to true we do not care*/
                        null;
                     elsif v_vic_tble(vic_cnt_780).victim_age in ('00NN','00NB') then    /* if age is newborn treat it as age 1*/
                            if v_ofd_tble(ofd_cnt_780).offender_age < '0001' then        /* if offender age LT the victim, true*/
                               null;
                            end if;
                     elsif v_ofd_tble(ofd_cnt_780).offender_age > v_vic_tble(vic_cnt_780).victim_age then    /* if victim Age GT offender age*/
                           update_status(5, v_vic_tble(vic_cnt_780).adm_id, v_vic_tble(vic_cnt_780).incident_number, 780,v_agency);
                     else
                         null;     /* if not found*/
                     end if;
                  end if;
              end loop;
          end if;
         end loop;
        end loop;
/*782*/
        for vic_cnt_782 in 1..vic_tble_cnt loop                                      /* for each record in the victim table */
         v_vicrel_t(1) := v_vic_tble(vic_cnt_782).victim_offender_relationship1;         /* load 1 - 10 occurences of victim offender relation*/
         v_vicrel_t(2) := v_vic_tble(vic_cnt_782).victim_offender_relationship2;
         v_vicrel_t(3) := v_vic_tble(vic_cnt_782).victim_offender_relationship3;
         v_vicrel_t(4) := v_vic_tble(vic_cnt_782).victim_offender_relationship4;
         v_vicrel_t(5) := v_vic_tble(vic_cnt_782).victim_offender_relationship5;
         v_vicrel_t(6) := v_vic_tble(vic_cnt_782).victim_offender_relationship6;
         v_vicrel_t(7) := v_vic_tble(vic_cnt_782).victim_offender_relationship7;
         v_vicrel_t(8) := v_vic_tble(vic_cnt_782).victim_offender_relationship8;
         v_vicrel_t(9) := v_vic_tble(vic_cnt_782).victim_offender_relationship9;
         v_vicrel_t(10) := v_vic_tble(vic_cnt_782).victim_offender_relationship10;
         v_vicofd_t(1) := v_vic_tble(vic_cnt_782).victim_offender_link1;                  /*load 1 - 10 occurences of victim offender */
         v_vicofd_t(2) := v_vic_tble(vic_cnt_782).victim_offender_link2;
         v_vicofd_t(3) := v_vic_tble(vic_cnt_782).victim_offender_link3;
         v_vicofd_t(4) := v_vic_tble(vic_cnt_782).victim_offender_link4;
         v_vicofd_t(5) := v_vic_tble(vic_cnt_782).victim_offender_link5;
         v_vicofd_t(6) := v_vic_tble(vic_cnt_782).victim_offender_link6;
         v_vicofd_t(7) := v_vic_tble(vic_cnt_782).victim_offender_link7;
         v_vicofd_t(8) := v_vic_tble(vic_cnt_782).victim_offender_link8;
         v_vicofd_t(9) := v_vic_tble(vic_cnt_782).victim_offender_link9;
         v_vicofd_t(10) := v_vic_tble(vic_cnt_782).victim_offender_link10;
         for vic_rel_cnt_782 in 1..10 loop                                                   /* for each of 1-10 occurences of victim relation */
          if v_vicrel_t(vic_rel_cnt_782) in ('05','07') then                                 /* if the relation code is */
             for ofd_cnt_782 in 1..ofd_tble_cnt loop                                         /* for each row in the offender cursor table */
                  if v_vicofd_t(vic_rel_cnt_782) = v_ofd_tble(ofd_cnt_782).offender_number then        /* if offender number = vic ofd link for this record */
                     if v_vic_tble(vic_cnt_782).victim_age = '9999' then
                       null;
                     elsif v_vic_tble(vic_cnt_782).victim_age in ('00NN','00NB','00BB') then    /* if victimage newborn  treat as 1*/
                            if v_ofd_tble(ofd_cnt_782).offender_age > '0001' then        /* if offender_age*/
                               null;
                            end if;
                     elsif v_ofd_tble(ofd_cnt_782).offender_age > v_vic_tble(vic_cnt_782).victim_age then /* if offender age GT victim*/
                           null;
                     else
                         update_status(5, v_vic_tble(vic_cnt_782).adm_id, v_vic_tble(vic_cnt_782).incident_number, 782,v_agency);
                     end if;
                  end if;
              end loop;
          end if;
         end loop;
        end loop;
/*784*/
-- Added by CI 08/28/2001 for bug no 44
<<victim_count>>
--dbms_output.put_line('Begin 784 init vfound and vcount');
v_found := 0;
v_count := 0;
for vic_cnt_784 in 1..vic_tble_cnt loop
--dbms_output.put_line('Begin 784 inside loop victim count init vfound and vcount');
v_found :=0;
v_count := 0;
   v_vicoff_t(1) := v_vic_tble(vic_cnt_784).victim_offense_link1;
   v_vicoff_t(2) := v_vic_tble(vic_cnt_784).victim_offense_link2;
   v_vicoff_t(3) := v_vic_tble(vic_cnt_784).victim_offense_link3;
   v_vicoff_t(4) := v_vic_tble(vic_cnt_784).victim_offense_link4;
   v_vicoff_t(5) := v_vic_tble(vic_cnt_784).victim_offense_link5;
   v_vicoff_t(6) := v_vic_tble(vic_cnt_784).victim_offense_link6;
   v_vicoff_t(7) := v_vic_tble(vic_cnt_784).victim_offense_link7;
   v_vicoff_t(8) := v_vic_tble(vic_cnt_784).victim_offense_link8;
   v_vicoff_t(9) := v_vic_tble(vic_cnt_784).victim_offense_link9;
   v_vicoff_t(10) := v_vic_tble(vic_cnt_784).victim_offense_link10;
--dbms_output.put_line('10 link values entered');
   for vic_link_cnt in 1..10 loop
     if v_vicoff_t(vic_link_cnt) <> '77' then
        for off_link_cnt in 1..off_tble_cnt loop
           if v_vicoff_t(vic_link_cnt) = v_off_tble(off_link_cnt).offense_number then
              if v_off_tble(off_link_cnt).ucr_code in ('13A','13B','13C','09A','09B','09C','11A','11B','11C','11D','100','36A','36B','90F','210','120') then
		 v_count := v_count + 1;
              end if;
    	   end if;
        end loop;
      end if;
   end loop;
--dbms_output.put_line('v_ Count is ' || v_count);
if v_count = 1 then
   <<off_link_count>>
   for vic_off_cnt_784 in 1..10 loop
           if v_vicoff_t(vic_off_cnt_784) <> '77' then
              for off_cnt_784 in 1..off_tble_cnt loop
		  if v_vicoff_t(vic_off_cnt_784) = v_off_tble(off_cnt_784).offense_number then
                     if v_off_tble(off_cnt_784).ucr_code = '13B' then
--dbms_output.put_line('13B check');
                       for off_cnt_784_inner in 1..off_tble_cnt loop
                           if v_off_tble(off_cnt_784_inner).ucr_code <> '13B' then
if v_off_tble(off_cnt_784_inner).ucr_code not in ('13A','13B','13C','09A','09B','09C','11A','11B','11C','11D','100','36A','36B','90F','210','120') then
                                 if v_vic_tble(vic_cnt_784).level_of_injury in ('1', '2', '7') then
--dbms_output.put_line('Inj level check');
                                    v_found := 1;
                                    exit off_link_count;
                                 end if;
                               end if;
                            end if;
                       end loop;
                     end if;
                  end if;
	      end loop;
            end if;
   end loop off_link_count;
end if;
   if v_found = 1 then
      update_status(5, v_vic_tble(vic_cnt_784).adm_id, v_vic_tble(vic_cnt_784).incident_number, 784 ,v_agency);  -- then error
   end if;
end loop victim_count;
-- END CI
/* 786 */
-- Added by CI 08/28/2001 for bug no 34
<<victim_count>>
v_found := 0;
v_count := 0;
for vic_cnt_786 in 1..vic_tble_cnt loop
v_found :=0;
v_count := 0;
   v_vicoff_t(1) := v_vic_tble(vic_cnt_786).victim_offense_link1;
   v_vicoff_t(2) := v_vic_tble(vic_cnt_786).victim_offense_link2;
   v_vicoff_t(3) := v_vic_tble(vic_cnt_786).victim_offense_link3;
   v_vicoff_t(4) := v_vic_tble(vic_cnt_786).victim_offense_link4;
   v_vicoff_t(5) := v_vic_tble(vic_cnt_786).victim_offense_link5;
   v_vicoff_t(6) := v_vic_tble(vic_cnt_786).victim_offense_link6;
   v_vicoff_t(7) := v_vic_tble(vic_cnt_786).victim_offense_link7;
   v_vicoff_t(8) := v_vic_tble(vic_cnt_786).victim_offense_link8;
   v_vicoff_t(9) := v_vic_tble(vic_cnt_786).victim_offense_link9;
   v_vicoff_t(10) := v_vic_tble(vic_cnt_786).victim_offense_link10;
   for vic_link_cnt in 1..10 loop
     if v_vicoff_t(vic_link_cnt) <> '77' then
        for off_link_cnt in 1..off_tble_cnt loop
           if v_vicoff_t(vic_link_cnt) = v_off_tble(off_link_cnt).offense_number then
              if v_off_tble(off_link_cnt).ucr_code in ('210','120') then
		 v_count := v_count + 1;
              end if;
    	   end if;
        end loop;
      end if;
   end loop;
if v_count = 0 then
   <<off_link_count>>
   for vic_off_cnt_786 in 1..10 loop
           if v_vicoff_t(vic_off_cnt_786) <> '77' then
              for off_cnt_786 in 1..off_tble_cnt loop
		  if v_vicoff_t(vic_off_cnt_786) = v_off_tble(off_cnt_786).offense_number then
                     if v_off_tble(off_cnt_786).ucr_code = '13B' then
                       for off_cnt_786_inner in 1..off_tble_cnt loop
                           if v_off_tble(off_cnt_786_inner).ucr_code = '13B' then
                              if v_off_tble(off_cnt_786_inner).ucr_code in ('13A','13B','13C','09A','09B','09C','11A','11B','11C','11D','100','36A','36B','90F','210','120') then
                                 if v_vic_tble(vic_cnt_786).type_of_injury1 not in ('00','01','02','03','04','05','07') then
                                    v_found := 1;
                                    exit off_link_count;
                                 end if;
                              end if;
                           end if;
                       end loop;
                     end if;
                  end if;
	      end loop;
            end if;
   end loop off_link_count;
end if;
   if v_found = 1 then
      update_status(5, v_vic_tble(vic_cnt_786).adm_id, v_vic_tble(vic_cnt_786).incident_number, 786 ,v_agency);  -- then error
   end if;
end loop victim_count;
-- END CI
     END;
    CLOSE VICTIM_CURSOR;
/* arrestee processing*/
      arrestee_tble_cnt := 0;
      OPEN ARRESTEE_CURSOR;
      LOOP
       FETCH ARRESTEE_CURSOR into v_arrestee_rec;
        EXIT WHEN ARRESTEE_CURSOR%notfound;
       BEGIN
        arrestee_tble_cnt := arrestee_tble_cnt + 1;
        v_arrestee_tble(arrestee_tble_cnt) := v_arrestee_rec;
        v_arrestee_tble(arrestee_tble_cnt).arrestee_number := v_arrestee_rec.arrestee_number;
     --   dbms_output.put_line('arte'||v_adm_rec.incident_number);
/*600*/
       if v_adm_rec.segment_action not in ('I', 'R', 'A', 'W', 'U') then
          update_status(6, v_arrestee_rec.adm_id, v_arrestee_rec.incident_number, 600,v_agency);
        end if;
/*617*/
       if v_arrestee_rec.segment_type <> '6' then
          update_status(6, v_arrestee_rec.adm_id, v_arrestee_rec.incident_number, 617,v_agency);
       end if;
       Select count(*) into v_rec_cnt from ibr_arrest_charge_segment
         where incident_number = v_arrestee_rec.incident_number
	       and adm_id = v_arrestee_rec.adm_id;
/*658*/
/*
         if v_rec_cnt > 16 then
            update_status(6, v_arrestee_rec.adm_id, v_arrestee_rec.incident_number, 658,v_agency);
         end if;
*/
/*650*/
         if v_adm_rec.incident_case_status between '10' and '14' then
            if v_rec_cnt > 1 then
               update_status(6, v_arrestee_rec.adm_id, v_arrestee_rec.incident_number, 650 ,v_agency);
             end if;
         end if;
/*788*/
         If v_arrestee_rec.segment_action in ('I', 'R') then
            if v_arrestee_rec.arrest_date < v_adm_rec.incident_report_date then
               update_status(6, v_arrestee_rec.adm_id, v_arrestee_rec.incident_number, 788,v_agency);
            end if;
         end if;
/*652*/
         if v_adm_rec.segment_action <> 'D' then
           if v_adm_rec.incident_case_status in ('01', '02') then
              if v_rec_cnt < 1 then
                 update_status(6, v_arrestee_rec.adm_id, v_arrestee_rec.incident_number, 652,v_agency);
              end if;
           end if;
         end if;
/*653*/
         if v_adm_rec.incident_case_status = '14' then
          <<outer_loop>>
            for ofd_cnt in 1..ofd_tble_cnt loop
                if v_ofd_tble(ofd_cnt).offender_age < '0016' then
                   v_found := 1;
                   exit outer_loop;
                end if;
            end loop;
            if v_found <> 1 then
               update_status(6, v_arrestee_rec.adm_id, v_arrestee_rec.incident_number, 653,v_agency);
            end if;
         end if;
      END;
     END LOOP;
                                   /*after rows loaded into pl/table*/
/*648*/
      BEGIN
      if arrestee_tble_cnt > 1 then
        For arrestee_cnt_648 in 1..arrestee_tble_cnt loop
          if arrestee_cnt_648 <> arrestee_tble_cnt then
            if v_arrestee_tble(arrestee_cnt_648).arrestee_number = v_arrestee_tble(arrestee_cnt_648 + 1).arrestee_number then
               update_status(6, v_arrestee_tble(arrestee_cnt_648).adm_id, v_arrestee_tble(arrestee_cnt_648).incident_number, 648,v_agency);
            end if;
          end if;
        end loop;
      end if;
      END;
/*654*/
      if arrestee_tble_cnt > 99 then
         update_status(6, v_arrestee_tble(1).adm_id, v_arrestee_tble(1).incident_number, 654 ,v_agency);
      end if;
/*792*/
-- Added by CI 08/28/2001 bug no 48 bug no 46
      if v_adm_rec.incident_case_status = '02' then
        BEGIN
          Select count(*)into v_rec_cnt from ibr_arrestee_segment
           where adm_id = v_adm_rec.adm_id
             and incident_number = v_adm_rec.incident_number
             and arrestee_age < '16';
          if v_rec_cnt < 1 then
             update_status(1, v_adm_rec.adm_id, v_adm_rec.incident_number, 792,v_agency);
          end if;
        END;
      end if;
-- End CI 08/28/2001 bug no 48 bug no 46
      CLOSE ARRESTEE_CURSOR;
/* arrest processing*/
      arrest_tble_cnt := 0;
      OPEN ARREST_CURSOR;
      LOOP
       FETCH ARREST_CURSOR into v_arrest_rec;
       EXIT WHEN ARREST_CURSOR%notfound;
       BEGIN
        arrest_tble_cnt := arrest_tble_cnt + 1;
      --  dbms_output.put_line('artchg'||v_adm_rec.incident_number);
/*600*/
        if v_adm_rec.segment_action not in ('I', 'R', 'A', 'W', 'U') then
           update_status(7, v_arrest_rec.adm_id, v_arrest_rec.incident_number, 600,v_agency);
        end if;
/*617*/
        if v_arrest_rec.segment_type <> '7' then
           update_status(1, v_arrest_rec.adm_id, v_arrest_rec.incident_number, 617,v_agency);
        end if;
        select count(*) into v_rec_cnt from ibr_arrestee_segment
         where arrestee_number = v_arrest_rec.arrestee_charge_link
	      and incident_number = v_arrest_rec.incident_number
	      and adm_id = v_arrest_rec.adm_id;
/*660 662*/
        if v_rec_cnt < 1 then
           update_status(7, v_arrest_rec.adm_id, v_arrest_rec.incident_number, 662 ,v_agency);
    	   update_status(7, v_arrest_rec.adm_id, v_arrest_rec.incident_number, 660 ,v_agency);
    	end if;
      END;
     END LOOP;
     CLOSE ARREST_CURSOR;
   END;                      /*ADM For begin*/
 END loop;                  /*adm cursor loop*/
 CLOSE ADM_CURSOR;
/* segment check*  some segment might not be recognized because they have been marked in error*/
BEGIN
OPEN adm_cursor;
  LOOP
   FETCH adm_cursor into v_adm_rec;
     EXIT when adm_cursor%notfound;
     if v_adm_rec.segment_action in ('I', 'R') then
        BEGIN
          v_row_cnt := 0;
          for v_off_rec in offense_cursor loop
             v_row_cnt := offense_cursor%rowcount;
          end loop;
         -- dbms_output.put_line(v_adm_rec.incident_number||' '||v_row_cnt);
          if v_row_cnt = 0 then
           update_status(1, v_adm_rec.adm_id, v_adm_rec.incident_number, 620,v_agency);
          end if;
          v_row_cnt := 0;
          for v_ofd_rec in offender_cursor loop
            v_row_cnt := offender_cursor%rowcount;
          end loop;
        --  dbms_output.put_line(v_adm_rec.incident_number||' '||v_row_cnt);
          if v_row_cnt = 0 then
           update_status(1, v_adm_rec.adm_id, v_adm_rec.incident_number, 634,v_agency);
          end if;
        --  dbms_output.put_line(v_adm_rec.incident_number||' '||v_row_cnt);
          v_row_cnt := 0;
          for v_vic_rec in victim_cursor loop
            v_row_cnt := victim_cursor%rowcount;
          end loop;
         -- dbms_output.put_line(v_adm_rec.incident_number||' '||v_row_cnt);
          if v_row_cnt = 0 then
           update_status(1, v_adm_rec.adm_id, v_adm_rec.incident_number, 642,v_agency);
          end if;
          v_row_cnt := 0;
          for v_arrestee_rec in arrestee_cursor loop
            for v_arrest_rec in arrest_cursor loop
                v_row_cnt:= arrest_cursor%rowcount;
            end loop;
            if v_row_cnt = 0 then
                update_status(1, v_adm_rec.adm_id, v_adm_rec.incident_number, 672,v_agency);
            end if;
          end loop;
        END;
     end if;
     if v_adm_rec.segment_action = 'A' then
       BEGIN
        v_row_cnt := 0;
         for v_arrestee_rec in arrestee_cursor loop
            for v_arrest_rec in arrest_cursor loop
                v_row_cnt:= arrest_cursor%rowcount;
            end loop;
            if v_row_cnt = 0 then
                update_status(1, v_adm_rec.adm_id, v_adm_rec.incident_number, 664,v_agency);
            end if;
          end loop;
       END;
     end if;
  END LOOP;
CLOSE adm_cursor;
END;                        /*outmost begin*/
Commit;
end;
END IBR_EDITS2;
/